; For assembly by NASM only
bits 32

; Theory of operation

; EDI=General purpose
; ESI=Program counter + base address
; EBP=mz80Base
; AX=AF
; BX=HL
; CX=BC
; DX=General purpose

; Using stack calling conventions
; Extended input/output instructions treat (C) as I/O address


		section	.data

times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

		global	_mz80contextBegin
_mz80contextBegin:
		global	_z80pc
		global	_z80nmiAddr
		global	_z80intAddr

; DO NOT CHANGE THE ORDER OF AF, BC, DE, HL and THE PRIME REGISTERS!

_z80Base	dd	0	; Base address for Z80 stuff
_z80MemRead	dd	0	; Offset of memory read structure array
_z80MemWrite	dd	0	; Offset of memory write structure array
_z80IoRead	dd	0	; Base address for I/O reads list
_z80IoWrite	dd	0	; Base address for I/O write list
_z80clockticks	dd	0	; # Of clock tips that have elapsed
_z80inInterrupt	dd	0	; Non-zero if we're in an interrupt
_z80interruptMode dd	0	; Interrupt mode
_z80interruptState	dd	0	; What state is our interrupt in?
_z80halted	dd	0	; 0=Not halted, 1=Halted
_z80af		dw	0	; A Flag & Flags
_z80bc		dw	0	; BC
_z80de		dw	0	; DE
_z80hl		dw	0	; HL
_z80afprime	dw	0	; A Flag & Flags prime
_z80bcprime	dw	0	; BC prime
_z80deprime	dw	0	; DE prime
_z80hlprime	dw	0	; HL prime

; The order of the following registers can be changed without adverse
; effect. Keep the WORD and DWORDs on boundaries of two for faster access

_z80ix		dw	0	; IX
_z80iy		dw	0	; IY
_z80sp		dw	0	; Stack pointer
_z80pc		dw	0	; PC
_z80nmiAddr	dw	0	; Address to jump to for NMI
_z80intAddr	dw	0	; Address to jump to for INT
_z80i		db	0	; I register
_z80r		db	0	; R register

_mz80contextEnd:

times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

dwElapsedTicks	dd	0	; # Of ticks elapsed
cyclesRemaining	dd	0	; # Of cycles remaining
_orgval	dw	0	; Scratch area
_orgval2	dw	0	; Scratch area
_wordval	dw	0	; Scratch area
_baseFixup	dd	0	; Our base fixup for when we're out of time


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

z80regular:
		dd	RegInst00
		dd	RegInst01
		dd	RegInst02
		dd	RegInst03
		dd	RegInst04
		dd	RegInst05
		dd	RegInst06
		dd	RegInst07
		dd	RegInst08
		dd	RegInst09
		dd	RegInst0a
		dd	RegInst0b
		dd	RegInst0c
		dd	RegInst0d
		dd	RegInst0e
		dd	RegInst0f
		dd	RegInst10
		dd	RegInst11
		dd	RegInst12
		dd	RegInst13
		dd	RegInst14
		dd	RegInst15
		dd	RegInst16
		dd	RegInst17
		dd	RegInst18
		dd	RegInst19
		dd	RegInst1a
		dd	RegInst1b
		dd	RegInst1c
		dd	RegInst1d
		dd	RegInst1e
		dd	RegInst1f
		dd	RegInst20
		dd	RegInst21
		dd	RegInst22
		dd	RegInst23
		dd	RegInst24
		dd	RegInst25
		dd	RegInst26
		dd	RegInst27
		dd	RegInst28
		dd	RegInst29
		dd	RegInst2a
		dd	RegInst2b
		dd	RegInst2c
		dd	RegInst2d
		dd	RegInst2e
		dd	RegInst2f
		dd	RegInst30
		dd	RegInst31
		dd	RegInst32
		dd	RegInst33
		dd	RegInst34
		dd	RegInst35
		dd	RegInst36
		dd	RegInst37
		dd	RegInst38
		dd	RegInst39
		dd	RegInst3a
		dd	RegInst3b
		dd	RegInst3c
		dd	RegInst3d
		dd	RegInst3e
		dd	RegInst3f
		dd	RegInst40
		dd	RegInst41
		dd	RegInst42
		dd	RegInst43
		dd	RegInst44
		dd	RegInst45
		dd	RegInst46
		dd	RegInst47
		dd	RegInst48
		dd	RegInst49
		dd	RegInst4a
		dd	RegInst4b
		dd	RegInst4c
		dd	RegInst4d
		dd	RegInst4e
		dd	RegInst4f
		dd	RegInst50
		dd	RegInst51
		dd	RegInst52
		dd	RegInst53
		dd	RegInst54
		dd	RegInst55
		dd	RegInst56
		dd	RegInst57
		dd	RegInst58
		dd	RegInst59
		dd	RegInst5a
		dd	RegInst5b
		dd	RegInst5c
		dd	RegInst5d
		dd	RegInst5e
		dd	RegInst5f
		dd	RegInst60
		dd	RegInst61
		dd	RegInst62
		dd	RegInst63
		dd	RegInst64
		dd	RegInst65
		dd	RegInst66
		dd	RegInst67
		dd	RegInst68
		dd	RegInst69
		dd	RegInst6a
		dd	RegInst6b
		dd	RegInst6c
		dd	RegInst6d
		dd	RegInst6e
		dd	RegInst6f
		dd	RegInst70
		dd	RegInst71
		dd	RegInst72
		dd	RegInst73
		dd	RegInst74
		dd	RegInst75
		dd	RegInst76
		dd	RegInst77
		dd	RegInst78
		dd	RegInst79
		dd	RegInst7a
		dd	RegInst7b
		dd	RegInst7c
		dd	RegInst7d
		dd	RegInst7e
		dd	RegInst7f
		dd	RegInst80
		dd	RegInst81
		dd	RegInst82
		dd	RegInst83
		dd	RegInst84
		dd	RegInst85
		dd	RegInst86
		dd	RegInst87
		dd	RegInst88
		dd	RegInst89
		dd	RegInst8a
		dd	RegInst8b
		dd	RegInst8c
		dd	RegInst8d
		dd	RegInst8e
		dd	RegInst8f
		dd	RegInst90
		dd	RegInst91
		dd	RegInst92
		dd	RegInst93
		dd	RegInst94
		dd	RegInst95
		dd	RegInst96
		dd	RegInst97
		dd	RegInst98
		dd	RegInst99
		dd	RegInst9a
		dd	RegInst9b
		dd	RegInst9c
		dd	RegInst9d
		dd	RegInst9e
		dd	RegInst9f
		dd	RegInsta0
		dd	RegInsta1
		dd	RegInsta2
		dd	RegInsta3
		dd	RegInsta4
		dd	RegInsta5
		dd	RegInsta6
		dd	RegInsta7
		dd	RegInsta8
		dd	RegInsta9
		dd	RegInstaa
		dd	RegInstab
		dd	RegInstac
		dd	RegInstad
		dd	RegInstae
		dd	RegInstaf
		dd	RegInstb0
		dd	RegInstb1
		dd	RegInstb2
		dd	RegInstb3
		dd	RegInstb4
		dd	RegInstb5
		dd	RegInstb6
		dd	RegInstb7
		dd	RegInstb8
		dd	RegInstb9
		dd	RegInstba
		dd	RegInstbb
		dd	RegInstbc
		dd	RegInstbd
		dd	RegInstbe
		dd	RegInstbf
		dd	RegInstc0
		dd	RegInstc1
		dd	RegInstc2
		dd	RegInstc3
		dd	RegInstc4
		dd	RegInstc5
		dd	RegInstc6
		dd	RegInstc7
		dd	RegInstc8
		dd	RegInstc9
		dd	RegInstca
		dd	RegInstcb
		dd	RegInstcc
		dd	RegInstcd
		dd	RegInstce
		dd	RegInstcf
		dd	RegInstd0
		dd	RegInstd1
		dd	RegInstd2
		dd	RegInstd3
		dd	RegInstd4
		dd	RegInstd5
		dd	RegInstd6
		dd	RegInstd7
		dd	RegInstd8
		dd	RegInstd9
		dd	RegInstda
		dd	RegInstdb
		dd	RegInstdc
		dd	RegInstdd
		dd	RegInstde
		dd	RegInstdf
		dd	RegInste0
		dd	RegInste1
		dd	RegInste2
		dd	RegInste3
		dd	RegInste4
		dd	RegInste5
		dd	RegInste6
		dd	RegInste7
		dd	RegInste8
		dd	RegInste9
		dd	RegInstea
		dd	RegInsteb
		dd	RegInstec
		dd	RegInsted
		dd	RegInstee
		dd	RegInstef
		dd	RegInstf0
		dd	RegInstf1
		dd	RegInstf2
		dd	RegInstf3
		dd	RegInstf4
		dd	RegInstf5
		dd	RegInstf6
		dd	RegInstf7
		dd	RegInstf8
		dd	RegInstf9
		dd	RegInstfa
		dd	RegInstfb
		dd	RegInstfc
		dd	RegInstfd
		dd	RegInstfe
		dd	RegInstff

z80PrefixCB:
		dd	CBInst00
		dd	CBInst01
		dd	CBInst02
		dd	CBInst03
		dd	CBInst04
		dd	CBInst05
		dd	CBInst06
		dd	CBInst07
		dd	CBInst08
		dd	CBInst09
		dd	CBInst0a
		dd	CBInst0b
		dd	CBInst0c
		dd	CBInst0d
		dd	CBInst0e
		dd	CBInst0f
		dd	CBInst10
		dd	CBInst11
		dd	CBInst12
		dd	CBInst13
		dd	CBInst14
		dd	CBInst15
		dd	CBInst16
		dd	CBInst17
		dd	CBInst18
		dd	CBInst19
		dd	CBInst1a
		dd	CBInst1b
		dd	CBInst1c
		dd	CBInst1d
		dd	CBInst1e
		dd	CBInst1f
		dd	CBInst20
		dd	CBInst21
		dd	CBInst22
		dd	CBInst23
		dd	CBInst24
		dd	CBInst25
		dd	CBInst26
		dd	CBInst27
		dd	CBInst28
		dd	CBInst29
		dd	CBInst2a
		dd	CBInst2b
		dd	CBInst2c
		dd	CBInst2d
		dd	CBInst2e
		dd	CBInst2f
		dd	CBInst30
		dd	CBInst31
		dd	CBInst32
		dd	CBInst33
		dd	CBInst34
		dd	CBInst35
		dd	CBInst36
		dd	CBInst37
		dd	CBInst38
		dd	CBInst39
		dd	CBInst3a
		dd	CBInst3b
		dd	CBInst3c
		dd	CBInst3d
		dd	CBInst3e
		dd	CBInst3f
		dd	CBInst40
		dd	CBInst41
		dd	CBInst42
		dd	CBInst43
		dd	CBInst44
		dd	CBInst45
		dd	CBInst46
		dd	CBInst47
		dd	CBInst48
		dd	CBInst49
		dd	CBInst4a
		dd	CBInst4b
		dd	CBInst4c
		dd	CBInst4d
		dd	CBInst4e
		dd	CBInst4f
		dd	CBInst50
		dd	CBInst51
		dd	CBInst52
		dd	CBInst53
		dd	CBInst54
		dd	CBInst55
		dd	CBInst56
		dd	CBInst57
		dd	CBInst58
		dd	CBInst59
		dd	CBInst5a
		dd	CBInst5b
		dd	CBInst5c
		dd	CBInst5d
		dd	CBInst5e
		dd	CBInst5f
		dd	CBInst60
		dd	CBInst61
		dd	CBInst62
		dd	CBInst63
		dd	CBInst64
		dd	CBInst65
		dd	CBInst66
		dd	CBInst67
		dd	CBInst68
		dd	CBInst69
		dd	CBInst6a
		dd	CBInst6b
		dd	CBInst6c
		dd	CBInst6d
		dd	CBInst6e
		dd	CBInst6f
		dd	CBInst70
		dd	CBInst71
		dd	CBInst72
		dd	CBInst73
		dd	CBInst74
		dd	CBInst75
		dd	CBInst76
		dd	CBInst77
		dd	CBInst78
		dd	CBInst79
		dd	CBInst7a
		dd	CBInst7b
		dd	CBInst7c
		dd	CBInst7d
		dd	CBInst7e
		dd	CBInst7f
		dd	CBInst80
		dd	CBInst81
		dd	CBInst82
		dd	CBInst83
		dd	CBInst84
		dd	CBInst85
		dd	CBInst86
		dd	CBInst87
		dd	CBInst88
		dd	CBInst89
		dd	CBInst8a
		dd	CBInst8b
		dd	CBInst8c
		dd	CBInst8d
		dd	CBInst8e
		dd	CBInst8f
		dd	CBInst90
		dd	CBInst91
		dd	CBInst92
		dd	CBInst93
		dd	CBInst94
		dd	CBInst95
		dd	CBInst96
		dd	CBInst97
		dd	CBInst98
		dd	CBInst99
		dd	CBInst9a
		dd	CBInst9b
		dd	CBInst9c
		dd	CBInst9d
		dd	CBInst9e
		dd	CBInst9f
		dd	CBInsta0
		dd	CBInsta1
		dd	CBInsta2
		dd	CBInsta3
		dd	CBInsta4
		dd	CBInsta5
		dd	CBInsta6
		dd	CBInsta7
		dd	CBInsta8
		dd	CBInsta9
		dd	CBInstaa
		dd	CBInstab
		dd	CBInstac
		dd	CBInstad
		dd	CBInstae
		dd	CBInstaf
		dd	CBInstb0
		dd	CBInstb1
		dd	CBInstb2
		dd	CBInstb3
		dd	CBInstb4
		dd	CBInstb5
		dd	CBInstb6
		dd	CBInstb7
		dd	CBInstb8
		dd	CBInstb9
		dd	CBInstba
		dd	CBInstbb
		dd	CBInstbc
		dd	CBInstbd
		dd	CBInstbe
		dd	CBInstbf
		dd	CBInstc0
		dd	CBInstc1
		dd	CBInstc2
		dd	CBInstc3
		dd	CBInstc4
		dd	CBInstc5
		dd	CBInstc6
		dd	CBInstc7
		dd	CBInstc8
		dd	CBInstc9
		dd	CBInstca
		dd	CBInstcb
		dd	CBInstcc
		dd	CBInstcd
		dd	CBInstce
		dd	CBInstcf
		dd	CBInstd0
		dd	CBInstd1
		dd	CBInstd2
		dd	CBInstd3
		dd	CBInstd4
		dd	CBInstd5
		dd	CBInstd6
		dd	CBInstd7
		dd	CBInstd8
		dd	CBInstd9
		dd	CBInstda
		dd	CBInstdb
		dd	CBInstdc
		dd	CBInstdd
		dd	CBInstde
		dd	CBInstdf
		dd	CBInste0
		dd	CBInste1
		dd	CBInste2
		dd	CBInste3
		dd	CBInste4
		dd	CBInste5
		dd	CBInste6
		dd	CBInste7
		dd	CBInste8
		dd	CBInste9
		dd	CBInstea
		dd	CBInsteb
		dd	CBInstec
		dd	CBInsted
		dd	CBInstee
		dd	CBInstef
		dd	CBInstf0
		dd	CBInstf1
		dd	CBInstf2
		dd	CBInstf3
		dd	CBInstf4
		dd	CBInstf5
		dd	CBInstf6
		dd	CBInstf7
		dd	CBInstf8
		dd	CBInstf9
		dd	CBInstfa
		dd	CBInstfb
		dd	CBInstfc
		dd	CBInstfd
		dd	CBInstfe
		dd	CBInstff

z80PrefixED:
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	EDInst40
		dd	EDInst41
		dd	EDInst42
		dd	EDInst43
		dd	EDInst44
		dd	EDInst45
		dd	EDInst46
		dd	EDInst47
		dd	EDInst48
		dd	EDInst49
		dd	EDInst4a
		dd	EDInst4b
		dd	invalidInsWord
		dd	EDInst4d
		dd	invalidInsWord
		dd	EDInst4f
		dd	EDInst50
		dd	EDInst51
		dd	EDInst52
		dd	EDInst53
		dd	invalidInsWord
		dd	invalidInsWord
		dd	EDInst56
		dd	EDInst57
		dd	EDInst58
		dd	EDInst59
		dd	EDInst5a
		dd	EDInst5b
		dd	invalidInsWord
		dd	invalidInsWord
		dd	EDInst5e
		dd	EDInst5f
		dd	EDInst60
		dd	EDInst61
		dd	EDInst62
		dd	EDInst63
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	EDInst67
		dd	EDInst68
		dd	EDInst69
		dd	EDInst6a
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	EDInst6f
		dd	invalidInsWord
		dd	invalidInsWord
		dd	EDInst72
		dd	EDInst73
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	EDInst78
		dd	EDInst79
		dd	EDInst7a
		dd	EDInst7b
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	EDInsta0
		dd	EDInsta1
		dd	EDInsta2
		dd	EDInsta3
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	EDInsta8
		dd	EDInsta9
		dd	EDInstaa
		dd	EDInstab
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	EDInstb0
		dd	EDInstb1
		dd	EDInstb2
		dd	EDInstb3
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	EDInstb8
		dd	EDInstb9
		dd	EDInstba
		dd	EDInstbb
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord

z80PrefixDD:
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDInst09
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDInst19
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDInst21
		dd	DDInst22
		dd	DDInst23
		dd	DDInst24
		dd	DDInst25
		dd	DDInst26
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDInst29
		dd	DDInst2a
		dd	DDInst2b
		dd	DDInst2c
		dd	DDInst2d
		dd	DDInst2e
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDInst34
		dd	DDInst35
		dd	DDInst36
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDInst39
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDInst44
		dd	DDInst45
		dd	DDInst46
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDInst4c
		dd	DDInst4d
		dd	DDInst4e
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDInst54
		dd	DDInst55
		dd	DDInst56
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDInst5c
		dd	DDInst5d
		dd	DDInst5e
		dd	invalidInsWord
		dd	DDInst60
		dd	DDInst61
		dd	DDInst62
		dd	DDInst63
		dd	DDInst64
		dd	DDInst65
		dd	DDInst66
		dd	DDInst67
		dd	DDInst68
		dd	DDInst69
		dd	DDInst6a
		dd	DDInst6b
		dd	DDInst6c
		dd	DDInst6d
		dd	DDInst6e
		dd	DDInst6f
		dd	DDInst70
		dd	DDInst71
		dd	DDInst72
		dd	DDInst73
		dd	DDInst74
		dd	DDInst75
		dd	invalidInsWord
		dd	DDInst77
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDInst7c
		dd	DDInst7d
		dd	DDInst7e
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDInst84
		dd	DDInst85
		dd	DDInst86
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDInst8c
		dd	DDInst8d
		dd	DDInst8e
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDInst94
		dd	DDInst95
		dd	DDInst96
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDInst9c
		dd	DDInst9d
		dd	DDInst9e
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDInsta4
		dd	DDInsta5
		dd	DDInsta6
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDInstac
		dd	DDInstad
		dd	DDInstae
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDInstb4
		dd	DDInstb5
		dd	DDInstb6
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDInstbc
		dd	DDInstbd
		dd	DDInstbe
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDInstcb
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDInste1
		dd	invalidInsWord
		dd	DDInste3
		dd	invalidInsWord
		dd	DDInste5
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDInste9
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDInstf9
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord

z80PrefixFD:
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	FDInst09
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	FDInst19
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	FDInst21
		dd	FDInst22
		dd	FDInst23
		dd	FDInst24
		dd	FDInst25
		dd	FDInst26
		dd	invalidInsWord
		dd	invalidInsWord
		dd	FDInst29
		dd	FDInst2a
		dd	FDInst2b
		dd	FDInst2c
		dd	FDInst2d
		dd	FDInst2e
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	FDInst34
		dd	FDInst35
		dd	FDInst36
		dd	invalidInsWord
		dd	invalidInsWord
		dd	FDInst39
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	FDInst44
		dd	FDInst45
		dd	FDInst46
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	FDInst4c
		dd	FDInst4d
		dd	FDInst4e
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	FDInst54
		dd	FDInst55
		dd	FDInst56
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	FDInst5c
		dd	FDInst5d
		dd	FDInst5e
		dd	invalidInsWord
		dd	FDInst60
		dd	FDInst61
		dd	FDInst62
		dd	FDInst63
		dd	FDInst64
		dd	FDInst65
		dd	FDInst66
		dd	FDInst67
		dd	FDInst68
		dd	FDInst69
		dd	FDInst6a
		dd	FDInst6b
		dd	FDInst6c
		dd	FDInst6d
		dd	FDInst6e
		dd	FDInst6f
		dd	FDInst70
		dd	FDInst71
		dd	FDInst72
		dd	FDInst73
		dd	FDInst74
		dd	FDInst75
		dd	invalidInsWord
		dd	FDInst77
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	FDInst7c
		dd	FDInst7d
		dd	FDInst7e
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	FDInst84
		dd	FDInst85
		dd	FDInst86
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	FDInst8c
		dd	FDInst8d
		dd	FDInst8e
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	FDInst94
		dd	FDInst95
		dd	FDInst96
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	FDInst9c
		dd	FDInst9d
		dd	FDInst9e
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	FDInsta4
		dd	FDInsta5
		dd	FDInsta6
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	FDInstac
		dd	FDInstad
		dd	FDInstae
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	FDInstb4
		dd	FDInstb5
		dd	FDInstb6
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	FDInstbc
		dd	FDInstbd
		dd	FDInstbe
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	FDInstcb
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	FDInste1
		dd	invalidInsWord
		dd	FDInste3
		dd	invalidInsWord
		dd	FDInste5
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	FDInste9
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	FDInstf9
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
z80ddfdcbInstructions:
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDFDCBInst06
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDFDCBInst0e
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDFDCBInst16
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDFDCBInst1e
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDFDCBInst26
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDFDCBInst2e
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDFDCBInst3e
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDFDCBInst46
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDFDCBInst4e
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDFDCBInst56
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDFDCBInst5e
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDFDCBInst66
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDFDCBInst6e
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDFDCBInst76
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDFDCBInst7e
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDFDCBInst86
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDFDCBInst8e
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDFDCBInst96
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDFDCBInst9e
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDFDCBInsta6
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDFDCBInstae
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDFDCBInstb6
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDFDCBInstbe
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDFDCBInstc6
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDFDCBInstce
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDFDCBInstd6
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDFDCBInstde
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDFDCBInste6
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDFDCBInstee
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDFDCBInstf6
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDFDCBInstfe
		dd	invalidInsWord

		section	.text

times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst00:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst01:
		sub	dword [cyclesRemaining], byte 10
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 10
		mov	cx, [esi]	; Get our immediate value of BC
		add	esi, 2
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst02:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		mov	[_z80af], ax	; Store AF
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop0:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite0	; Yes - go write it!
		cmp	cx, [edi]	; Are we smaller?
		jb	nextAddr0	; Yes... go to the next addr
		cmp	cx, [edi+4]	; Are we smaller?
		jbe	callRoutine0	; If not, go call it!

nextAddr0:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop0

callRoutine0:
		mov	dx, cx	; Get our address to target
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit0
memoryWrite0:
		mov	[ebp + ecx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit0:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst03:
		sub	dword [cyclesRemaining], byte 6
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 6
		inc	cx
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst04:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		inc	ch
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		and	ah, 0fdh	; Knock out N!
		xor	dh, dh	; Clear upper part of DX
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst05:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		dec	ch
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		or	ah, 02h	; Set negative!
		xor	dh, dh	; Clear upper part of DX
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst06:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		mov	ch, [esi]	; Get our immediate value
		inc	esi
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst07:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		rol	al, 1
		lahf
		and	ah, 0edh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst08:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		xchg	ah, al
		xchg	ax, [_z80afprime]
		xchg	ah, al
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst09:
		sub	dword [cyclesRemaining], byte 11
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 11
		mov	dh, ah	; Get our flags
		and	dh, 0ech	; Preserve the top three and bits 2 & 3
		mov	[_orgval], bx	; Store our original value
		add	bx, cx
		lahf
		mov	di, [_orgval]	; Get original
		xor	di, bx ; XOR It with our computed value
		xor	di, cx
		and	di, 1000h	; Just our half carry
		or		dx, di	; Or in our flags
		and	ah, 01h	; Just carry
		or	ah, dh
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst0a:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop1:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead1
		cmp	cx, [edi]	; Are we smaller?
		jb		nextAddr1		; Yes, go to the next address
		cmp	cx, [edi+4]	; Are we bigger?
		jbe	callRoutine1

nextAddr1:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop1

callRoutine1:
		mov	dx, cx	; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	[_z80af], al	; Save our new accumulator
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit1

memoryRead1:
		mov	al, [ebp + ecx]	; Get our data

readExit1:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst0b:
		sub	dword [cyclesRemaining], byte 6
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 6
		dec	cx
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst0c:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		inc	cl
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		and	ah, 0fdh	; Knock out N!
		xor	dh, dh	; Clear upper part of DX
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst0d:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		dec	cl
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		or	ah, 02h	; Set negative!
		xor	dh, dh	; Clear upper part of DX
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst0e:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		mov	cl, [esi]	; Get our immediate value
		inc	esi
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst0f:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		ror	al, 1
		lahf
		and	ah, 0edh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst10:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 8
		mov	dl, [esi] ; Get our relative offset
		inc	esi	; Next instruction, please!
		dec	ch	; Decrement B
		jz	noJump	; Don't take the jump if it's done!
; Otherwise, take the jump
		add	dword [dwElapsedTicks], 5
		sub	dword [cyclesRemaining], 5
		xchg	ax, dx
		cbw
		xchg	ax, dx
		sub	esi, ebp
		add	si, dx
		add	esi, ebp
noJump:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst11:
		sub	dword [cyclesRemaining], byte 10
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 10
		mov	di, [esi]	; Get our immediate value of DE
		mov	word [_z80de], di ; Store DE
		add	esi, 2
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst12:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		mov	[_z80af], ax	; Store AF
		mov	dx, [_z80de]
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop2:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite2	; Yes - go write it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr2	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine2	; If not, go call it!

nextAddr2:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop2

callRoutine2:
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit2
memoryWrite2:
		mov	[ebp + edx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit2:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst13:
		sub	dword [cyclesRemaining], byte 6
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 6
		inc	word [_z80de]
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst14:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		inc	byte [_z80de + 1]
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		and	ah, 0fdh	; Knock out N!
		xor	dh, dh	; Clear upper part of DX
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst15:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		dec	byte [_z80de + 1]
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		or	ah, 02h	; Set negative!
		xor	dh, dh	; Clear upper part of DX
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst16:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		mov	dl, [esi]	; Get our immediate value
		mov	byte [_z80de + 1], dl	; Store our new value
		inc	esi
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst17:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		rcl	al, 1
		lahf
		and	ah, 0edh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst18:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		mov	dl, [esi] ; Get our relative offset
		inc	esi	; Next instruction, please!
		cmp	dl, 0feh	; Jump to self?
		je		yesJrMan	; Yup! Bail out!
		xchg	ax, dx
		cbw
		xchg	ax, dx
		sub	esi, ebp
		add	si, dx
		add	esi, ebp
		xor	dh, dh
noJumpMan3:
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]

yesJrMan:
		mov	edx, [cyclesRemaining]	; Get # of cycles remaining
		inc	edx		; Make it a little longer
		add	[dwElapsedTicks], edx	; Elapse it!
		xor	edx, edx		; Zero me for later
		mov	[cyclesRemaining], edx
		dec	esi		; Back up one
		jmp	noMoreExec


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst19:
		sub	dword [cyclesRemaining], byte 11
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 11
		mov	dh, ah	; Get our flags
		and	dh, 0ech	; Preserve the top three and bits 2 & 3
		mov	[_orgval], bx	; Store our original value
		add	bx, word [_z80de]
		lahf
		mov	di, [_orgval]	; Get original
		xor	di, bx ; XOR It with our computed value
		xor	di, word [_z80de]
		and	di, 1000h	; Just our half carry
		or		dx, di	; Or in our flags
		and	ah, 01h	; Just carry
		or	ah, dh
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst1a:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		mov	dx, [_z80de]
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop4:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead4
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr4		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine4

nextAddr4:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop4

callRoutine4:
		call	ReadMemoryByte	; Standard read routine
		mov	[_z80af], al	; Save our new accumulator
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit4

memoryRead4:
		mov	al, [ebp + edx]	; Get our data

readExit4:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst1b:
		sub	dword [cyclesRemaining], byte 6
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 6
		dec	word [_z80de]
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst1c:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		inc	byte [_z80de]
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		and	ah, 0fdh	; Knock out N!
		xor	dh, dh	; Clear upper part of DX
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst1d:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		dec	byte [_z80de]
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		or	ah, 02h	; Set negative!
		xor	dh, dh	; Clear upper part of DX
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst1e:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		mov	dl, [esi]	; Get our immediate value
		mov	byte [_z80de], dl	; Store our new value
		inc	esi
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst1f:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		rcr	al, 1
		lahf
		and	ah, 0edh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst20:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		mov	dl, [esi] ; Get our relative offset
		inc	esi	; Next instruction, please!
		sahf
		jnz	takeJump5
		jmp	short noJumpMan5
takeJump5:
		add	dword [dwElapsedTicks], 5
		sub	dword [cyclesRemaining], 5
		xchg	ax, dx
		cbw
		xchg	ax, dx
		sub	esi, ebp
		add	si, dx
		add	esi, ebp
		xor	dh, dh
noJumpMan5:
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst21:
		sub	dword [cyclesRemaining], byte 10
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 10
		mov	bx, [esi]	; Get our immediate value of HL
		add	esi, 2
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst22:
		sub	dword [cyclesRemaining], byte 16
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 16
		mov	dx, [esi]	; Get our address to write to
		add	esi, 2		; Next address, please...
		mov	[_z80af], ax	; Store AF
		mov	al, bl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop6:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite6	; Yes - go write it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr6	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine6	; If not, go call it!

nextAddr6:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop6

callRoutine6:
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit6
memoryWrite6:
		mov	[ebp + edx], bl
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit6:
		inc	dx
		mov	[_z80af], ax	; Store AF
		mov	al, bh	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop7:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite7	; Yes - go write it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr7	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine7	; If not, go call it!

nextAddr7:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop7

callRoutine7:
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit7
memoryWrite7:
		mov	[ebp + edx], bh
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit7:
		xor	dh, dh	; Zero our upper byte
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst23:
		sub	dword [cyclesRemaining], byte 6
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 6
		inc	bx
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst24:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		inc	bh
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		and	ah, 0fdh	; Knock out N!
		xor	dh, dh	; Clear upper part of DX
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst25:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		dec	bh
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		or	ah, 02h	; Set negative!
		xor	dh, dh	; Clear upper part of DX
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst26:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		mov	bh, [esi]	; Get our immediate value
		inc	esi
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst27:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	dh, ah
		and	dh, 02ah
		test	ah, 02h	; Were we doing a subtraction?
		jnz	handleNeg ; Nope!
		sahf
		daa
		lahf
		jmp	short endDaa
handleNeg:
		sahf
		das
		lahf
endDaa:
		and	ah, 0d5h
		or	ah, dh
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst28:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		mov	dl, [esi] ; Get our relative offset
		inc	esi	; Next instruction, please!
		sahf
		jz	takeJump8
		jmp	short noJumpMan8
takeJump8:
		add	dword [dwElapsedTicks], 5
		sub	dword [cyclesRemaining], 5
		xchg	ax, dx
		cbw
		xchg	ax, dx
		sub	esi, ebp
		add	si, dx
		add	esi, ebp
		xor	dh, dh
noJumpMan8:
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst29:
		sub	dword [cyclesRemaining], byte 11
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 11
		mov	dh, ah	; Get our flags
		and	dh, 0ech	; Preserve the top three and bits 2 & 3
		mov	[_orgval], bx	; Store our original value
		add	bx, bx
		lahf
		mov	di, [_orgval]	; Get original
		xor	di, bx ; XOR It with our computed value
		xor	di, bx
		and	di, 1000h	; Just our half carry
		or		dx, di	; Or in our flags
		and	ah, 01h	; Just carry
		or	ah, dh
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst2a:
		sub	dword [cyclesRemaining], byte 16
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 16
		mov	dx, [esi]	; Get address to load
		add	esi, 2	; Skip over it so we don't execute it
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop9:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead9
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr9		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine9

nextAddr9:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop9

callRoutine9:
		call	ReadMemoryByte	; Standard read routine
		mov	bl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit9

memoryRead9:
		mov	bl, [ebp + edx]	; Get our data

readExit9:
		inc	dx
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop10:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead10
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr10		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine10

nextAddr10:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop10

callRoutine10:
		call	ReadMemoryByte	; Standard read routine
		mov	bh, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit10

memoryRead10:
		mov	bh, [ebp + edx]	; Get our data

readExit10:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst2b:
		sub	dword [cyclesRemaining], byte 6
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 6
		dec	bx
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst2c:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		inc	bl
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		and	ah, 0fdh	; Knock out N!
		xor	dh, dh	; Clear upper part of DX
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst2d:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		dec	bl
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		or	ah, 02h	; Set negative!
		xor	dh, dh	; Clear upper part of DX
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst2e:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		mov	bl, [esi]	; Get our immediate value
		inc	esi
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst2f:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		not	al
		or	ah, 012h	; N And H are now on!
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst30:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		mov	dl, [esi] ; Get our relative offset
		inc	esi	; Next instruction, please!
		sahf
		jnc	takeJump11
		jmp	short noJumpMan11
takeJump11:
		add	dword [dwElapsedTicks], 5
		sub	dword [cyclesRemaining], 5
		xchg	ax, dx
		cbw
		xchg	ax, dx
		sub	esi, ebp
		add	si, dx
		add	esi, ebp
		xor	dh, dh
noJumpMan11:
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst31:
		sub	dword [cyclesRemaining], byte 10
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 10
		mov	di, [esi]	; Get our immediate value of SP
		mov	word [_z80sp], di	; Store it!
		add	esi, 2
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst32:
		sub	dword [cyclesRemaining], byte 13
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 13
		mov	dx, [esi]	; Get our address to write to
		add	esi, 2		; Next address, please...
		mov	[_z80af], ax	; Store AF
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop12:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite12	; Yes - go write it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr12	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine12	; If not, go call it!

nextAddr12:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop12

callRoutine12:
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit12
memoryWrite12:
		mov	[ebp + edx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit12:
		xor	dh, dh	; Zero our upper byte
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst33:
		sub	dword [cyclesRemaining], byte 6
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 6
		inc	word [_z80sp]
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst34:
		sub	dword [cyclesRemaining], byte 11
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 11
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop13:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead13
		cmp	bx, [edi]	; Are we smaller?
		jb		nextAddr13		; Yes, go to the next address
		cmp	bx, [edi+4]	; Are we bigger?
		jbe	callRoutine13

nextAddr13:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop13

callRoutine13:
		mov	dx, bx	; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit13

memoryRead13:
		mov	dl, [ebp + ebx]	; Get our data

readExit13:
		sahf
		inc	dl
		lahf
		o16	pushf
		shl	edx, 16
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		shr	edx, 16
		and	ah, 0fdh	; Knock out N!
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop14:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite14	; Yes - go write it!
		cmp	bx, [edi]	; Are we smaller?
		jb	nextAddr14	; Yes... go to the next addr
		cmp	bx, [edi+4]	; Are we smaller?
		jbe	callRoutine14	; If not, go call it!

nextAddr14:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop14

callRoutine14:
		mov	dx, bx	; Get our address to target
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit14
memoryWrite14:
		mov	[ebp + ebx], dl
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit14:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst35:
		sub	dword [cyclesRemaining], byte 11
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 11
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop15:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead15
		cmp	bx, [edi]	; Are we smaller?
		jb		nextAddr15		; Yes, go to the next address
		cmp	bx, [edi+4]	; Are we bigger?
		jbe	callRoutine15

nextAddr15:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop15

callRoutine15:
		mov	dx, bx	; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit15

memoryRead15:
		mov	dl, [ebp + ebx]	; Get our data

readExit15:
		sahf
		dec	dl
		lahf
		o16	pushf
		shl	edx, 16
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		shr	edx, 16
		or		ah, 02h	; Make it N!
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop16:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite16	; Yes - go write it!
		cmp	bx, [edi]	; Are we smaller?
		jb	nextAddr16	; Yes... go to the next addr
		cmp	bx, [edi+4]	; Are we smaller?
		jbe	callRoutine16	; If not, go call it!

nextAddr16:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop16

callRoutine16:
		mov	dx, bx	; Get our address to target
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit16
memoryWrite16:
		mov	[ebp + ebx], dl
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit16:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst36:
		sub	dword [cyclesRemaining], byte 10
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 10
		mov	[_z80af], ax	; Store AF
		mov	al, [esi]	; And our data to write
		inc	esi	; Increment our program counter
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop17:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite17	; Yes - go write it!
		cmp	bx, [edi]	; Are we smaller?
		jb	nextAddr17	; Yes... go to the next addr
		cmp	bx, [edi+4]	; Are we smaller?
		jbe	callRoutine17	; If not, go call it!

nextAddr17:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop17

callRoutine17:
		mov	dx, bx	; Get our address to target
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit17
memoryWrite17:
		mov	[ebp + ebx], al	; Store our direct value
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit17:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst37:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		or	ah, 1
		and	ah,0edh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst38:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		mov	dl, [esi] ; Get our relative offset
		inc	esi	; Next instruction, please!
		sahf
		jc	takeJump18
		jmp	short noJumpMan18
takeJump18:
		add	dword [dwElapsedTicks], 5
		sub	dword [cyclesRemaining], 5
		xchg	ax, dx
		cbw
		xchg	ax, dx
		sub	esi, ebp
		add	si, dx
		add	esi, ebp
		xor	dh, dh
noJumpMan18:
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst39:
		sub	dword [cyclesRemaining], byte 11
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 11
		mov	dh, ah	; Get our flags
		and	dh, 0ech	; Preserve the top three and bits 2 & 3
		mov	[_orgval], bx	; Store our original value
		add	bx, word [_z80sp]
		lahf
		mov	di, [_orgval]	; Get original
		xor	di, bx ; XOR It with our computed value
		xor	di, word [_z80sp]
		and	di, 1000h	; Just our half carry
		or		dx, di	; Or in our flags
		and	ah, 01h	; Just carry
		or	ah, dh
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst3a:
		sub	dword [cyclesRemaining], byte 13
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 13
		mov	dx, [esi]	; Get our address
		add	esi, 2		; Skip past the address
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop19:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead19
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr19		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine19

nextAddr19:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop19

callRoutine19:
		call	ReadMemoryByte	; Standard read routine
		mov	[_z80af], al	; Save our new accumulator
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit19

memoryRead19:
		mov	al, [ebp + edx]	; Get our data

readExit19:
		xor	dh, dh	; Make sure we don't hose things
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst3b:
		sub	dword [cyclesRemaining], byte 6
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 6
		dec	word [_z80sp]
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst3c:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		inc	al
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		and	ah, 0fdh	; Knock out N!
		xor	dh, dh	; Clear upper part of DX
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst3d:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		dec	al
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		or	ah, 02h	; Set negative!
		xor	dh, dh	; Clear upper part of DX
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst3e:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		mov	al, [esi]	; Get our immediate value
		inc	esi
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst3f:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	dl, ah
		and	dl, 01h
		shl	dl, 4
		xor	ah, 01h
		and	ah, 0edh
		or	ah, dl
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst40:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst41:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	ch, cl
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst42:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	ch, byte [_z80de + 1]
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst43:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	ch, byte [_z80de]
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst44:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	ch, bh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst45:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	ch, bl
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst46:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop20:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead20
		cmp	bx, [edi]	; Are we smaller?
		jb		nextAddr20		; Yes, go to the next address
		cmp	bx, [edi+4]	; Are we bigger?
		jbe	callRoutine20

nextAddr20:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop20

callRoutine20:
		mov	dx, bx	; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	ch, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit20

memoryRead20:
		mov	ch, [ebp + ebx]	; Get our data

readExit20:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst47:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	ch, al
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst48:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	cl, ch
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst49:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst4a:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	cl, byte [_z80de + 1]
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst4b:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	cl, byte [_z80de]
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst4c:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	cl, bh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst4d:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	cl, bl
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst4e:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop21:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead21
		cmp	bx, [edi]	; Are we smaller?
		jb		nextAddr21		; Yes, go to the next address
		cmp	bx, [edi+4]	; Are we bigger?
		jbe	callRoutine21

nextAddr21:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop21

callRoutine21:
		mov	dx, bx	; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	cl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit21

memoryRead21:
		mov	cl, [ebp + ebx]	; Get our data

readExit21:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst4f:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	cl, al
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst50:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	byte [_z80de + 1], ch
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst51:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	byte [_z80de + 1], cl
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst52:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst53:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	dl, byte [_z80de]
		mov	[_z80de + 1], dl
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst54:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	byte [_z80de + 1], bh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst55:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	byte [_z80de + 1], bl
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst56:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop22:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead22
		cmp	bx, [edi]	; Are we smaller?
		jb		nextAddr22		; Yes, go to the next address
		cmp	bx, [edi+4]	; Are we bigger?
		jbe	callRoutine22

nextAddr22:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop22

callRoutine22:
		mov	dx, bx	; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dh, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit22

memoryRead22:
		mov	dh, [ebp + ebx]	; Get our data

readExit22:
		mov	byte [_z80de + 1], dh
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst57:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	byte [_z80de + 1], al
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst58:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	byte [_z80de], ch
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst59:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	byte [_z80de], cl
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst5a:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	dl, byte [_z80de + 1]
		mov	[_z80de], dl
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst5b:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst5c:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	byte [_z80de], bh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst5d:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	byte [_z80de], bl
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst5e:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop23:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead23
		cmp	bx, [edi]	; Are we smaller?
		jb		nextAddr23		; Yes, go to the next address
		cmp	bx, [edi+4]	; Are we bigger?
		jbe	callRoutine23

nextAddr23:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop23

callRoutine23:
		mov	dx, bx	; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit23

memoryRead23:
		mov	dl, [ebp + ebx]	; Get our data

readExit23:
		mov	byte [_z80de], dl
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst5f:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	byte [_z80de], al
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst60:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	bh, ch
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst61:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	bh, cl
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst62:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	bh, byte [_z80de + 1]
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst63:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	bh, byte [_z80de]
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst64:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst65:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	bh, bl
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst66:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop24:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead24
		cmp	bx, [edi]	; Are we smaller?
		jb		nextAddr24		; Yes, go to the next address
		cmp	bx, [edi+4]	; Are we bigger?
		jbe	callRoutine24

nextAddr24:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop24

callRoutine24:
		mov	dx, bx	; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	bh, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit24

memoryRead24:
		mov	bh, [ebp + ebx]	; Get our data

readExit24:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst67:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	bh, al
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst68:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	bl, ch
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst69:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	bl, cl
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst6a:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	bl, byte [_z80de + 1]
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst6b:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	bl, byte [_z80de]
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst6c:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	bl, bh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst6d:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst6e:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop25:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead25
		cmp	bx, [edi]	; Are we smaller?
		jb		nextAddr25		; Yes, go to the next address
		cmp	bx, [edi+4]	; Are we bigger?
		jbe	callRoutine25

nextAddr25:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop25

callRoutine25:
		mov	dx, bx	; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	bl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit25

memoryRead25:
		mov	bl, [ebp + ebx]	; Get our data

readExit25:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst6f:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	bl, al
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst70:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		mov	[_z80af], ax	; Store AF
		mov	al, ch	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop26:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite26	; Yes - go write it!
		cmp	bx, [edi]	; Are we smaller?
		jb	nextAddr26	; Yes... go to the next addr
		cmp	bx, [edi+4]	; Are we smaller?
		jbe	callRoutine26	; If not, go call it!

nextAddr26:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop26

callRoutine26:
		mov	dx, bx	; Get our address to target
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit26
memoryWrite26:
		mov	[ebp + ebx], ch
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit26:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst71:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		mov	[_z80af], ax	; Store AF
		mov	al, cl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop27:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite27	; Yes - go write it!
		cmp	bx, [edi]	; Are we smaller?
		jb	nextAddr27	; Yes... go to the next addr
		cmp	bx, [edi+4]	; Are we smaller?
		jbe	callRoutine27	; If not, go call it!

nextAddr27:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop27

callRoutine27:
		mov	dx, bx	; Get our address to target
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit27
memoryWrite27:
		mov	[ebp + ebx], cl
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit27:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst72:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		mov	[_z80af], ax	; Store AF
		mov	al, byte [_z80de + 1]	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop28:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite28	; Yes - go write it!
		cmp	bx, [edi]	; Are we smaller?
		jb	nextAddr28	; Yes... go to the next addr
		cmp	bx, [edi+4]	; Are we smaller?
		jbe	callRoutine28	; If not, go call it!

nextAddr28:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop28

callRoutine28:
		mov	dx, bx	; Get our address to target
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit28
memoryWrite28:
		mov	edi, edx
		mov	dl, byte [_z80de + 1]
		mov	[ebp + ebx], dl
		mov	edx, edi
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit28:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst73:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		mov	[_z80af], ax	; Store AF
		mov	al, byte [_z80de]	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop29:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite29	; Yes - go write it!
		cmp	bx, [edi]	; Are we smaller?
		jb	nextAddr29	; Yes... go to the next addr
		cmp	bx, [edi+4]	; Are we smaller?
		jbe	callRoutine29	; If not, go call it!

nextAddr29:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop29

callRoutine29:
		mov	dx, bx	; Get our address to target
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit29
memoryWrite29:
		mov	edi, edx
		mov	dl, byte [_z80de]
		mov	[ebp + ebx], dl
		mov	edx, edi
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit29:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst74:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		mov	[_z80af], ax	; Store AF
		mov	al, bh	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop30:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite30	; Yes - go write it!
		cmp	bx, [edi]	; Are we smaller?
		jb	nextAddr30	; Yes... go to the next addr
		cmp	bx, [edi+4]	; Are we smaller?
		jbe	callRoutine30	; If not, go call it!

nextAddr30:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop30

callRoutine30:
		mov	dx, bx	; Get our address to target
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit30
memoryWrite30:
		mov	[ebp + ebx], bh
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit30:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst75:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		mov	[_z80af], ax	; Store AF
		mov	al, bl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop31:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite31	; Yes - go write it!
		cmp	bx, [edi]	; Are we smaller?
		jb	nextAddr31	; Yes... go to the next addr
		cmp	bx, [edi+4]	; Are we smaller?
		jbe	callRoutine31	; If not, go call it!

nextAddr31:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop31

callRoutine31:
		mov	dx, bx	; Get our address to target
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit31
memoryWrite31:
		mov	[ebp + ebx], bl
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit31:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst76:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	dword [_z80halted], 1	; We've halted the chip!
		mov	edx, dword [cyclesRemaining] ; Get the time remaining
		add	[dwElapsedTicks], edx ; Fake like we did it
		inc	esi
		jmp	noMoreExec
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst77:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		mov	[_z80af], ax	; Store AF
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop32:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite32	; Yes - go write it!
		cmp	bx, [edi]	; Are we smaller?
		jb	nextAddr32	; Yes... go to the next addr
		cmp	bx, [edi+4]	; Are we smaller?
		jbe	callRoutine32	; If not, go call it!

nextAddr32:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop32

callRoutine32:
		mov	dx, bx	; Get our address to target
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit32
memoryWrite32:
		mov	[ebp + ebx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit32:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst78:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	al, ch
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst79:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	al, cl
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst7a:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	al, byte [_z80de + 1]
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst7b:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	al, byte [_z80de]
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst7c:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	al, bh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst7d:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	al, bl
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst7e:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop33:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead33
		cmp	bx, [edi]	; Are we smaller?
		jb		nextAddr33		; Yes, go to the next address
		cmp	bx, [edi+4]	; Are we bigger?
		jbe	callRoutine33

nextAddr33:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop33

callRoutine33:
		mov	dx, bx	; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	[_z80af], al	; Save our new accumulator
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit33

memoryRead33:
		mov	al, [ebp + ebx]	; Get our data

readExit33:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst7f:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst80:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		add	al, ch
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		and	ah, 0fdh ; No N!
		xor	dh, dh	; Zero this...
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst81:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		add	al, cl
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		and	ah, 0fdh ; No N!
		xor	dh, dh	; Zero this...
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst82:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		add	al, byte [_z80de + 1]
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		and	ah, 0fdh ; No N!
		xor	dh, dh	; Zero this...
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst83:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		add	al, byte [_z80de]
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		and	ah, 0fdh ; No N!
		xor	dh, dh	; Zero this...
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst84:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		add	al, bh
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		and	ah, 0fdh ; No N!
		xor	dh, dh	; Zero this...
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst85:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		add	al, bl
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		and	ah, 0fdh ; No N!
		xor	dh, dh	; Zero this...
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst86:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop34:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead34
		cmp	bx, [edi]	; Are we smaller?
		jb		nextAddr34		; Yes, go to the next address
		cmp	bx, [edi+4]	; Are we bigger?
		jbe	callRoutine34

nextAddr34:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop34

callRoutine34:
		mov	dx, bx	; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit34

memoryRead34:
		mov	dl, [ebp + ebx]	; Get our data

readExit34:
		sahf
		add	al, dl
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		and	ah, 0fdh ; No N!
		xor	dh, dh	; Zero this...
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst87:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		add	al, al
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		and	ah, 0fdh ; No N!
		xor	dh, dh	; Zero this...
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst88:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		adc	al, ch
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		and	ah, 0fdh ; No N!
		xor	dh, dh	; Zero this...
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst89:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		adc	al, cl
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		and	ah, 0fdh ; No N!
		xor	dh, dh	; Zero this...
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst8a:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		adc	al, byte [_z80de + 1]
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		and	ah, 0fdh ; No N!
		xor	dh, dh	; Zero this...
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst8b:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		adc	al, byte [_z80de]
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		and	ah, 0fdh ; No N!
		xor	dh, dh	; Zero this...
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst8c:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		adc	al, bh
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		and	ah, 0fdh ; No N!
		xor	dh, dh	; Zero this...
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst8d:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		adc	al, bl
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		and	ah, 0fdh ; No N!
		xor	dh, dh	; Zero this...
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst8e:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop35:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead35
		cmp	bx, [edi]	; Are we smaller?
		jb		nextAddr35		; Yes, go to the next address
		cmp	bx, [edi+4]	; Are we bigger?
		jbe	callRoutine35

nextAddr35:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop35

callRoutine35:
		mov	dx, bx	; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit35

memoryRead35:
		mov	dl, [ebp + ebx]	; Get our data

readExit35:
		sahf
		adc	al, dl
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		and	ah, 0fdh ; No N!
		xor	dh, dh	; Zero this...
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst8f:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		adc	al, al
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		and	ah, 0fdh ; No N!
		xor	dh, dh	; Zero this...
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst90:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		sub	al, ch
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		or	ah, 02h	; N Gets set!
		xor	dh, dh	; Zero this...
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst91:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		sub	al, cl
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		or	ah, 02h	; N Gets set!
		xor	dh, dh	; Zero this...
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst92:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		sub	al, byte [_z80de + 1]
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		or	ah, 02h	; N Gets set!
		xor	dh, dh	; Zero this...
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst93:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		sub	al, byte [_z80de]
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		or	ah, 02h	; N Gets set!
		xor	dh, dh	; Zero this...
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst94:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		sub	al, bh
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		or	ah, 02h	; N Gets set!
		xor	dh, dh	; Zero this...
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst95:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		sub	al, bl
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		or	ah, 02h	; N Gets set!
		xor	dh, dh	; Zero this...
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst96:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop36:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead36
		cmp	bx, [edi]	; Are we smaller?
		jb		nextAddr36		; Yes, go to the next address
		cmp	bx, [edi+4]	; Are we bigger?
		jbe	callRoutine36

nextAddr36:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop36

callRoutine36:
		mov	dx, bx	; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit36

memoryRead36:
		mov	dl, [ebp + ebx]	; Get our data

readExit36:
		sahf
		sub	al, dl
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		or	ah, 02h	; N Gets set!
		xor	dh, dh	; Zero this...
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst97:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		sub	al, al
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		or	ah, 02h	; N Gets set!
		xor	dh, dh	; Zero this...
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst98:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		sbb	al, ch
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		or	ah, 02h	; N Gets set!
		xor	dh, dh	; Zero this...
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst99:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		sbb	al, cl
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		or	ah, 02h	; N Gets set!
		xor	dh, dh	; Zero this...
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst9a:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		sbb	al, byte [_z80de + 1]
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		or	ah, 02h	; N Gets set!
		xor	dh, dh	; Zero this...
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst9b:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		sbb	al, byte [_z80de]
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		or	ah, 02h	; N Gets set!
		xor	dh, dh	; Zero this...
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst9c:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		sbb	al, bh
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		or	ah, 02h	; N Gets set!
		xor	dh, dh	; Zero this...
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst9d:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		sbb	al, bl
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		or	ah, 02h	; N Gets set!
		xor	dh, dh	; Zero this...
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst9e:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop37:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead37
		cmp	bx, [edi]	; Are we smaller?
		jb		nextAddr37		; Yes, go to the next address
		cmp	bx, [edi+4]	; Are we bigger?
		jbe	callRoutine37

nextAddr37:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop37

callRoutine37:
		mov	dx, bx	; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit37

memoryRead37:
		mov	dl, [ebp + ebx]	; Get our data

readExit37:
		sahf
		sbb	al, dl
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		or	ah, 02h	; N Gets set!
		xor	dh, dh	; Zero this...
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst9f:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		sbb	al, al
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		or	ah, 02h	; N Gets set!
		xor	dh, dh	; Zero this...
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInsta0:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		and	al, ch
		lahf
		and	ah, 0ech	; Only these flags matter!
		or	ah, 010h	; Half carry gets set
		xor	dh, dh	; Zero this...
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInsta1:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		and	al, cl
		lahf
		and	ah, 0ech	; Only these flags matter!
		or	ah, 010h	; Half carry gets set
		xor	dh, dh	; Zero this...
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInsta2:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		and	al, byte [_z80de + 1]
		lahf
		and	ah, 0ech	; Only these flags matter!
		or	ah, 010h	; Half carry gets set
		xor	dh, dh	; Zero this...
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInsta3:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		and	al, byte [_z80de]
		lahf
		and	ah, 0ech	; Only these flags matter!
		or	ah, 010h	; Half carry gets set
		xor	dh, dh	; Zero this...
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInsta4:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		and	al, bh
		lahf
		and	ah, 0ech	; Only these flags matter!
		or	ah, 010h	; Half carry gets set
		xor	dh, dh	; Zero this...
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInsta5:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		and	al, bl
		lahf
		and	ah, 0ech	; Only these flags matter!
		or	ah, 010h	; Half carry gets set
		xor	dh, dh	; Zero this...
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInsta6:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop38:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead38
		cmp	bx, [edi]	; Are we smaller?
		jb		nextAddr38		; Yes, go to the next address
		cmp	bx, [edi+4]	; Are we bigger?
		jbe	callRoutine38

nextAddr38:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop38

callRoutine38:
		mov	dx, bx	; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit38

memoryRead38:
		mov	dl, [ebp + ebx]	; Get our data

readExit38:
		sahf
		and	al, dl
		lahf
		and	ah, 0ech	; Only these flags matter!
		or	ah, 010h	; Half carry gets set
		xor	dh, dh	; Zero this...
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInsta7:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		and	al, al
		lahf
		and	ah, 0ech	; Only these flags matter!
		or	ah, 010h	; Half carry gets set
		xor	dh, dh	; Zero this...
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInsta8:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		xor	al, ch
		lahf
		and	ah, 0ech	; Only these flags matter!
		xor	dh, dh	; Zero this...
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInsta9:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		xor	al, cl
		lahf
		and	ah, 0ech	; Only these flags matter!
		xor	dh, dh	; Zero this...
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstaa:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		xor	al, byte [_z80de + 1]
		lahf
		and	ah, 0ech	; Only these flags matter!
		xor	dh, dh	; Zero this...
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstab:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		xor	al, byte [_z80de]
		lahf
		and	ah, 0ech	; Only these flags matter!
		xor	dh, dh	; Zero this...
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstac:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		xor	al, bh
		lahf
		and	ah, 0ech	; Only these flags matter!
		xor	dh, dh	; Zero this...
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstad:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		xor	al, bl
		lahf
		and	ah, 0ech	; Only these flags matter!
		xor	dh, dh	; Zero this...
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstae:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop39:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead39
		cmp	bx, [edi]	; Are we smaller?
		jb		nextAddr39		; Yes, go to the next address
		cmp	bx, [edi+4]	; Are we bigger?
		jbe	callRoutine39

nextAddr39:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop39

callRoutine39:
		mov	dx, bx	; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit39

memoryRead39:
		mov	dl, [ebp + ebx]	; Get our data

readExit39:
		sahf
		xor	al, dl
		lahf
		and	ah, 0ech	; Only these flags matter!
		xor	dh, dh	; Zero this...
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstaf:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		xor	al, al
		lahf
		and	ah, 0ech	; Only these flags matter!
		xor	dh, dh	; Zero this...
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstb0:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		or	al, ch
		lahf
		and	ah, 0ech ; No H, N, or C
		xor	dh, dh	; Zero this...
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstb1:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		or	al, cl
		lahf
		and	ah, 0ech ; No H, N, or C
		xor	dh, dh	; Zero this...
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstb2:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		or	al, byte [_z80de + 1]
		lahf
		and	ah, 0ech ; No H, N, or C
		xor	dh, dh	; Zero this...
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstb3:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		or	al, byte [_z80de]
		lahf
		and	ah, 0ech ; No H, N, or C
		xor	dh, dh	; Zero this...
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstb4:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		or	al, bh
		lahf
		and	ah, 0ech ; No H, N, or C
		xor	dh, dh	; Zero this...
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstb5:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		or	al, bl
		lahf
		and	ah, 0ech ; No H, N, or C
		xor	dh, dh	; Zero this...
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstb6:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop40:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead40
		cmp	bx, [edi]	; Are we smaller?
		jb		nextAddr40		; Yes, go to the next address
		cmp	bx, [edi+4]	; Are we bigger?
		jbe	callRoutine40

nextAddr40:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop40

callRoutine40:
		mov	dx, bx	; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit40

memoryRead40:
		mov	dl, [ebp + ebx]	; Get our data

readExit40:
		sahf
		or	al, dl
		lahf
		and	ah, 0ech ; No H, N, or C
		xor	dh, dh	; Zero this...
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstb7:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		or	al, al
		lahf
		and	ah, 0ech ; No H, N, or C
		xor	dh, dh	; Zero this...
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstb8:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		cmp	al, ch
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		or	ah, 02h	; Set N for compare!
		xor	dh, dh	; Zero this...
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstb9:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		cmp	al, cl
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		or	ah, 02h	; Set N for compare!
		xor	dh, dh	; Zero this...
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstba:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		cmp	al, byte [_z80de + 1]
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		or	ah, 02h	; Set N for compare!
		xor	dh, dh	; Zero this...
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstbb:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		cmp	al, byte [_z80de]
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		or	ah, 02h	; Set N for compare!
		xor	dh, dh	; Zero this...
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstbc:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		cmp	al, bh
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		or	ah, 02h	; Set N for compare!
		xor	dh, dh	; Zero this...
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstbd:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		cmp	al, bl
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		or	ah, 02h	; Set N for compare!
		xor	dh, dh	; Zero this...
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstbe:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop41:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead41
		cmp	bx, [edi]	; Are we smaller?
		jb		nextAddr41		; Yes, go to the next address
		cmp	bx, [edi+4]	; Are we bigger?
		jbe	callRoutine41

nextAddr41:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop41

callRoutine41:
		mov	dx, bx	; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit41

memoryRead41:
		mov	dl, [ebp + ebx]	; Get our data

readExit41:
		sahf
		cmp	al, dl
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		or	ah, 02h	; Set N for compare!
		xor	dh, dh	; Zero this...
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstbf:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		cmp	al, al
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		or	ah, 02h	; Set N for compare!
		xor	dh, dh	; Zero this...
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstc0:
		sub	dword [cyclesRemaining], byte 5
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 5
		sahf
		jnz	takeReturn42
		jmp	short retNotTaken42
takeReturn42:
		add	dword [dwElapsedTicks], 6
		sub	dword [cyclesRemaining], 6
		mov	dx, word [_z80sp]	; Get our current stack pointer
		mov	si, [edx+ebp]	; Get our return address
		and	esi, 0ffffh		; Only within 64K!
		add	esi, ebp			; Add in our base address
		add	word [_z80sp], 02h	; Remove our two bytes from the stack
		xor	dh, dh
retNotTaken42:
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstc1:
		sub	dword [cyclesRemaining], byte 10
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 10
		mov	dx, [_z80sp]
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop43:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead43
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr43		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine43

nextAddr43:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop43

callRoutine43:
		call	ReadMemoryByte	; Standard read routine
		mov	cl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit43

memoryRead43:
		mov	cl, [ebp + edx]	; Get our data

readExit43:
		inc	dx
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop44:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead44
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr44		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine44

nextAddr44:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop44

callRoutine44:
		call	ReadMemoryByte	; Standard read routine
		mov	ch, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit44

memoryRead44:
		mov	ch, [ebp + edx]	; Get our data

readExit44:
		add	word [_z80sp], 2
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstc2:
		sub	dword [cyclesRemaining], byte 10
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 10
		sahf		; Restore our flags
		jnz	takeJump45	; We're going to take a jump
		add	esi, 2		; Skip past the address
		jmp	short nextInst45	 ; Go execute the next instruction
takeJump45:
		add	dword [dwElapsedTicks], 7
		sub	dword [cyclesRemaining], 7
		mov	si, [esi]	; Get our new offset
		and	esi, 0ffffh	; Only the lower WORD is valid
		add	esi, ebp		; Our new address!
nextInst45:
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstc3:
		sub	dword [cyclesRemaining], byte 10
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 10
		mov	si, [esi]	; Get our new address
		and	esi, 0ffffh	; Only the lower 16 bits
		add	esi, ebp		; Our new address!
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstc4:
		sub	dword [cyclesRemaining], byte 10
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 10
		sahf		; Restore our flags
		jnz	takeJump46	; We're going call in this case
		add	esi, 2		; Skip past the address
		jmp	short noCallTaken46	 ; Go execute the next instruction
takeJump46:
		add	dword [dwElapsedTicks], 7
		sub	dword [cyclesRemaining], 7
		mov	dx, [esi]	; Get our call to address
		mov	[_z80pc], dx ; Store our new program counter
		add	esi, 2		; Skip to our new address to be pushed
		sub	esi, ebp		; Value to push onto the "stack"
		mov	dx, word [_z80sp] ; Get the current stack pointer
		sub	dx, 2		; Back up two bytes
		mov	[ebp+edx], si ; PUSH It!
		mov	word [_z80sp], dx	; Store our new stack pointer
		mov	si, [_z80pc] ; Get our new program counter
		add	esi, ebp		; Naturalize it!
		xor	dh, dh
noCallTaken46:
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstc5:
		sub	dword [cyclesRemaining], byte 11
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 11
		sub	word [_z80sp], 2
		mov	dx, [_z80sp]
		mov	[_z80af], ax	; Store AF
		mov	al, cl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop47:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite47	; Yes - go write it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr47	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine47	; If not, go call it!

nextAddr47:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop47

callRoutine47:
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit47
memoryWrite47:
		mov	[ebp + edx], cl
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit47:
		inc	dx
		mov	[_z80af], ax	; Store AF
		mov	al, ch	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop48:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite48	; Yes - go write it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr48	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine48	; If not, go call it!

nextAddr48:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop48

callRoutine48:
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit48
memoryWrite48:
		mov	[ebp + edx], ch
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit48:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstc6:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		sahf
		add	al, [esi]
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		xor	dh, dh
		and	ah, 0fdh ; Knock out N!
		inc	esi
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstc7:
		sub	dword [cyclesRemaining], byte 11
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 11
		mov	dx, word [_z80sp]	; Get our stack pointer
		sub	dx, 2		; Make room for the new value!
		mov	word [_z80sp], dx	; Store our new stack pointer
		sub	esi, ebp		; Get our real PC
		mov	[ebp+edx], si	; Our return address
		mov	si, 000h	; Our new call address
		add	esi, ebp	; Back to the base!
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstc8:
		sub	dword [cyclesRemaining], byte 5
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 5
		sahf
		jz	takeReturn49
		jmp	short retNotTaken49
takeReturn49:
		add	dword [dwElapsedTicks], 6
		sub	dword [cyclesRemaining], 6
		mov	dx, word [_z80sp]	; Get our current stack pointer
		mov	si, [edx+ebp]	; Get our return address
		and	esi, 0ffffh		; Only within 64K!
		add	esi, ebp			; Add in our base address
		add	word [_z80sp], 02h	; Remove our two bytes from the stack
		xor	dh, dh
retNotTaken49:
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstc9:
		sub	dword [cyclesRemaining], byte 10
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 10
		mov	dx, word [_z80sp]	; Get our current stack pointer
		mov	si, [edx+ebp]	; Get our return address
		and	esi, 0ffffh		; Only within 64K!
		add	esi, ebp			; Add in our base address
		add	word [_z80sp], 02h	; Remove our two bytes from the stack
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstca:
		sub	dword [cyclesRemaining], byte 10
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 10
		sahf		; Restore our flags
		jz	takeJump50	; We're going to take a jump
		add	esi, 2		; Skip past the address
		jmp	short nextInst50	 ; Go execute the next instruction
takeJump50:
		add	dword [dwElapsedTicks], 7
		sub	dword [cyclesRemaining], 7
		mov	si, [esi]	; Get our new offset
		and	esi, 0ffffh	; Only the lower WORD is valid
		add	esi, ebp		; Our new address!
nextInst50:
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]

;
; Handler for all CBxx instructions
;

times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstcb:
		mov	[_baseFixup], dword 1
		mov	dl, [esi]
		inc	esi
		jmp	dword [z80PrefixCB+edx*4]




times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstcc:
		sub	dword [cyclesRemaining], byte 10
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 10
		sahf		; Restore our flags
		jz	takeJump51	; We're going call in this case
		add	esi, 2		; Skip past the address
		jmp	short noCallTaken51	 ; Go execute the next instruction
takeJump51:
		add	dword [dwElapsedTicks], 7
		sub	dword [cyclesRemaining], 7
		mov	dx, [esi]	; Get our call to address
		mov	[_z80pc], dx ; Store our new program counter
		add	esi, 2		; Skip to our new address to be pushed
		sub	esi, ebp		; Value to push onto the "stack"
		mov	dx, word [_z80sp] ; Get the current stack pointer
		sub	dx, 2		; Back up two bytes
		mov	[ebp+edx], si ; PUSH It!
		mov	word [_z80sp], dx	; Store our new stack pointer
		mov	si, [_z80pc] ; Get our new program counter
		add	esi, ebp		; Naturalize it!
		xor	dh, dh
noCallTaken51:
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstcd:
		sub	dword [cyclesRemaining], byte 10
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 10
		mov	dx, [esi]	; Get our call to address
		mov	[_z80pc], dx ; Store our new program counter
		add	esi, 2		; Skip to our new address to be pushed
		sub	esi, ebp		; Value to push onto the "stack"
		mov	dx, word [_z80sp] ; Get the current stack pointer
		sub	dx, 2		; Back up two bytes
		mov	[ebp+edx], si ; PUSH It!
		mov	word [_z80sp], dx	; Store our new stack pointer
		mov	si, [_z80pc] ; Get our new program counter
		add	esi, ebp		; Naturalize it!
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstce:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		sahf
		adc	al, [esi]
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		xor	dh, dh
		and	ah, 0fdh ; Knock out N!
		inc	esi
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstcf:
		sub	dword [cyclesRemaining], byte 11
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 11
		mov	dx, word [_z80sp]	; Get our stack pointer
		sub	dx, 2		; Make room for the new value!
		mov	word [_z80sp], dx	; Store our new stack pointer
		sub	esi, ebp		; Get our real PC
		mov	[ebp+edx], si	; Our return address
		mov	si, 008h	; Our new call address
		add	esi, ebp	; Back to the base!
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstd0:
		sub	dword [cyclesRemaining], byte 5
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 5
		sahf
		jnc	takeReturn52
		jmp	short retNotTaken52
takeReturn52:
		add	dword [dwElapsedTicks], 6
		sub	dword [cyclesRemaining], 6
		mov	dx, word [_z80sp]	; Get our current stack pointer
		mov	si, [edx+ebp]	; Get our return address
		and	esi, 0ffffh		; Only within 64K!
		add	esi, ebp			; Add in our base address
		add	word [_z80sp], 02h	; Remove our two bytes from the stack
		xor	dh, dh
retNotTaken52:
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstd1:
		sub	dword [cyclesRemaining], byte 10
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 10
		mov	dx, [_z80sp]
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop53:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead53
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr53		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine53

nextAddr53:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop53

callRoutine53:
		call	ReadMemoryByte	; Standard read routine
		mov	byte [_z80de], al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit53

memoryRead53:
		mov	di, dx
		mov	dl, [ebp + edx]
		mov	byte [_z80de], dl
		mov	dx, di
readExit53:
		inc	dx
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop54:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead54
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr54		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine54

nextAddr54:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop54

callRoutine54:
		call	ReadMemoryByte	; Standard read routine
		mov	byte [_z80de + 1], al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit54

memoryRead54:
		mov	di, dx
		mov	dl, [ebp + edx]
		mov	byte [_z80de + 1], dl
		mov	dx, di
readExit54:
		add	word [_z80sp], 2
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstd2:
		sub	dword [cyclesRemaining], byte 10
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 10
		sahf		; Restore our flags
		jnc	takeJump55	; We're going to take a jump
		add	esi, 2		; Skip past the address
		jmp	short nextInst55	 ; Go execute the next instruction
takeJump55:
		add	dword [dwElapsedTicks], 7
		sub	dword [cyclesRemaining], 7
		mov	si, [esi]	; Get our new offset
		and	esi, 0ffffh	; Only the lower WORD is valid
		add	esi, ebp		; Our new address!
nextInst55:
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstd3:
		sub	dword [cyclesRemaining], byte 11
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 11
		mov	dl, [esi]	; Get our address to 'out' to
		inc	esi	; Next address
		mov	[_z80af], ax	; Store AF
		mov	edi, [_z80IoWrite]	; Point to the I/O write array

checkLoop56:
		cmp	[edi], word 0ffffh ; End of our list?
		je	WriteMacroExit56	; Yes - ignore it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr56	; Yes... go to the next addr
		cmp	dx, [edi+2]	; Are we bigger?
		jbe	callRoutine56	; If not, go call it!

nextAddr56:
		add	edi, 0ch		; Next structure, please
		jmp	short checkLoop56

callRoutine56:
		call	WriteIOByte	; Go write the data!
WriteMacroExit56:
		xor	dh, dh	; Make sure we don't hose things
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstd4:
		sub	dword [cyclesRemaining], byte 10
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 10
		sahf		; Restore our flags
		jnc	takeJump57	; We're going call in this case
		add	esi, 2		; Skip past the address
		jmp	short noCallTaken57	 ; Go execute the next instruction
takeJump57:
		add	dword [dwElapsedTicks], 7
		sub	dword [cyclesRemaining], 7
		mov	dx, [esi]	; Get our call to address
		mov	[_z80pc], dx ; Store our new program counter
		add	esi, 2		; Skip to our new address to be pushed
		sub	esi, ebp		; Value to push onto the "stack"
		mov	dx, word [_z80sp] ; Get the current stack pointer
		sub	dx, 2		; Back up two bytes
		mov	[ebp+edx], si ; PUSH It!
		mov	word [_z80sp], dx	; Store our new stack pointer
		mov	si, [_z80pc] ; Get our new program counter
		add	esi, ebp		; Naturalize it!
		xor	dh, dh
noCallTaken57:
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstd5:
		sub	dword [cyclesRemaining], byte 11
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 11
		sub	word [_z80sp], 2
		mov	dx, [_z80sp]
		mov	[_z80af], ax	; Store AF
		mov	al, byte [_z80de]	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop58:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite58	; Yes - go write it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr58	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine58	; If not, go call it!

nextAddr58:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop58

callRoutine58:
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit58
memoryWrite58:
		mov	edi, edx
		mov	dl, byte [_z80de]
		mov	[ebp + edi], dl
		mov	edx, edi
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit58:
		inc	dx
		mov	[_z80af], ax	; Store AF
		mov	al, byte [_z80de + 1]	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop59:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite59	; Yes - go write it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr59	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine59	; If not, go call it!

nextAddr59:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop59

callRoutine59:
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit59
memoryWrite59:
		mov	edi, edx
		mov	dl, byte [_z80de + 1]
		mov	[ebp + edi], dl
		mov	edx, edi
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit59:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstd6:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		sahf
		sub	al, [esi]
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		xor	dh, dh
		or	ah, 02h	; Set negative!
		inc	esi
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstd7:
		sub	dword [cyclesRemaining], byte 11
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 11
		mov	dx, word [_z80sp]	; Get our stack pointer
		sub	dx, 2		; Make room for the new value!
		mov	word [_z80sp], dx	; Store our new stack pointer
		sub	esi, ebp		; Get our real PC
		mov	[ebp+edx], si	; Our return address
		mov	si, 010h	; Our new call address
		add	esi, ebp	; Back to the base!
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstd8:
		sub	dword [cyclesRemaining], byte 5
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 5
		sahf
		jc	takeReturn60
		jmp	short retNotTaken60
takeReturn60:
		add	dword [dwElapsedTicks], 6
		sub	dword [cyclesRemaining], 6
		mov	dx, word [_z80sp]	; Get our current stack pointer
		mov	si, [edx+ebp]	; Get our return address
		and	esi, 0ffffh		; Only within 64K!
		add	esi, ebp			; Add in our base address
		add	word [_z80sp], 02h	; Remove our two bytes from the stack
		xor	dh, dh
retNotTaken60:
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstd9:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	di, [_z80de]
		xchg	cx, [_z80bcprime]
		xchg	di, [_z80deprime]
		xchg	bx, [_z80hlprime]
		mov	[_z80de], di
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstda:
		sub	dword [cyclesRemaining], byte 10
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 10
		sahf		; Restore our flags
		jc	takeJump61	; We're going to take a jump
		add	esi, 2		; Skip past the address
		jmp	short nextInst61	 ; Go execute the next instruction
takeJump61:
		add	dword [dwElapsedTicks], 7
		sub	dword [cyclesRemaining], 7
		mov	si, [esi]	; Get our new offset
		and	esi, 0ffffh	; Only the lower WORD is valid
		add	esi, ebp		; Our new address!
nextInst61:
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstdb:
		sub	dword [cyclesRemaining], byte 11
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 11
		mov	dl, [esi]	; Get our address to 'out' to
		inc	esi	; Next address
		mov	edi, [_z80IoRead]	; Point to the read array

checkLoop62:
		cmp	[edi], word 0ffffh ; End of the list?
		je		ioRead62
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr62		; Yes, go to the next address
		cmp	dx, [edi+2]	; Are we bigger?
		jbe	callRoutine62

nextAddr62:
		add	edi, 0ch		; Next structure!
		jmp	short checkLoop62

callRoutine62:
		call	ReadIOByte	; Standard read routine
		mov	[_z80af], al	; Save our new accumulator
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit62

ioRead62:
		mov	al, 0ffh	; An unreferenced read
readExit62:
		xor	dh, dh	; Make sure we don't hose things
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstdc:
		sub	dword [cyclesRemaining], byte 10
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 10
		sahf		; Restore our flags
		jc	takeJump63	; We're going call in this case
		add	esi, 2		; Skip past the address
		jmp	short noCallTaken63	 ; Go execute the next instruction
takeJump63:
		add	dword [dwElapsedTicks], 7
		sub	dword [cyclesRemaining], 7
		mov	dx, [esi]	; Get our call to address
		mov	[_z80pc], dx ; Store our new program counter
		add	esi, 2		; Skip to our new address to be pushed
		sub	esi, ebp		; Value to push onto the "stack"
		mov	dx, word [_z80sp] ; Get the current stack pointer
		sub	dx, 2		; Back up two bytes
		mov	[ebp+edx], si ; PUSH It!
		mov	word [_z80sp], dx	; Store our new stack pointer
		mov	si, [_z80pc] ; Get our new program counter
		add	esi, ebp		; Naturalize it!
		xor	dh, dh
noCallTaken63:
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]

;
; Handler for all DDxx instructions
;

times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstdd:
		mov	[_baseFixup], dword 1
		mov	dl, [esi]
		inc	esi
		jmp	dword [z80PrefixDD+edx*4]




times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstde:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		sahf
		sbb	al, [esi]
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		xor	dh, dh
		or	ah, 02h	; Set negative!
		inc	esi
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstdf:
		sub	dword [cyclesRemaining], byte 11
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 11
		mov	dx, word [_z80sp]	; Get our stack pointer
		sub	dx, 2		; Make room for the new value!
		mov	word [_z80sp], dx	; Store our new stack pointer
		sub	esi, ebp		; Get our real PC
		mov	[ebp+edx], si	; Our return address
		mov	si, 018h	; Our new call address
		add	esi, ebp	; Back to the base!
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInste0:
		sub	dword [cyclesRemaining], byte 5
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 5
		sahf
		jpo	takeReturn64
		jmp	short retNotTaken64
takeReturn64:
		add	dword [dwElapsedTicks], 6
		sub	dword [cyclesRemaining], 6
		mov	dx, word [_z80sp]	; Get our current stack pointer
		mov	si, [edx+ebp]	; Get our return address
		and	esi, 0ffffh		; Only within 64K!
		add	esi, ebp			; Add in our base address
		add	word [_z80sp], 02h	; Remove our two bytes from the stack
		xor	dh, dh
retNotTaken64:
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInste1:
		sub	dword [cyclesRemaining], byte 10
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 10
		mov	dx, [_z80sp]
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop65:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead65
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr65		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine65

nextAddr65:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop65

callRoutine65:
		call	ReadMemoryByte	; Standard read routine
		mov	bl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit65

memoryRead65:
		mov	bl, [ebp + edx]	; Get our data

readExit65:
		inc	dx
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop66:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead66
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr66		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine66

nextAddr66:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop66

callRoutine66:
		call	ReadMemoryByte	; Standard read routine
		mov	bh, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit66

memoryRead66:
		mov	bh, [ebp + edx]	; Get our data

readExit66:
		add	word [_z80sp], 2
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInste2:
		sub	dword [cyclesRemaining], byte 10
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 10
		sahf		; Restore our flags
		jpo	takeJump67	; We're going to take a jump
		add	esi, 2		; Skip past the address
		jmp	short nextInst67	 ; Go execute the next instruction
takeJump67:
		add	dword [dwElapsedTicks], 7
		sub	dword [cyclesRemaining], 7
		mov	si, [esi]	; Get our new offset
		and	esi, 0ffffh	; Only the lower WORD is valid
		add	esi, ebp		; Our new address!
nextInst67:
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInste3:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 19
		mov	dx, word [_z80sp]
		xchg	bx, [ebp+edx]
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInste4:
		sub	dword [cyclesRemaining], byte 10
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 10
		sahf		; Restore our flags
		jpo	takeJump68	; We're going call in this case
		add	esi, 2		; Skip past the address
		jmp	short noCallTaken68	 ; Go execute the next instruction
takeJump68:
		add	dword [dwElapsedTicks], 7
		sub	dword [cyclesRemaining], 7
		mov	dx, [esi]	; Get our call to address
		mov	[_z80pc], dx ; Store our new program counter
		add	esi, 2		; Skip to our new address to be pushed
		sub	esi, ebp		; Value to push onto the "stack"
		mov	dx, word [_z80sp] ; Get the current stack pointer
		sub	dx, 2		; Back up two bytes
		mov	[ebp+edx], si ; PUSH It!
		mov	word [_z80sp], dx	; Store our new stack pointer
		mov	si, [_z80pc] ; Get our new program counter
		add	esi, ebp		; Naturalize it!
		xor	dh, dh
noCallTaken68:
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInste5:
		sub	dword [cyclesRemaining], byte 11
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 11
		sub	word [_z80sp], 2
		mov	dx, [_z80sp]
		mov	[_z80af], ax	; Store AF
		mov	al, bl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop69:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite69	; Yes - go write it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr69	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine69	; If not, go call it!

nextAddr69:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop69

callRoutine69:
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit69
memoryWrite69:
		mov	[ebp + edx], bl
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit69:
		inc	dx
		mov	[_z80af], ax	; Store AF
		mov	al, bh	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop70:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite70	; Yes - go write it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr70	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine70	; If not, go call it!

nextAddr70:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop70

callRoutine70:
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit70
memoryWrite70:
		mov	[ebp + edx], bh
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit70:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInste6:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		sahf
		and	al, [esi]
		lahf
		and	ah, 0ech ; Only parity, half carry, sign, zero
		or	ah, 10h	; Half carry
		inc	esi
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInste7:
		sub	dword [cyclesRemaining], byte 11
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 11
		mov	dx, word [_z80sp]	; Get our stack pointer
		sub	dx, 2		; Make room for the new value!
		mov	word [_z80sp], dx	; Store our new stack pointer
		sub	esi, ebp		; Get our real PC
		mov	[ebp+edx], si	; Our return address
		mov	si, 020h	; Our new call address
		add	esi, ebp	; Back to the base!
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInste8:
		sub	dword [cyclesRemaining], byte 5
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 5
		sahf
		jpe	takeReturn71
		jmp	short retNotTaken71
takeReturn71:
		add	dword [dwElapsedTicks], 6
		sub	dword [cyclesRemaining], 6
		mov	dx, word [_z80sp]	; Get our current stack pointer
		mov	si, [edx+ebp]	; Get our return address
		and	esi, 0ffffh		; Only within 64K!
		add	esi, ebp			; Add in our base address
		add	word [_z80sp], 02h	; Remove our two bytes from the stack
		xor	dh, dh
retNotTaken71:
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInste9:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	si, bx
		and	esi, 0ffffh
		add	esi, ebp
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstea:
		sub	dword [cyclesRemaining], byte 10
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 10
		sahf		; Restore our flags
		jpe	takeJump72	; We're going to take a jump
		add	esi, 2		; Skip past the address
		jmp	short nextInst72	 ; Go execute the next instruction
takeJump72:
		add	dword [dwElapsedTicks], 7
		sub	dword [cyclesRemaining], 7
		mov	si, [esi]	; Get our new offset
		and	esi, 0ffffh	; Only the lower WORD is valid
		add	esi, ebp		; Our new address!
nextInst72:
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInsteb:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		xchg	[_z80de], bx	; Exchange DE & HL
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstec:
		sub	dword [cyclesRemaining], byte 10
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 10
		sahf		; Restore our flags
		jpe	takeJump73	; We're going call in this case
		add	esi, 2		; Skip past the address
		jmp	short noCallTaken73	 ; Go execute the next instruction
takeJump73:
		add	dword [dwElapsedTicks], 7
		sub	dword [cyclesRemaining], 7
		mov	dx, [esi]	; Get our call to address
		mov	[_z80pc], dx ; Store our new program counter
		add	esi, 2		; Skip to our new address to be pushed
		sub	esi, ebp		; Value to push onto the "stack"
		mov	dx, word [_z80sp] ; Get the current stack pointer
		sub	dx, 2		; Back up two bytes
		mov	[ebp+edx], si ; PUSH It!
		mov	word [_z80sp], dx	; Store our new stack pointer
		mov	si, [_z80pc] ; Get our new program counter
		add	esi, ebp		; Naturalize it!
		xor	dh, dh
noCallTaken73:
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]

;
; Handler for all EDxx instructions
;

times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInsted:
		mov	[_baseFixup], dword 1
		mov	dl, [esi]
		inc	esi
		jmp	dword [z80PrefixED+edx*4]




times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstee:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		sahf
		xor	al, [esi]
		lahf
		and	ah, 0ech	; No H, N, or C
		inc	esi
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstef:
		sub	dword [cyclesRemaining], byte 11
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 11
		mov	dx, word [_z80sp]	; Get our stack pointer
		sub	dx, 2		; Make room for the new value!
		mov	word [_z80sp], dx	; Store our new stack pointer
		sub	esi, ebp		; Get our real PC
		mov	[ebp+edx], si	; Our return address
		mov	si, 028h	; Our new call address
		add	esi, ebp	; Back to the base!
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstf0:
		sub	dword [cyclesRemaining], byte 5
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 5
		sahf
		jns	takeReturn74
		jmp	short retNotTaken74
takeReturn74:
		add	dword [dwElapsedTicks], 6
		sub	dword [cyclesRemaining], 6
		mov	dx, word [_z80sp]	; Get our current stack pointer
		mov	si, [edx+ebp]	; Get our return address
		and	esi, 0ffffh		; Only within 64K!
		add	esi, ebp			; Add in our base address
		add	word [_z80sp], 02h	; Remove our two bytes from the stack
		xor	dh, dh
retNotTaken74:
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstf1:
		sub	dword [cyclesRemaining], byte 10
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 10
		mov	dx, [_z80sp]
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop75:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead75
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr75		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine75

nextAddr75:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop75

callRoutine75:
		call	ReadMemoryByte	; Standard read routine
		mov	[_z80af + 1], al	; Save our new flags
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit75

memoryRead75:
		mov	ah, [ebp + edx]	; Get our data

readExit75:
		inc	dx
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop76:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead76
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr76		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine76

nextAddr76:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop76

callRoutine76:
		call	ReadMemoryByte	; Standard read routine
		mov	[_z80af], al	; Save our new accumulator
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit76

memoryRead76:
		mov	al, [ebp + edx]	; Get our data

readExit76:
		add	word [_z80sp], 2
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstf2:
		sub	dword [cyclesRemaining], byte 10
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 10
		sahf		; Restore our flags
		jns	takeJump77	; We're going to take a jump
		add	esi, 2		; Skip past the address
		jmp	short nextInst77	 ; Go execute the next instruction
takeJump77:
		add	dword [dwElapsedTicks], 7
		sub	dword [cyclesRemaining], 7
		mov	si, [esi]	; Get our new offset
		and	esi, 0ffffh	; Only the lower WORD is valid
		add	esi, ebp		; Our new address!
nextInst77:
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstf3:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	dword [_z80interruptState], 0	; Interrupts disabled now
		mov	dword [_z80inInterrupt], 0	; Not in an interrupt
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstf4:
		sub	dword [cyclesRemaining], byte 10
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 10
		sahf		; Restore our flags
		jns	takeJump78	; We're going call in this case
		add	esi, 2		; Skip past the address
		jmp	short noCallTaken78	 ; Go execute the next instruction
takeJump78:
		add	dword [dwElapsedTicks], 7
		sub	dword [cyclesRemaining], 7
		mov	dx, [esi]	; Get our call to address
		mov	[_z80pc], dx ; Store our new program counter
		add	esi, 2		; Skip to our new address to be pushed
		sub	esi, ebp		; Value to push onto the "stack"
		mov	dx, word [_z80sp] ; Get the current stack pointer
		sub	dx, 2		; Back up two bytes
		mov	[ebp+edx], si ; PUSH It!
		mov	word [_z80sp], dx	; Store our new stack pointer
		mov	si, [_z80pc] ; Get our new program counter
		add	esi, ebp		; Naturalize it!
		xor	dh, dh
noCallTaken78:
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstf5:
		sub	dword [cyclesRemaining], byte 11
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 11
		sub	word [_z80sp], 2
		mov	dx, [_z80sp]
		mov	[_z80af], ax	; Store AF
		mov	al, ah	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop79:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite79	; Yes - go write it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr79	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine79	; If not, go call it!

nextAddr79:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop79

callRoutine79:
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit79
memoryWrite79:
		mov	[ebp + edx], ah
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit79:
		inc	dx
		mov	[_z80af], ax	; Store AF
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop80:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite80	; Yes - go write it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr80	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine80	; If not, go call it!

nextAddr80:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop80

callRoutine80:
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit80
memoryWrite80:
		mov	[ebp + edx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit80:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstf6:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		sahf
		or	al, [esi]
		lahf
		and	ah, 0ech	; No H, N, or C
		inc	esi
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstf7:
		sub	dword [cyclesRemaining], byte 11
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 11
		mov	dx, word [_z80sp]	; Get our stack pointer
		sub	dx, 2		; Make room for the new value!
		mov	word [_z80sp], dx	; Store our new stack pointer
		sub	esi, ebp		; Get our real PC
		mov	[ebp+edx], si	; Our return address
		mov	si, 030h	; Our new call address
		add	esi, ebp	; Back to the base!
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstf8:
		sub	dword [cyclesRemaining], byte 5
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 5
		sahf
		js	takeReturn81
		jmp	short retNotTaken81
takeReturn81:
		add	dword [dwElapsedTicks], 6
		sub	dword [cyclesRemaining], 6
		mov	dx, word [_z80sp]	; Get our current stack pointer
		mov	si, [edx+ebp]	; Get our return address
		and	esi, 0ffffh		; Only within 64K!
		add	esi, ebp			; Add in our base address
		add	word [_z80sp], 02h	; Remove our two bytes from the stack
		xor	dh, dh
retNotTaken81:
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstf9:
		sub	dword [cyclesRemaining], byte 6
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 6
		mov	word [_z80sp], bx
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstfa:
		sub	dword [cyclesRemaining], byte 10
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 10
		sahf		; Restore our flags
		js	takeJump82	; We're going to take a jump
		add	esi, 2		; Skip past the address
		jmp	short nextInst82	 ; Go execute the next instruction
takeJump82:
		add	dword [dwElapsedTicks], 7
		sub	dword [cyclesRemaining], 7
		mov	si, [esi]	; Get our new offset
		and	esi, 0ffffh	; Only the lower WORD is valid
		add	esi, ebp		; Our new address!
nextInst82:
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstfb:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	dword [_z80interruptState], 1	; Interrupts enabled now
		mov	dword [_z80inInterrupt], 0	; Not in an interrupt
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstfc:
		sub	dword [cyclesRemaining], byte 10
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 10
		sahf		; Restore our flags
		js	takeJump83	; We're going call in this case
		add	esi, 2		; Skip past the address
		jmp	short noCallTaken83	 ; Go execute the next instruction
takeJump83:
		add	dword [dwElapsedTicks], 7
		sub	dword [cyclesRemaining], 7
		mov	dx, [esi]	; Get our call to address
		mov	[_z80pc], dx ; Store our new program counter
		add	esi, 2		; Skip to our new address to be pushed
		sub	esi, ebp		; Value to push onto the "stack"
		mov	dx, word [_z80sp] ; Get the current stack pointer
		sub	dx, 2		; Back up two bytes
		mov	[ebp+edx], si ; PUSH It!
		mov	word [_z80sp], dx	; Store our new stack pointer
		mov	si, [_z80pc] ; Get our new program counter
		add	esi, ebp		; Naturalize it!
		xor	dh, dh
noCallTaken83:
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]

;
; Handler for all FDxx instructions
;

times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstfd:
		mov	[_baseFixup], dword 1
		mov	dl, [esi]
		inc	esi
		jmp	dword [z80PrefixFD+edx*4]




times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstfe:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		sahf
		cmp	al, [esi]
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		xor	dh, dh
		or	ah, 02h	; Set negative!
		inc	esi
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstff:
		sub	dword [cyclesRemaining], byte 11
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 11
		mov	dx, word [_z80sp]	; Get our stack pointer
		sub	dx, 2		; Make room for the new value!
		mov	word [_z80sp], dx	; Store our new stack pointer
		sub	esi, ebp		; Get our real PC
		mov	[ebp+edx], si	; Our return address
		mov	si, 038h	; Our new call address
		add	esi, ebp	; Back to the base!
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst00:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		sahf
		rol	ch, 1
		lahf
		and	ah, 029h	; Clear H and N
		mov	byte [_z80af], ah
		or	ch, ch
		lahf
		and	ah, 0c4h	; Sign, zero, and parity
		or	ah, byte [_z80af]
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst01:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		sahf
		rol	cl, 1
		lahf
		and	ah, 029h	; Clear H and N
		mov	byte [_z80af], ah
		or	cl, cl
		lahf
		and	ah, 0c4h	; Sign, zero, and parity
		or	ah, byte [_z80af]
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst02:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		sahf
		rol	dh, 1
		lahf
		and	ah, 029h	; Clear H and N
		mov	byte [_z80af], ah
		or	dh, dh
		lahf
		and	ah, 0c4h	; Sign, zero, and parity
		or	ah, byte [_z80af]
		mov	[_z80de], dx	; Once modified, put it back
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst03:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		sahf
		rol	dl, 1
		lahf
		and	ah, 029h	; Clear H and N
		mov	byte [_z80af], ah
		or	dl, dl
		lahf
		and	ah, 0c4h	; Sign, zero, and parity
		or	ah, byte [_z80af]
		mov	[_z80de], dx	; Once modified, put it back
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst04:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		sahf
		rol	bh, 1
		lahf
		and	ah, 029h	; Clear H and N
		mov	byte [_z80af], ah
		or	bh, bh
		lahf
		and	ah, 0c4h	; Sign, zero, and parity
		or	ah, byte [_z80af]
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst05:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		sahf
		rol	bl, 1
		lahf
		and	ah, 029h	; Clear H and N
		mov	byte [_z80af], ah
		or	bl, bl
		lahf
		and	ah, 0c4h	; Sign, zero, and parity
		or	ah, byte [_z80af]
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst06:
		sub	dword [cyclesRemaining], byte 15
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 15
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop84:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead84
		cmp	bx, [edi]	; Are we smaller?
		jb		nextAddr84		; Yes, go to the next address
		cmp	bx, [edi+4]	; Are we bigger?
		jbe	callRoutine84

nextAddr84:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop84

callRoutine84:
		mov	dx, bx	; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit84

memoryRead84:
		mov	dl, [ebp + ebx]	; Get our data

readExit84:
		sahf
		rol	dl, 1
		lahf
		and	ah, 029h	; Clear H and N
		mov	byte [_z80af], ah
		or	dl, dl
		lahf
		and	ah, 0c4h	; Sign, zero, and parity
		or	ah, byte [_z80af]
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop85:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite85	; Yes - go write it!
		cmp	bx, [edi]	; Are we smaller?
		jb	nextAddr85	; Yes... go to the next addr
		cmp	bx, [edi+4]	; Are we smaller?
		jbe	callRoutine85	; If not, go call it!

nextAddr85:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop85

callRoutine85:
		mov	dx, bx	; Get our address to target
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit85
memoryWrite85:
		mov	[ebp + ebx], dl
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit85:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst07:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		sahf
		rol	al, 1
		lahf
		and	ah, 029h	; Clear H and N
		mov	byte [_z80af], ah
		or	al, al
		lahf
		and	ah, 0c4h	; Sign, zero, and parity
		or	ah, byte [_z80af]
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst08:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		sahf
		ror	ch, 1
		lahf
		and	ah, 029h	; Clear H and N
		mov	byte [_z80af], ah
		or	ch, ch
		lahf
		and	ah, 0c4h	; Sign, zero, and parity
		or	ah, byte [_z80af]
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst09:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		sahf
		ror	cl, 1
		lahf
		and	ah, 029h	; Clear H and N
		mov	byte [_z80af], ah
		or	cl, cl
		lahf
		and	ah, 0c4h	; Sign, zero, and parity
		or	ah, byte [_z80af]
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst0a:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		sahf
		ror	dh, 1
		lahf
		and	ah, 029h	; Clear H and N
		mov	byte [_z80af], ah
		or	dh, dh
		lahf
		and	ah, 0c4h	; Sign, zero, and parity
		or	ah, byte [_z80af]
		mov	[_z80de], dx	; Once modified, put it back
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst0b:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		sahf
		ror	dl, 1
		lahf
		and	ah, 029h	; Clear H and N
		mov	byte [_z80af], ah
		or	dl, dl
		lahf
		and	ah, 0c4h	; Sign, zero, and parity
		or	ah, byte [_z80af]
		mov	[_z80de], dx	; Once modified, put it back
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst0c:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		sahf
		ror	bh, 1
		lahf
		and	ah, 029h	; Clear H and N
		mov	byte [_z80af], ah
		or	bh, bh
		lahf
		and	ah, 0c4h	; Sign, zero, and parity
		or	ah, byte [_z80af]
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst0d:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		sahf
		ror	bl, 1
		lahf
		and	ah, 029h	; Clear H and N
		mov	byte [_z80af], ah
		or	bl, bl
		lahf
		and	ah, 0c4h	; Sign, zero, and parity
		or	ah, byte [_z80af]
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst0e:
		sub	dword [cyclesRemaining], byte 15
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 15
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop86:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead86
		cmp	bx, [edi]	; Are we smaller?
		jb		nextAddr86		; Yes, go to the next address
		cmp	bx, [edi+4]	; Are we bigger?
		jbe	callRoutine86

nextAddr86:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop86

callRoutine86:
		mov	dx, bx	; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit86

memoryRead86:
		mov	dl, [ebp + ebx]	; Get our data

readExit86:
		sahf
		ror	dl, 1
		lahf
		and	ah, 029h	; Clear H and N
		mov	byte [_z80af], ah
		or	dl, dl
		lahf
		and	ah, 0c4h	; Sign, zero, and parity
		or	ah, byte [_z80af]
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop87:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite87	; Yes - go write it!
		cmp	bx, [edi]	; Are we smaller?
		jb	nextAddr87	; Yes... go to the next addr
		cmp	bx, [edi+4]	; Are we smaller?
		jbe	callRoutine87	; If not, go call it!

nextAddr87:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop87

callRoutine87:
		mov	dx, bx	; Get our address to target
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit87
memoryWrite87:
		mov	[ebp + ebx], dl
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit87:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst0f:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		sahf
		ror	al, 1
		lahf
		and	ah, 029h	; Clear H and N
		mov	byte [_z80af], ah
		or	al, al
		lahf
		and	ah, 0c4h	; Sign, zero, and parity
		or	ah, byte [_z80af]
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst10:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		sahf
		rcl	ch, 1
		lahf
		and	ah, 029h	; Clear H and N
		mov	byte [_z80af], ah
		or	ch, ch
		lahf
		and	ah, 0c4h	; Sign, zero, and parity
		or	ah, byte [_z80af]
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst11:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		sahf
		rcl	cl, 1
		lahf
		and	ah, 029h	; Clear H and N
		mov	byte [_z80af], ah
		or	cl, cl
		lahf
		and	ah, 0c4h	; Sign, zero, and parity
		or	ah, byte [_z80af]
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst12:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		sahf
		rcl	dh, 1
		lahf
		and	ah, 029h	; Clear H and N
		mov	byte [_z80af], ah
		or	dh, dh
		lahf
		and	ah, 0c4h	; Sign, zero, and parity
		or	ah, byte [_z80af]
		mov	[_z80de], dx	; Once modified, put it back
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst13:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		sahf
		rcl	dl, 1
		lahf
		and	ah, 029h	; Clear H and N
		mov	byte [_z80af], ah
		or	dl, dl
		lahf
		and	ah, 0c4h	; Sign, zero, and parity
		or	ah, byte [_z80af]
		mov	[_z80de], dx	; Once modified, put it back
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst14:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		sahf
		rcl	bh, 1
		lahf
		and	ah, 029h	; Clear H and N
		mov	byte [_z80af], ah
		or	bh, bh
		lahf
		and	ah, 0c4h	; Sign, zero, and parity
		or	ah, byte [_z80af]
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst15:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		sahf
		rcl	bl, 1
		lahf
		and	ah, 029h	; Clear H and N
		mov	byte [_z80af], ah
		or	bl, bl
		lahf
		and	ah, 0c4h	; Sign, zero, and parity
		or	ah, byte [_z80af]
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst16:
		sub	dword [cyclesRemaining], byte 15
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 15
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop88:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead88
		cmp	bx, [edi]	; Are we smaller?
		jb		nextAddr88		; Yes, go to the next address
		cmp	bx, [edi+4]	; Are we bigger?
		jbe	callRoutine88

nextAddr88:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop88

callRoutine88:
		mov	dx, bx	; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit88

memoryRead88:
		mov	dl, [ebp + ebx]	; Get our data

readExit88:
		sahf
		rcl	dl, 1
		lahf
		and	ah, 029h	; Clear H and N
		mov	byte [_z80af], ah
		or	dl, dl
		lahf
		and	ah, 0c4h	; Sign, zero, and parity
		or	ah, byte [_z80af]
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop89:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite89	; Yes - go write it!
		cmp	bx, [edi]	; Are we smaller?
		jb	nextAddr89	; Yes... go to the next addr
		cmp	bx, [edi+4]	; Are we smaller?
		jbe	callRoutine89	; If not, go call it!

nextAddr89:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop89

callRoutine89:
		mov	dx, bx	; Get our address to target
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit89
memoryWrite89:
		mov	[ebp + ebx], dl
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit89:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst17:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		sahf
		rcl	al, 1
		lahf
		and	ah, 029h	; Clear H and N
		mov	byte [_z80af], ah
		or	al, al
		lahf
		and	ah, 0c4h	; Sign, zero, and parity
		or	ah, byte [_z80af]
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst18:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		sahf
		rcr	ch, 1
		lahf
		and	ah, 029h	; Clear H and N
		mov	byte [_z80af], ah
		or	ch, ch
		lahf
		and	ah, 0c4h	; Sign, zero, and parity
		or	ah, byte [_z80af]
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst19:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		sahf
		rcr	cl, 1
		lahf
		and	ah, 029h	; Clear H and N
		mov	byte [_z80af], ah
		or	cl, cl
		lahf
		and	ah, 0c4h	; Sign, zero, and parity
		or	ah, byte [_z80af]
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst1a:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		sahf
		rcr	dh, 1
		lahf
		and	ah, 029h	; Clear H and N
		mov	byte [_z80af], ah
		or	dh, dh
		lahf
		and	ah, 0c4h	; Sign, zero, and parity
		or	ah, byte [_z80af]
		mov	[_z80de], dx	; Once modified, put it back
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst1b:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		sahf
		rcr	dl, 1
		lahf
		and	ah, 029h	; Clear H and N
		mov	byte [_z80af], ah
		or	dl, dl
		lahf
		and	ah, 0c4h	; Sign, zero, and parity
		or	ah, byte [_z80af]
		mov	[_z80de], dx	; Once modified, put it back
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst1c:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		sahf
		rcr	bh, 1
		lahf
		and	ah, 029h	; Clear H and N
		mov	byte [_z80af], ah
		or	bh, bh
		lahf
		and	ah, 0c4h	; Sign, zero, and parity
		or	ah, byte [_z80af]
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst1d:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		sahf
		rcr	bl, 1
		lahf
		and	ah, 029h	; Clear H and N
		mov	byte [_z80af], ah
		or	bl, bl
		lahf
		and	ah, 0c4h	; Sign, zero, and parity
		or	ah, byte [_z80af]
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst1e:
		sub	dword [cyclesRemaining], byte 15
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 15
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop90:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead90
		cmp	bx, [edi]	; Are we smaller?
		jb		nextAddr90		; Yes, go to the next address
		cmp	bx, [edi+4]	; Are we bigger?
		jbe	callRoutine90

nextAddr90:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop90

callRoutine90:
		mov	dx, bx	; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit90

memoryRead90:
		mov	dl, [ebp + ebx]	; Get our data

readExit90:
		sahf
		rcr	dl, 1
		lahf
		and	ah, 029h	; Clear H and N
		mov	byte [_z80af], ah
		or	dl, dl
		lahf
		and	ah, 0c4h	; Sign, zero, and parity
		or	ah, byte [_z80af]
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop91:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite91	; Yes - go write it!
		cmp	bx, [edi]	; Are we smaller?
		jb	nextAddr91	; Yes... go to the next addr
		cmp	bx, [edi+4]	; Are we smaller?
		jbe	callRoutine91	; If not, go call it!

nextAddr91:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop91

callRoutine91:
		mov	dx, bx	; Get our address to target
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit91
memoryWrite91:
		mov	[ebp + ebx], dl
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit91:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst1f:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		sahf
		rcr	al, 1
		lahf
		and	ah, 029h	; Clear H and N
		mov	byte [_z80af], ah
		or	al, al
		lahf
		and	ah, 0c4h	; Sign, zero, and parity
		or	ah, byte [_z80af]
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst20:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		sahf
		shl	ch, 1
		lahf
		and	ah, 0edh	; Clear H and N
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst21:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		sahf
		shl	cl, 1
		lahf
		and	ah, 0edh	; Clear H and N
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst22:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		sahf
		shl	dh, 1
		lahf
		and	ah, 0edh	; Clear H and N
		mov	[_z80de], dx	; Once modified, put it back
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst23:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		sahf
		shl	dl, 1
		lahf
		and	ah, 0edh	; Clear H and N
		mov	[_z80de], dx	; Once modified, put it back
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst24:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		sahf
		shl	bh, 1
		lahf
		and	ah, 0edh	; Clear H and N
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst25:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		sahf
		shl	bl, 1
		lahf
		and	ah, 0edh	; Clear H and N
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst26:
		sub	dword [cyclesRemaining], byte 15
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 15
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop92:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead92
		cmp	bx, [edi]	; Are we smaller?
		jb		nextAddr92		; Yes, go to the next address
		cmp	bx, [edi+4]	; Are we bigger?
		jbe	callRoutine92

nextAddr92:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop92

callRoutine92:
		mov	dx, bx	; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit92

memoryRead92:
		mov	dl, [ebp + ebx]	; Get our data

readExit92:
		sahf
		shl	dl, 1
		lahf
		and	ah, 0edh	; Clear H and N
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop93:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite93	; Yes - go write it!
		cmp	bx, [edi]	; Are we smaller?
		jb	nextAddr93	; Yes... go to the next addr
		cmp	bx, [edi+4]	; Are we smaller?
		jbe	callRoutine93	; If not, go call it!

nextAddr93:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop93

callRoutine93:
		mov	dx, bx	; Get our address to target
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit93
memoryWrite93:
		mov	[ebp + ebx], dl
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit93:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst27:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		sahf
		shl	al, 1
		lahf
		and	ah, 0edh	; Clear H and N
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst28:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		sahf
		sar	ch, 1
		lahf
		and	ah, 0edh	; Clear H and N
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst29:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		sahf
		sar	cl, 1
		lahf
		and	ah, 0edh	; Clear H and N
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst2a:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		sahf
		sar	dh, 1
		lahf
		and	ah, 0edh	; Clear H and N
		mov	[_z80de], dx	; Once modified, put it back
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst2b:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		sahf
		sar	dl, 1
		lahf
		and	ah, 0edh	; Clear H and N
		mov	[_z80de], dx	; Once modified, put it back
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst2c:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		sahf
		sar	bh, 1
		lahf
		and	ah, 0edh	; Clear H and N
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst2d:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		sahf
		sar	bl, 1
		lahf
		and	ah, 0edh	; Clear H and N
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst2e:
		sub	dword [cyclesRemaining], byte 15
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 15
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop94:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead94
		cmp	bx, [edi]	; Are we smaller?
		jb		nextAddr94		; Yes, go to the next address
		cmp	bx, [edi+4]	; Are we bigger?
		jbe	callRoutine94

nextAddr94:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop94

callRoutine94:
		mov	dx, bx	; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit94

memoryRead94:
		mov	dl, [ebp + ebx]	; Get our data

readExit94:
		sahf
		sar	dl, 1
		lahf
		and	ah, 0edh	; Clear H and N
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop95:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite95	; Yes - go write it!
		cmp	bx, [edi]	; Are we smaller?
		jb	nextAddr95	; Yes... go to the next addr
		cmp	bx, [edi+4]	; Are we smaller?
		jbe	callRoutine95	; If not, go call it!

nextAddr95:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop95

callRoutine95:
		mov	dx, bx	; Get our address to target
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit95
memoryWrite95:
		mov	[ebp + ebx], dl
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit95:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst2f:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		sahf
		sar	al, 1
		lahf
		and	ah, 0edh	; Clear H and N
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst30:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		sahf
		shl	ch, 1
		lahf
		or	ch, 1	; Slide in a 1 bit (SLIA)
		and	ah, 0edh	; Clear H and N
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst31:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		sahf
		shl	cl, 1
		lahf
		or	cl, 1	; Slide in a 1 bit (SLIA)
		and	ah, 0edh	; Clear H and N
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst32:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		sahf
		shl	dh, 1
		lahf
		or	dh, 1	; Slide in a 1 bit (SLIA)
		and	ah, 0edh	; Clear H and N
		mov	[_z80de], dx	; Once modified, put it back
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst33:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		sahf
		shl	dl, 1
		lahf
		or	dl, 1	; Slide in a 1 bit (SLIA)
		and	ah, 0edh	; Clear H and N
		mov	[_z80de], dx	; Once modified, put it back
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst34:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		sahf
		shl	bh, 1
		lahf
		or	bh, 1	; Slide in a 1 bit (SLIA)
		and	ah, 0edh	; Clear H and N
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst35:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		sahf
		shl	bl, 1
		lahf
		or	bl, 1	; Slide in a 1 bit (SLIA)
		and	ah, 0edh	; Clear H and N
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst36:
		sub	dword [cyclesRemaining], byte 15
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 15
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop96:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead96
		cmp	bx, [edi]	; Are we smaller?
		jb		nextAddr96		; Yes, go to the next address
		cmp	bx, [edi+4]	; Are we bigger?
		jbe	callRoutine96

nextAddr96:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop96

callRoutine96:
		mov	dx, bx	; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit96

memoryRead96:
		mov	dl, [ebp + ebx]	; Get our data

readExit96:
		sahf
		shl	dl, 1
		lahf
		or	dl, 1	; Slide in a 1 bit (SLIA)
		and	ah, 0edh	; Clear H and N
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop97:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite97	; Yes - go write it!
		cmp	bx, [edi]	; Are we smaller?
		jb	nextAddr97	; Yes... go to the next addr
		cmp	bx, [edi+4]	; Are we smaller?
		jbe	callRoutine97	; If not, go call it!

nextAddr97:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop97

callRoutine97:
		mov	dx, bx	; Get our address to target
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit97
memoryWrite97:
		mov	[ebp + ebx], dl
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit97:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst37:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		sahf
		shl	al, 1
		lahf
		or	al, 1	; Slide in a 1 bit (SLIA)
		and	ah, 0edh	; Clear H and N
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst38:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		sahf
		shr	ch, 1
		lahf
		and	ah, 0edh	; Clear H and N
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst39:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		sahf
		shr	cl, 1
		lahf
		and	ah, 0edh	; Clear H and N
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst3a:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		sahf
		shr	dh, 1
		lahf
		and	ah, 0edh	; Clear H and N
		mov	[_z80de], dx	; Once modified, put it back
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst3b:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		sahf
		shr	dl, 1
		lahf
		and	ah, 0edh	; Clear H and N
		mov	[_z80de], dx	; Once modified, put it back
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst3c:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		sahf
		shr	bh, 1
		lahf
		and	ah, 0edh	; Clear H and N
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst3d:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		sahf
		shr	bl, 1
		lahf
		and	ah, 0edh	; Clear H and N
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst3e:
		sub	dword [cyclesRemaining], byte 15
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 15
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop98:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead98
		cmp	bx, [edi]	; Are we smaller?
		jb		nextAddr98		; Yes, go to the next address
		cmp	bx, [edi+4]	; Are we bigger?
		jbe	callRoutine98

nextAddr98:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop98

callRoutine98:
		mov	dx, bx	; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit98

memoryRead98:
		mov	dl, [ebp + ebx]	; Get our data

readExit98:
		sahf
		shr	dl, 1
		lahf
		and	ah, 0edh	; Clear H and N
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop99:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite99	; Yes - go write it!
		cmp	bx, [edi]	; Are we smaller?
		jb	nextAddr99	; Yes... go to the next addr
		cmp	bx, [edi+4]	; Are we smaller?
		jbe	callRoutine99	; If not, go call it!

nextAddr99:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop99

callRoutine99:
		mov	dx, bx	; Get our address to target
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit99
memoryWrite99:
		mov	[ebp + ebx], dl
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit99:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst3f:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		sahf
		shr	al, 1
		lahf
		and	ah, 0edh	; Clear H and N
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst40:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test ch, 001h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst41:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test cl, 001h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst42:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test byte [_z80de + 1], 001h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst43:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test byte [_z80de], 001h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst44:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test bh, 001h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst45:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test bl, 001h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst46:
		sub	dword [cyclesRemaining], byte 12
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 12
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop100:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead100
		cmp	bx, [edi]	; Are we smaller?
		jb		nextAddr100		; Yes, go to the next address
		cmp	bx, [edi+4]	; Are we bigger?
		jbe	callRoutine100

nextAddr100:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop100

callRoutine100:
		mov	dx, bx	; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit100

memoryRead100:
		mov	dl, [ebp + ebx]	; Get our data

readExit100:
		mov	byte [_z80af], ah ; Store F
		sahf
		test	dl, 001h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst47:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test al, 001h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst48:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test ch, 002h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst49:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test cl, 002h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst4a:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test byte [_z80de + 1], 002h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst4b:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test byte [_z80de], 002h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst4c:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test bh, 002h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst4d:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test bl, 002h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst4e:
		sub	dword [cyclesRemaining], byte 12
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 12
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop101:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead101
		cmp	bx, [edi]	; Are we smaller?
		jb		nextAddr101		; Yes, go to the next address
		cmp	bx, [edi+4]	; Are we bigger?
		jbe	callRoutine101

nextAddr101:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop101

callRoutine101:
		mov	dx, bx	; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit101

memoryRead101:
		mov	dl, [ebp + ebx]	; Get our data

readExit101:
		mov	byte [_z80af], ah ; Store F
		sahf
		test	dl, 002h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst4f:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test al, 002h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst50:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test ch, 004h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst51:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test cl, 004h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst52:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test byte [_z80de + 1], 004h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst53:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test byte [_z80de], 004h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst54:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test bh, 004h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst55:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test bl, 004h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst56:
		sub	dword [cyclesRemaining], byte 12
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 12
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop102:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead102
		cmp	bx, [edi]	; Are we smaller?
		jb		nextAddr102		; Yes, go to the next address
		cmp	bx, [edi+4]	; Are we bigger?
		jbe	callRoutine102

nextAddr102:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop102

callRoutine102:
		mov	dx, bx	; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit102

memoryRead102:
		mov	dl, [ebp + ebx]	; Get our data

readExit102:
		mov	byte [_z80af], ah ; Store F
		sahf
		test	dl, 004h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst57:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test al, 004h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst58:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test ch, 008h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst59:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test cl, 008h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst5a:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test byte [_z80de + 1], 008h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst5b:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test byte [_z80de], 008h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst5c:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test bh, 008h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst5d:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test bl, 008h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst5e:
		sub	dword [cyclesRemaining], byte 12
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 12
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop103:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead103
		cmp	bx, [edi]	; Are we smaller?
		jb		nextAddr103		; Yes, go to the next address
		cmp	bx, [edi+4]	; Are we bigger?
		jbe	callRoutine103

nextAddr103:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop103

callRoutine103:
		mov	dx, bx	; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit103

memoryRead103:
		mov	dl, [ebp + ebx]	; Get our data

readExit103:
		mov	byte [_z80af], ah ; Store F
		sahf
		test	dl, 008h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst5f:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test al, 008h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst60:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test ch, 010h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst61:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test cl, 010h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst62:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test byte [_z80de + 1], 010h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst63:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test byte [_z80de], 010h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst64:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test bh, 010h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst65:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test bl, 010h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst66:
		sub	dword [cyclesRemaining], byte 12
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 12
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop104:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead104
		cmp	bx, [edi]	; Are we smaller?
		jb		nextAddr104		; Yes, go to the next address
		cmp	bx, [edi+4]	; Are we bigger?
		jbe	callRoutine104

nextAddr104:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop104

callRoutine104:
		mov	dx, bx	; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit104

memoryRead104:
		mov	dl, [ebp + ebx]	; Get our data

readExit104:
		mov	byte [_z80af], ah ; Store F
		sahf
		test	dl, 010h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst67:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test al, 010h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst68:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test ch, 020h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst69:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test cl, 020h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst6a:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test byte [_z80de + 1], 020h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst6b:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test byte [_z80de], 020h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst6c:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test bh, 020h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst6d:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test bl, 020h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst6e:
		sub	dword [cyclesRemaining], byte 12
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 12
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop105:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead105
		cmp	bx, [edi]	; Are we smaller?
		jb		nextAddr105		; Yes, go to the next address
		cmp	bx, [edi+4]	; Are we bigger?
		jbe	callRoutine105

nextAddr105:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop105

callRoutine105:
		mov	dx, bx	; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit105

memoryRead105:
		mov	dl, [ebp + ebx]	; Get our data

readExit105:
		mov	byte [_z80af], ah ; Store F
		sahf
		test	dl, 020h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst6f:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test al, 020h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst70:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test ch, 040h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst71:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test cl, 040h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst72:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test byte [_z80de + 1], 040h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst73:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test byte [_z80de], 040h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst74:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test bh, 040h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst75:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test bl, 040h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst76:
		sub	dword [cyclesRemaining], byte 12
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 12
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop106:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead106
		cmp	bx, [edi]	; Are we smaller?
		jb		nextAddr106		; Yes, go to the next address
		cmp	bx, [edi+4]	; Are we bigger?
		jbe	callRoutine106

nextAddr106:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop106

callRoutine106:
		mov	dx, bx	; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit106

memoryRead106:
		mov	dl, [ebp + ebx]	; Get our data

readExit106:
		mov	byte [_z80af], ah ; Store F
		sahf
		test	dl, 040h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst77:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test al, 040h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst78:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test ch, 080h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst79:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test cl, 080h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst7a:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test byte [_z80de + 1], 080h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst7b:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test byte [_z80de], 080h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst7c:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test bh, 080h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst7d:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test bl, 080h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst7e:
		sub	dword [cyclesRemaining], byte 12
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 12
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop107:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead107
		cmp	bx, [edi]	; Are we smaller?
		jb		nextAddr107		; Yes, go to the next address
		cmp	bx, [edi+4]	; Are we bigger?
		jbe	callRoutine107

nextAddr107:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop107

callRoutine107:
		mov	dx, bx	; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit107

memoryRead107:
		mov	dl, [ebp + ebx]	; Get our data

readExit107:
		mov	byte [_z80af], ah ; Store F
		sahf
		test	dl, 080h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst7f:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test al, 080h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst80:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		and ch, 0feh	; Reset a bit
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst81:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		and cl, 0feh	; Reset a bit
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst82:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		and dh, 0feh	; Reset a bit
		mov	[_z80de], dx	; Once modified, put it back
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst83:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		and dl, 0feh	; Reset a bit
		mov	[_z80de], dx	; Once modified, put it back
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst84:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		and bh, 0feh	; Reset a bit
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst85:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		and bl, 0feh	; Reset a bit
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst86:
		sub	dword [cyclesRemaining], byte 15
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 15
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop108:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead108
		cmp	bx, [edi]	; Are we smaller?
		jb		nextAddr108		; Yes, go to the next address
		cmp	bx, [edi+4]	; Are we bigger?
		jbe	callRoutine108

nextAddr108:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop108

callRoutine108:
		mov	dx, bx	; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit108

memoryRead108:
		mov	dl, [ebp + ebx]	; Get our data

readExit108:
		and dl, 0feh	; Reset a bit
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop109:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite109	; Yes - go write it!
		cmp	bx, [edi]	; Are we smaller?
		jb	nextAddr109	; Yes... go to the next addr
		cmp	bx, [edi+4]	; Are we smaller?
		jbe	callRoutine109	; If not, go call it!

nextAddr109:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop109

callRoutine109:
		mov	dx, bx	; Get our address to target
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit109
memoryWrite109:
		mov	[ebp + ebx], dl
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit109:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst87:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		and al, 0feh	; Reset a bit
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst88:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		and ch, 0fdh	; Reset a bit
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst89:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		and cl, 0fdh	; Reset a bit
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst8a:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		and dh, 0fdh	; Reset a bit
		mov	[_z80de], dx	; Once modified, put it back
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst8b:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		and dl, 0fdh	; Reset a bit
		mov	[_z80de], dx	; Once modified, put it back
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst8c:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		and bh, 0fdh	; Reset a bit
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst8d:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		and bl, 0fdh	; Reset a bit
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst8e:
		sub	dword [cyclesRemaining], byte 15
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 15
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop110:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead110
		cmp	bx, [edi]	; Are we smaller?
		jb		nextAddr110		; Yes, go to the next address
		cmp	bx, [edi+4]	; Are we bigger?
		jbe	callRoutine110

nextAddr110:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop110

callRoutine110:
		mov	dx, bx	; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit110

memoryRead110:
		mov	dl, [ebp + ebx]	; Get our data

readExit110:
		and dl, 0fdh	; Reset a bit
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop111:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite111	; Yes - go write it!
		cmp	bx, [edi]	; Are we smaller?
		jb	nextAddr111	; Yes... go to the next addr
		cmp	bx, [edi+4]	; Are we smaller?
		jbe	callRoutine111	; If not, go call it!

nextAddr111:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop111

callRoutine111:
		mov	dx, bx	; Get our address to target
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit111
memoryWrite111:
		mov	[ebp + ebx], dl
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit111:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst8f:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		and al, 0fdh	; Reset a bit
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst90:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		and ch, 0fbh	; Reset a bit
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst91:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		and cl, 0fbh	; Reset a bit
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst92:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		and dh, 0fbh	; Reset a bit
		mov	[_z80de], dx	; Once modified, put it back
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst93:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		and dl, 0fbh	; Reset a bit
		mov	[_z80de], dx	; Once modified, put it back
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst94:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		and bh, 0fbh	; Reset a bit
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst95:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		and bl, 0fbh	; Reset a bit
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst96:
		sub	dword [cyclesRemaining], byte 15
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 15
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop112:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead112
		cmp	bx, [edi]	; Are we smaller?
		jb		nextAddr112		; Yes, go to the next address
		cmp	bx, [edi+4]	; Are we bigger?
		jbe	callRoutine112

nextAddr112:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop112

callRoutine112:
		mov	dx, bx	; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit112

memoryRead112:
		mov	dl, [ebp + ebx]	; Get our data

readExit112:
		and dl, 0fbh	; Reset a bit
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop113:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite113	; Yes - go write it!
		cmp	bx, [edi]	; Are we smaller?
		jb	nextAddr113	; Yes... go to the next addr
		cmp	bx, [edi+4]	; Are we smaller?
		jbe	callRoutine113	; If not, go call it!

nextAddr113:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop113

callRoutine113:
		mov	dx, bx	; Get our address to target
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit113
memoryWrite113:
		mov	[ebp + ebx], dl
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit113:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst97:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		and al, 0fbh	; Reset a bit
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst98:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		and ch, 0f7h	; Reset a bit
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst99:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		and cl, 0f7h	; Reset a bit
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst9a:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		and dh, 0f7h	; Reset a bit
		mov	[_z80de], dx	; Once modified, put it back
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst9b:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		and dl, 0f7h	; Reset a bit
		mov	[_z80de], dx	; Once modified, put it back
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst9c:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		and bh, 0f7h	; Reset a bit
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst9d:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		and bl, 0f7h	; Reset a bit
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst9e:
		sub	dword [cyclesRemaining], byte 15
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 15
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop114:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead114
		cmp	bx, [edi]	; Are we smaller?
		jb		nextAddr114		; Yes, go to the next address
		cmp	bx, [edi+4]	; Are we bigger?
		jbe	callRoutine114

nextAddr114:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop114

callRoutine114:
		mov	dx, bx	; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit114

memoryRead114:
		mov	dl, [ebp + ebx]	; Get our data

readExit114:
		and dl, 0f7h	; Reset a bit
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop115:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite115	; Yes - go write it!
		cmp	bx, [edi]	; Are we smaller?
		jb	nextAddr115	; Yes... go to the next addr
		cmp	bx, [edi+4]	; Are we smaller?
		jbe	callRoutine115	; If not, go call it!

nextAddr115:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop115

callRoutine115:
		mov	dx, bx	; Get our address to target
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit115
memoryWrite115:
		mov	[ebp + ebx], dl
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit115:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst9f:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		and al, 0f7h	; Reset a bit
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInsta0:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		and ch, 0efh	; Reset a bit
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInsta1:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		and cl, 0efh	; Reset a bit
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInsta2:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		and dh, 0efh	; Reset a bit
		mov	[_z80de], dx	; Once modified, put it back
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInsta3:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		and dl, 0efh	; Reset a bit
		mov	[_z80de], dx	; Once modified, put it back
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInsta4:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		and bh, 0efh	; Reset a bit
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInsta5:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		and bl, 0efh	; Reset a bit
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInsta6:
		sub	dword [cyclesRemaining], byte 15
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 15
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop116:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead116
		cmp	bx, [edi]	; Are we smaller?
		jb		nextAddr116		; Yes, go to the next address
		cmp	bx, [edi+4]	; Are we bigger?
		jbe	callRoutine116

nextAddr116:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop116

callRoutine116:
		mov	dx, bx	; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit116

memoryRead116:
		mov	dl, [ebp + ebx]	; Get our data

readExit116:
		and dl, 0efh	; Reset a bit
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop117:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite117	; Yes - go write it!
		cmp	bx, [edi]	; Are we smaller?
		jb	nextAddr117	; Yes... go to the next addr
		cmp	bx, [edi+4]	; Are we smaller?
		jbe	callRoutine117	; If not, go call it!

nextAddr117:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop117

callRoutine117:
		mov	dx, bx	; Get our address to target
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit117
memoryWrite117:
		mov	[ebp + ebx], dl
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit117:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInsta7:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		and al, 0efh	; Reset a bit
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInsta8:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		and ch, 0dfh	; Reset a bit
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInsta9:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		and cl, 0dfh	; Reset a bit
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstaa:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		and dh, 0dfh	; Reset a bit
		mov	[_z80de], dx	; Once modified, put it back
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstab:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		and dl, 0dfh	; Reset a bit
		mov	[_z80de], dx	; Once modified, put it back
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstac:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		and bh, 0dfh	; Reset a bit
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstad:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		and bl, 0dfh	; Reset a bit
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstae:
		sub	dword [cyclesRemaining], byte 15
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 15
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop118:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead118
		cmp	bx, [edi]	; Are we smaller?
		jb		nextAddr118		; Yes, go to the next address
		cmp	bx, [edi+4]	; Are we bigger?
		jbe	callRoutine118

nextAddr118:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop118

callRoutine118:
		mov	dx, bx	; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit118

memoryRead118:
		mov	dl, [ebp + ebx]	; Get our data

readExit118:
		and dl, 0dfh	; Reset a bit
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop119:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite119	; Yes - go write it!
		cmp	bx, [edi]	; Are we smaller?
		jb	nextAddr119	; Yes... go to the next addr
		cmp	bx, [edi+4]	; Are we smaller?
		jbe	callRoutine119	; If not, go call it!

nextAddr119:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop119

callRoutine119:
		mov	dx, bx	; Get our address to target
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit119
memoryWrite119:
		mov	[ebp + ebx], dl
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit119:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstaf:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		and al, 0dfh	; Reset a bit
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstb0:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		and ch, 0bfh	; Reset a bit
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstb1:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		and cl, 0bfh	; Reset a bit
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstb2:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		and dh, 0bfh	; Reset a bit
		mov	[_z80de], dx	; Once modified, put it back
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstb3:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		and dl, 0bfh	; Reset a bit
		mov	[_z80de], dx	; Once modified, put it back
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstb4:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		and bh, 0bfh	; Reset a bit
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstb5:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		and bl, 0bfh	; Reset a bit
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstb6:
		sub	dword [cyclesRemaining], byte 15
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 15
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop120:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead120
		cmp	bx, [edi]	; Are we smaller?
		jb		nextAddr120		; Yes, go to the next address
		cmp	bx, [edi+4]	; Are we bigger?
		jbe	callRoutine120

nextAddr120:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop120

callRoutine120:
		mov	dx, bx	; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit120

memoryRead120:
		mov	dl, [ebp + ebx]	; Get our data

readExit120:
		and dl, 0bfh	; Reset a bit
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop121:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite121	; Yes - go write it!
		cmp	bx, [edi]	; Are we smaller?
		jb	nextAddr121	; Yes... go to the next addr
		cmp	bx, [edi+4]	; Are we smaller?
		jbe	callRoutine121	; If not, go call it!

nextAddr121:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop121

callRoutine121:
		mov	dx, bx	; Get our address to target
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit121
memoryWrite121:
		mov	[ebp + ebx], dl
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit121:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstb7:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		and al, 0bfh	; Reset a bit
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstb8:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		and ch, 07fh	; Reset a bit
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstb9:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		and cl, 07fh	; Reset a bit
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstba:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		and dh, 07fh	; Reset a bit
		mov	[_z80de], dx	; Once modified, put it back
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstbb:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		and dl, 07fh	; Reset a bit
		mov	[_z80de], dx	; Once modified, put it back
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstbc:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		and bh, 07fh	; Reset a bit
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstbd:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		and bl, 07fh	; Reset a bit
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstbe:
		sub	dword [cyclesRemaining], byte 15
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 15
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop122:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead122
		cmp	bx, [edi]	; Are we smaller?
		jb		nextAddr122		; Yes, go to the next address
		cmp	bx, [edi+4]	; Are we bigger?
		jbe	callRoutine122

nextAddr122:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop122

callRoutine122:
		mov	dx, bx	; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit122

memoryRead122:
		mov	dl, [ebp + ebx]	; Get our data

readExit122:
		and dl, 07fh	; Reset a bit
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop123:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite123	; Yes - go write it!
		cmp	bx, [edi]	; Are we smaller?
		jb	nextAddr123	; Yes... go to the next addr
		cmp	bx, [edi+4]	; Are we smaller?
		jbe	callRoutine123	; If not, go call it!

nextAddr123:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop123

callRoutine123:
		mov	dx, bx	; Get our address to target
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit123
memoryWrite123:
		mov	[ebp + ebx], dl
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit123:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstbf:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		and al, 07fh	; Reset a bit
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstc0:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		or	ch, 001h	; Set a bit
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstc1:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		or	cl, 001h	; Set a bit
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstc2:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		or	dh, 001h	; Set a bit
		mov	[_z80de], dx	; Once modified, put it back
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstc3:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		or	dl, 001h	; Set a bit
		mov	[_z80de], dx	; Once modified, put it back
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstc4:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		or	bh, 001h	; Set a bit
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstc5:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		or	bl, 001h	; Set a bit
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstc6:
		sub	dword [cyclesRemaining], byte 15
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 15
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop124:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead124
		cmp	bx, [edi]	; Are we smaller?
		jb		nextAddr124		; Yes, go to the next address
		cmp	bx, [edi+4]	; Are we bigger?
		jbe	callRoutine124

nextAddr124:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop124

callRoutine124:
		mov	dx, bx	; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit124

memoryRead124:
		mov	dl, [ebp + ebx]	; Get our data

readExit124:
		or	dl, 001h	; Set a bit
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop125:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite125	; Yes - go write it!
		cmp	bx, [edi]	; Are we smaller?
		jb	nextAddr125	; Yes... go to the next addr
		cmp	bx, [edi+4]	; Are we smaller?
		jbe	callRoutine125	; If not, go call it!

nextAddr125:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop125

callRoutine125:
		mov	dx, bx	; Get our address to target
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit125
memoryWrite125:
		mov	[ebp + ebx], dl
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit125:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstc7:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		or	al, 001h	; Set a bit
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstc8:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		or	ch, 002h	; Set a bit
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstc9:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		or	cl, 002h	; Set a bit
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstca:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		or	dh, 002h	; Set a bit
		mov	[_z80de], dx	; Once modified, put it back
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstcb:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		or	dl, 002h	; Set a bit
		mov	[_z80de], dx	; Once modified, put it back
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstcc:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		or	bh, 002h	; Set a bit
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstcd:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		or	bl, 002h	; Set a bit
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstce:
		sub	dword [cyclesRemaining], byte 15
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 15
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop126:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead126
		cmp	bx, [edi]	; Are we smaller?
		jb		nextAddr126		; Yes, go to the next address
		cmp	bx, [edi+4]	; Are we bigger?
		jbe	callRoutine126

nextAddr126:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop126

callRoutine126:
		mov	dx, bx	; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit126

memoryRead126:
		mov	dl, [ebp + ebx]	; Get our data

readExit126:
		or	dl, 002h	; Set a bit
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop127:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite127	; Yes - go write it!
		cmp	bx, [edi]	; Are we smaller?
		jb	nextAddr127	; Yes... go to the next addr
		cmp	bx, [edi+4]	; Are we smaller?
		jbe	callRoutine127	; If not, go call it!

nextAddr127:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop127

callRoutine127:
		mov	dx, bx	; Get our address to target
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit127
memoryWrite127:
		mov	[ebp + ebx], dl
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit127:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstcf:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		or	al, 002h	; Set a bit
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstd0:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		or	ch, 004h	; Set a bit
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstd1:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		or	cl, 004h	; Set a bit
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstd2:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		or	dh, 004h	; Set a bit
		mov	[_z80de], dx	; Once modified, put it back
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstd3:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		or	dl, 004h	; Set a bit
		mov	[_z80de], dx	; Once modified, put it back
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstd4:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		or	bh, 004h	; Set a bit
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstd5:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		or	bl, 004h	; Set a bit
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstd6:
		sub	dword [cyclesRemaining], byte 15
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 15
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop128:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead128
		cmp	bx, [edi]	; Are we smaller?
		jb		nextAddr128		; Yes, go to the next address
		cmp	bx, [edi+4]	; Are we bigger?
		jbe	callRoutine128

nextAddr128:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop128

callRoutine128:
		mov	dx, bx	; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit128

memoryRead128:
		mov	dl, [ebp + ebx]	; Get our data

readExit128:
		or	dl, 004h	; Set a bit
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop129:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite129	; Yes - go write it!
		cmp	bx, [edi]	; Are we smaller?
		jb	nextAddr129	; Yes... go to the next addr
		cmp	bx, [edi+4]	; Are we smaller?
		jbe	callRoutine129	; If not, go call it!

nextAddr129:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop129

callRoutine129:
		mov	dx, bx	; Get our address to target
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit129
memoryWrite129:
		mov	[ebp + ebx], dl
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit129:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstd7:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		or	al, 004h	; Set a bit
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstd8:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		or	ch, 008h	; Set a bit
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstd9:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		or	cl, 008h	; Set a bit
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstda:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		or	dh, 008h	; Set a bit
		mov	[_z80de], dx	; Once modified, put it back
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstdb:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		or	dl, 008h	; Set a bit
		mov	[_z80de], dx	; Once modified, put it back
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstdc:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		or	bh, 008h	; Set a bit
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstdd:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		or	bl, 008h	; Set a bit
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstde:
		sub	dword [cyclesRemaining], byte 15
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 15
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop130:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead130
		cmp	bx, [edi]	; Are we smaller?
		jb		nextAddr130		; Yes, go to the next address
		cmp	bx, [edi+4]	; Are we bigger?
		jbe	callRoutine130

nextAddr130:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop130

callRoutine130:
		mov	dx, bx	; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit130

memoryRead130:
		mov	dl, [ebp + ebx]	; Get our data

readExit130:
		or	dl, 008h	; Set a bit
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop131:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite131	; Yes - go write it!
		cmp	bx, [edi]	; Are we smaller?
		jb	nextAddr131	; Yes... go to the next addr
		cmp	bx, [edi+4]	; Are we smaller?
		jbe	callRoutine131	; If not, go call it!

nextAddr131:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop131

callRoutine131:
		mov	dx, bx	; Get our address to target
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit131
memoryWrite131:
		mov	[ebp + ebx], dl
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit131:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstdf:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		or	al, 008h	; Set a bit
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInste0:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		or	ch, 010h	; Set a bit
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInste1:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		or	cl, 010h	; Set a bit
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInste2:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		or	dh, 010h	; Set a bit
		mov	[_z80de], dx	; Once modified, put it back
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInste3:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		or	dl, 010h	; Set a bit
		mov	[_z80de], dx	; Once modified, put it back
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInste4:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		or	bh, 010h	; Set a bit
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInste5:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		or	bl, 010h	; Set a bit
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInste6:
		sub	dword [cyclesRemaining], byte 15
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 15
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop132:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead132
		cmp	bx, [edi]	; Are we smaller?
		jb		nextAddr132		; Yes, go to the next address
		cmp	bx, [edi+4]	; Are we bigger?
		jbe	callRoutine132

nextAddr132:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop132

callRoutine132:
		mov	dx, bx	; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit132

memoryRead132:
		mov	dl, [ebp + ebx]	; Get our data

readExit132:
		or	dl, 010h	; Set a bit
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop133:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite133	; Yes - go write it!
		cmp	bx, [edi]	; Are we smaller?
		jb	nextAddr133	; Yes... go to the next addr
		cmp	bx, [edi+4]	; Are we smaller?
		jbe	callRoutine133	; If not, go call it!

nextAddr133:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop133

callRoutine133:
		mov	dx, bx	; Get our address to target
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit133
memoryWrite133:
		mov	[ebp + ebx], dl
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit133:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInste7:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		or	al, 010h	; Set a bit
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInste8:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		or	ch, 020h	; Set a bit
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInste9:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		or	cl, 020h	; Set a bit
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstea:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		or	dh, 020h	; Set a bit
		mov	[_z80de], dx	; Once modified, put it back
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInsteb:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		or	dl, 020h	; Set a bit
		mov	[_z80de], dx	; Once modified, put it back
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstec:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		or	bh, 020h	; Set a bit
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInsted:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		or	bl, 020h	; Set a bit
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstee:
		sub	dword [cyclesRemaining], byte 15
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 15
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop134:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead134
		cmp	bx, [edi]	; Are we smaller?
		jb		nextAddr134		; Yes, go to the next address
		cmp	bx, [edi+4]	; Are we bigger?
		jbe	callRoutine134

nextAddr134:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop134

callRoutine134:
		mov	dx, bx	; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit134

memoryRead134:
		mov	dl, [ebp + ebx]	; Get our data

readExit134:
		or	dl, 020h	; Set a bit
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop135:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite135	; Yes - go write it!
		cmp	bx, [edi]	; Are we smaller?
		jb	nextAddr135	; Yes... go to the next addr
		cmp	bx, [edi+4]	; Are we smaller?
		jbe	callRoutine135	; If not, go call it!

nextAddr135:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop135

callRoutine135:
		mov	dx, bx	; Get our address to target
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit135
memoryWrite135:
		mov	[ebp + ebx], dl
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit135:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstef:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		or	al, 020h	; Set a bit
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstf0:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		or	ch, 040h	; Set a bit
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstf1:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		or	cl, 040h	; Set a bit
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstf2:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		or	dh, 040h	; Set a bit
		mov	[_z80de], dx	; Once modified, put it back
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstf3:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		or	dl, 040h	; Set a bit
		mov	[_z80de], dx	; Once modified, put it back
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstf4:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		or	bh, 040h	; Set a bit
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstf5:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		or	bl, 040h	; Set a bit
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstf6:
		sub	dword [cyclesRemaining], byte 15
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 15
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop136:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead136
		cmp	bx, [edi]	; Are we smaller?
		jb		nextAddr136		; Yes, go to the next address
		cmp	bx, [edi+4]	; Are we bigger?
		jbe	callRoutine136

nextAddr136:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop136

callRoutine136:
		mov	dx, bx	; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit136

memoryRead136:
		mov	dl, [ebp + ebx]	; Get our data

readExit136:
		or	dl, 040h	; Set a bit
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop137:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite137	; Yes - go write it!
		cmp	bx, [edi]	; Are we smaller?
		jb	nextAddr137	; Yes... go to the next addr
		cmp	bx, [edi+4]	; Are we smaller?
		jbe	callRoutine137	; If not, go call it!

nextAddr137:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop137

callRoutine137:
		mov	dx, bx	; Get our address to target
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit137
memoryWrite137:
		mov	[ebp + ebx], dl
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit137:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstf7:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		or	al, 040h	; Set a bit
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstf8:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		or	ch, 080h	; Set a bit
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstf9:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		or	cl, 080h	; Set a bit
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstfa:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		or	dh, 080h	; Set a bit
		mov	[_z80de], dx	; Once modified, put it back
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstfb:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		or	dl, 080h	; Set a bit
		mov	[_z80de], dx	; Once modified, put it back
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstfc:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		or	bh, 080h	; Set a bit
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstfd:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		or	bl, 080h	; Set a bit
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstfe:
		sub	dword [cyclesRemaining], byte 15
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 15
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop138:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead138
		cmp	bx, [edi]	; Are we smaller?
		jb		nextAddr138		; Yes, go to the next address
		cmp	bx, [edi+4]	; Are we bigger?
		jbe	callRoutine138

nextAddr138:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop138

callRoutine138:
		mov	dx, bx	; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit138

memoryRead138:
		mov	dl, [ebp + ebx]	; Get our data

readExit138:
		or	dl, 080h	; Set a bit
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop139:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite139	; Yes - go write it!
		cmp	bx, [edi]	; Are we smaller?
		jb	nextAddr139	; Yes... go to the next addr
		cmp	bx, [edi+4]	; Are we smaller?
		jbe	callRoutine139	; If not, go call it!

nextAddr139:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop139

callRoutine139:
		mov	dx, bx	; Get our address to target
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit139
memoryWrite139:
		mov	[ebp + ebx], dl
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit139:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstff:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		or	al, 080h	; Set a bit
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInst40:
		sub	dword [cyclesRemaining], byte 12
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 12
		mov	dl, cl	; Address in DX... (C)
		mov	edi, [_z80IoRead]	; Point to the read array

checkLoop140:
		cmp	[edi], word 0ffffh ; End of the list?
		je		ioRead140
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr140		; Yes, go to the next address
		cmp	dx, [edi+2]	; Are we bigger?
		jbe	callRoutine140

nextAddr140:
		add	edi, 0ch		; Next structure!
		jmp	short checkLoop140

callRoutine140:
		call	ReadIOByte	; Standard read routine
		mov	ch, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit140

ioRead140:
		mov	ch, 0ffh	; An unreferenced read
readExit140:
;
; Remember, this variant of the IN instruction modifies the flags
;

		sahf	; Restore our flags
		mov	dh, ah	; Save flags for later
		or	ch, ch;
		lahf
		and	dh, 029h	; Only keep carry and two unused flags
		and	ah, 0d4h
		or	ah, dh
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInst41:
		sub	dword [cyclesRemaining], byte 12
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 12
		mov	dl, cl	; Address in DX... (C)
		mov	[_z80af], ax	; Store AF
		mov	al, ch	; And our data to write
		mov	edi, [_z80IoWrite]	; Point to the I/O write array

checkLoop141:
		cmp	[edi], word 0ffffh ; End of our list?
		je	WriteMacroExit141	; Yes - ignore it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr141	; Yes... go to the next addr
		cmp	dx, [edi+2]	; Are we bigger?
		jbe	callRoutine141	; If not, go call it!

nextAddr141:
		add	edi, 0ch		; Next structure, please
		jmp	short checkLoop141

callRoutine141:
		call	WriteIOByte	; Go write the data!
WriteMacroExit141:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInst42:
		sub	dword [cyclesRemaining], byte 15
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 15
		mov	dx, cx	; Get our original register
		mov	[_orgval], dx	; Store this for later half carry computation
		mov	[_orgval2], bx	; Store this, too
		sahf		; Restore our flags
		sbb	bx, dx	; Do the operation!
		lahf		; Get our new flags
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		and	ah, 0edh	; Knock out negative & half carry flags
		or	ah, 02h	; Negative!
		mov	[_z80hl], bx
		xor	bx, [_orgval]
		xor	bx, [_orgval2]
		and	bh, 10h	; Half carry?
		or	ah, bh	; OR It in if so
		mov	bx, [_z80hl]
		xor	dh, dh	; Make sure we don't hose things
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInst43:
		sub	dword [cyclesRemaining], byte 20
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 20
		mov	dx, [esi]	; Get our address to write to
		add	esi, 2		; Next address, please...
		mov	[_z80af], ax	; Store AF
		mov	al, cl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop142:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite142	; Yes - go write it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr142	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine142	; If not, go call it!

nextAddr142:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop142

callRoutine142:
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit142
memoryWrite142:
		mov	[ebp + edx], cl
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit142:
		inc	dx
		mov	[_z80af], ax	; Store AF
		mov	al, ch	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop143:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite143	; Yes - go write it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr143	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine143	; If not, go call it!

nextAddr143:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop143

callRoutine143:
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit143
memoryWrite143:
		mov	[ebp + edx], ch
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit143:
		xor	dh, dh	; Zero our upper word
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInst44:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		sahf
		sub	dh, al
		lahf
		mov	al, dh
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		or	ah, 02h
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInst45:
		sub	dword [cyclesRemaining], byte 14
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 14
		mov	dx, word [_z80sp]	; Get our current stack pointer
		mov	si, [edx+ebp]	; Get our return address
		and	esi, 0ffffh		; Only within 64K!
		add	esi, ebp			; Add in our base address
		add	word [_z80sp], 02h	; Remove our two bytes from the stack
		xor	dh, dh	; Make sure we don't hose things
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInst46:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dword [_z80interruptMode], 0 ; IM 0
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInst47:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
           mov     [_z80i], al
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInst48:
		sub	dword [cyclesRemaining], byte 12
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 12
		mov	dl, cl	; Address in DX... (C)
		mov	edi, [_z80IoRead]	; Point to the read array

checkLoop144:
		cmp	[edi], word 0ffffh ; End of the list?
		je		ioRead144
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr144		; Yes, go to the next address
		cmp	dx, [edi+2]	; Are we bigger?
		jbe	callRoutine144

nextAddr144:
		add	edi, 0ch		; Next structure!
		jmp	short checkLoop144

callRoutine144:
		call	ReadIOByte	; Standard read routine
		mov	cl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit144

ioRead144:
		mov	cl, 0ffh	; An unreferenced read
readExit144:
;
; Remember, this variant of the IN instruction modifies the flags
;

		sahf	; Restore our flags
		mov	dh, ah	; Save flags for later
		or	cl, cl;
		lahf
		and	dh, 029h	; Only keep carry and two unused flags
		and	ah, 0d4h
		or	ah, dh
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInst49:
		sub	dword [cyclesRemaining], byte 12
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 12
		mov	dl, cl	; Address in DX... (C)
		mov	[_z80af], ax	; Store AF
		mov	al, cl	; And our data to write
		mov	edi, [_z80IoWrite]	; Point to the I/O write array

checkLoop145:
		cmp	[edi], word 0ffffh ; End of our list?
		je	WriteMacroExit145	; Yes - ignore it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr145	; Yes... go to the next addr
		cmp	dx, [edi+2]	; Are we bigger?
		jbe	callRoutine145	; If not, go call it!

nextAddr145:
		add	edi, 0ch		; Next structure, please
		jmp	short checkLoop145

callRoutine145:
		call	WriteIOByte	; Go write the data!
WriteMacroExit145:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInst4a:
		sub	dword [cyclesRemaining], byte 15
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 15
		mov	dx, cx	; Get our original register
		mov	[_orgval], dx	; Store this for later half carry computation
		mov	[_orgval2], bx	; Store this, too
		sahf		; Restore our flags
		adc	bx, dx	; Do the operation!
		lahf		; Get our new flags
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		and	ah, 0edh	; Knock out negative & half carry flags
		mov	[_z80hl], bx
		xor	bx, [_orgval]
		xor	bx, [_orgval2]
		and	bh, 10h	; Half carry?
		or	ah, bh	; OR It in if so
		mov	bx, [_z80hl]
		xor	dh, dh	; Make sure we don't hose things
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInst4b:
		sub	dword [cyclesRemaining], byte 20
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 20
		mov	dx, [esi]	; Get address to load
		add	esi, 2	; Skip over it so we don't execute it
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop146:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead146
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr146		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine146

nextAddr146:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop146

callRoutine146:
		call	ReadMemoryByte	; Standard read routine
		mov	cl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit146

memoryRead146:
		mov	cl, [ebp + edx]	; Get our data

readExit146:
		inc	dx
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop147:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead147
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr147		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine147

nextAddr147:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop147

callRoutine147:
		call	ReadMemoryByte	; Standard read routine
		mov	ch, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit147

memoryRead147:
		mov	ch, [ebp + edx]	; Get our data

readExit147:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInst4d:
		sub	dword [cyclesRemaining], byte 14
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 14
		mov	dx, word [_z80sp]	; Get our current stack pointer
		mov	si, [edx+ebp]	; Get our return address
		and	esi, 0ffffh		; Only within 64K!
		add	esi, ebp			; Add in our base address
		add	word [_z80sp], 02h	; Remove our two bytes from the stack
		mov	dword [_z80inInterrupt], 0
		xor	dh, dh	; Make sure we don't hose things
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInst4f:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
           mov     [_z80r], al
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInst50:
		sub	dword [cyclesRemaining], byte 12
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 12
		mov	dl, cl	; Address in DX... (C)
		mov	edi, [_z80IoRead]	; Point to the read array

checkLoop148:
		cmp	[edi], word 0ffffh ; End of the list?
		je		ioRead148
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr148		; Yes, go to the next address
		cmp	dx, [edi+2]	; Are we bigger?
		jbe	callRoutine148

nextAddr148:
		add	edi, 0ch		; Next structure!
		jmp	short checkLoop148

callRoutine148:
		call	ReadIOByte	; Standard read routine
		mov	byte [_z80de + 1], al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit148

ioRead148:
		mov	byte [_z80de + 1], 0ffh	; An unreferenced read
readExit148:
;
; Remember, this variant of the IN instruction modifies the flags
;

		sahf	; Restore our flags
		mov	dh, ah	; Save flags for later
		mov	dl, byte [_z80de + 1]
		or	dl, dl
		lahf
		and	dh, 029h	; Only keep carry and two unused flags
		and	ah, 0d4h
		or	ah, dh
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInst51:
		sub	dword [cyclesRemaining], byte 12
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 12
		mov	dl, cl	; Address in DX... (C)
		mov	[_z80af], ax	; Store AF
		mov	al, byte [_z80de + 1]	; And our data to write
		mov	edi, [_z80IoWrite]	; Point to the I/O write array

checkLoop149:
		cmp	[edi], word 0ffffh ; End of our list?
		je	WriteMacroExit149	; Yes - ignore it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr149	; Yes... go to the next addr
		cmp	dx, [edi+2]	; Are we bigger?
		jbe	callRoutine149	; If not, go call it!

nextAddr149:
		add	edi, 0ch		; Next structure, please
		jmp	short checkLoop149

callRoutine149:
		call	WriteIOByte	; Go write the data!
WriteMacroExit149:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInst52:
		sub	dword [cyclesRemaining], byte 15
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 15
		mov	dx, word [_z80de]	; Get our original register
		mov	[_orgval], dx	; Store this for later half carry computation
		mov	[_orgval2], bx	; Store this, too
		sahf		; Restore our flags
		sbb	bx, dx	; Do the operation!
		lahf		; Get our new flags
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		and	ah, 0edh	; Knock out negative & half carry flags
		or	ah, 02h	; Negative!
		mov	[_z80hl], bx
		xor	bx, [_orgval]
		xor	bx, [_orgval2]
		and	bh, 10h	; Half carry?
		or	ah, bh	; OR It in if so
		mov	bx, [_z80hl]
		xor	dh, dh	; Make sure we don't hose things
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInst53:
		sub	dword [cyclesRemaining], byte 20
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 20
		mov	dx, [esi]	; Get our address to write to
		add	esi, 2		; Next address, please...
		mov	[_z80af], ax	; Store AF
		mov	al, byte [_z80de]	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop150:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite150	; Yes - go write it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr150	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine150	; If not, go call it!

nextAddr150:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop150

callRoutine150:
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit150
memoryWrite150:
		mov	edi, edx
		mov	dl, byte [_z80de]
		mov	[ebp + edi], dl
		mov	edx, edi
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit150:
		inc	dx
		mov	[_z80af], ax	; Store AF
		mov	al, byte [_z80de + 1]	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop151:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite151	; Yes - go write it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr151	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine151	; If not, go call it!

nextAddr151:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop151

callRoutine151:
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit151
memoryWrite151:
		mov	edi, edx
		mov	dl, byte [_z80de + 1]
		mov	[ebp + edi], dl
		mov	edx, edi
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit151:
		xor	dh, dh	; Zero our upper word
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInst56:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dword [_z80interruptMode], 1 ; Interrupt mode 1
		mov	word [_z80intAddr], 038h	; Interrupt mode 1 cmd!
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInst57:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
           mov     al, [_z80i]
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInst58:
		sub	dword [cyclesRemaining], byte 12
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 12
		mov	dl, cl	; Address in DX... (C)
		mov	edi, [_z80IoRead]	; Point to the read array

checkLoop152:
		cmp	[edi], word 0ffffh ; End of the list?
		je		ioRead152
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr152		; Yes, go to the next address
		cmp	dx, [edi+2]	; Are we bigger?
		jbe	callRoutine152

nextAddr152:
		add	edi, 0ch		; Next structure!
		jmp	short checkLoop152

callRoutine152:
		call	ReadIOByte	; Standard read routine
		mov	byte [_z80de], al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit152

ioRead152:
		mov	byte [_z80de], 0ffh	; An unreferenced read
readExit152:
;
; Remember, this variant of the IN instruction modifies the flags
;

		sahf	; Restore our flags
		mov	dh, ah	; Save flags for later
		mov	dl, byte [_z80de]
		or	dl, dl
		lahf
		and	dh, 029h	; Only keep carry and two unused flags
		and	ah, 0d4h
		or	ah, dh
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInst59:
		sub	dword [cyclesRemaining], byte 12
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 12
		mov	dl, cl	; Address in DX... (C)
		mov	[_z80af], ax	; Store AF
		mov	al, byte [_z80de]	; And our data to write
		mov	edi, [_z80IoWrite]	; Point to the I/O write array

checkLoop153:
		cmp	[edi], word 0ffffh ; End of our list?
		je	WriteMacroExit153	; Yes - ignore it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr153	; Yes... go to the next addr
		cmp	dx, [edi+2]	; Are we bigger?
		jbe	callRoutine153	; If not, go call it!

nextAddr153:
		add	edi, 0ch		; Next structure, please
		jmp	short checkLoop153

callRoutine153:
		call	WriteIOByte	; Go write the data!
WriteMacroExit153:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInst5a:
		sub	dword [cyclesRemaining], byte 15
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 15
		mov	dx, word [_z80de]	; Get our original register
		mov	[_orgval], dx	; Store this for later half carry computation
		mov	[_orgval2], bx	; Store this, too
		sahf		; Restore our flags
		adc	bx, dx	; Do the operation!
		lahf		; Get our new flags
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		and	ah, 0edh	; Knock out negative & half carry flags
		mov	[_z80hl], bx
		xor	bx, [_orgval]
		xor	bx, [_orgval2]
		and	bh, 10h	; Half carry?
		or	ah, bh	; OR It in if so
		mov	bx, [_z80hl]
		xor	dh, dh	; Make sure we don't hose things
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInst5b:
		sub	dword [cyclesRemaining], byte 20
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 20
		mov	dx, [esi]	; Get address to load
		add	esi, 2	; Skip over it so we don't execute it
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop154:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead154
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr154		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine154

nextAddr154:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop154

callRoutine154:
		call	ReadMemoryByte	; Standard read routine
		mov	byte [_z80de], al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit154

memoryRead154:
		mov	di, dx
		mov	dl, [ebp + edx]
		mov	byte [_z80de], dl
		mov	dx, di
readExit154:
		inc	dx
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop155:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead155
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr155		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine155

nextAddr155:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop155

callRoutine155:
		call	ReadMemoryByte	; Standard read routine
		mov	byte [_z80de + 1], al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit155

memoryRead155:
		mov	di, dx
		mov	dl, [ebp + edx]
		mov	byte [_z80de + 1], dl
		mov	dx, di
readExit155:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInst5e:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dword [_z80interruptMode], 2 ; IM 2
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInst5f:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
           mov     al, [_z80r]
		and	ah, 029h	; No N, H, Z, or S!
		or	al,al	; Get appropriate flags
		o16 pushf
		pop	dx
		and	dl, 0c0h
		or	ah, dl	; OR In our S & Z flags
		mov	dl, byte [_z80inInterrupt]
		not	dl
		and	dl, 1
		shl	dl, 2
		or	ah, dl
		xor	dh, dh
		mov	dl, [_z80r]
		add	dl, bl
		inc	dl
		add	dl, ch
		xor	dl, al
		mov	[_z80r], dl
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInst60:
		sub	dword [cyclesRemaining], byte 12
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 12
		mov	dl, cl	; Address in DX... (C)
		mov	edi, [_z80IoRead]	; Point to the read array

checkLoop156:
		cmp	[edi], word 0ffffh ; End of the list?
		je		ioRead156
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr156		; Yes, go to the next address
		cmp	dx, [edi+2]	; Are we bigger?
		jbe	callRoutine156

nextAddr156:
		add	edi, 0ch		; Next structure!
		jmp	short checkLoop156

callRoutine156:
		call	ReadIOByte	; Standard read routine
		mov	bh, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit156

ioRead156:
		mov	bh, 0ffh	; An unreferenced read
readExit156:
;
; Remember, this variant of the IN instruction modifies the flags
;

		sahf	; Restore our flags
		mov	dh, ah	; Save flags for later
		or	bh, bh;
		lahf
		and	dh, 029h	; Only keep carry and two unused flags
		and	ah, 0d4h
		or	ah, dh
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInst61:
		sub	dword [cyclesRemaining], byte 12
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 12
		mov	dl, cl	; Address in DX... (C)
		mov	[_z80af], ax	; Store AF
		mov	al, bh	; And our data to write
		mov	edi, [_z80IoWrite]	; Point to the I/O write array

checkLoop157:
		cmp	[edi], word 0ffffh ; End of our list?
		je	WriteMacroExit157	; Yes - ignore it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr157	; Yes... go to the next addr
		cmp	dx, [edi+2]	; Are we bigger?
		jbe	callRoutine157	; If not, go call it!

nextAddr157:
		add	edi, 0ch		; Next structure, please
		jmp	short checkLoop157

callRoutine157:
		call	WriteIOByte	; Go write the data!
WriteMacroExit157:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInst62:
		sub	dword [cyclesRemaining], byte 15
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 15
		mov	dx, bx	; Get our original register
		mov	[_orgval], dx	; Store this for later half carry computation
		mov	[_orgval2], bx	; Store this, too
		sahf		; Restore our flags
		sbb	bx, dx	; Do the operation!
		lahf		; Get our new flags
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		and	ah, 0edh	; Knock out negative & half carry flags
		or	ah, 02h	; Negative!
		mov	[_z80hl], bx
		xor	bx, [_orgval]
		xor	bx, [_orgval2]
		and	bh, 10h	; Half carry?
		or	ah, bh	; OR It in if so
		mov	bx, [_z80hl]
		xor	dh, dh	; Make sure we don't hose things
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInst63:
		sub	dword [cyclesRemaining], byte 20
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 20
		mov	dx, [esi]	; Get our address to write to
		add	esi, 2		; Next address, please...
		mov	[_z80af], ax	; Store AF
		mov	al, bl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop158:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite158	; Yes - go write it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr158	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine158	; If not, go call it!

nextAddr158:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop158

callRoutine158:
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit158
memoryWrite158:
		mov	[ebp + edx], bl
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit158:
		inc	dx
		mov	[_z80af], ax	; Store AF
		mov	al, bh	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop159:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite159	; Yes - go write it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr159	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine159	; If not, go call it!

nextAddr159:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop159

callRoutine159:
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit159
memoryWrite159:
		mov	[ebp + edx], bh
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit159:
		xor	dh, dh	; Zero our upper word
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInst67:
		sub	dword [cyclesRemaining], byte 18
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 18
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop160:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead160
		cmp	bx, [edi]	; Are we smaller?
		jb		nextAddr160		; Yes, go to the next address
		cmp	bx, [edi+4]	; Are we bigger?
		jbe	callRoutine160

nextAddr160:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop160

callRoutine160:
		mov	dx, bx	; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit160

memoryRead160:
		mov	dl, [ebp + ebx]	; Get our data

readExit160:
		mov	dh, dl	; Put a copy in DH
		shr	dl, 4	; Upper nibble to lower nibble
		shl	ecx, 16	; Save this
		mov	cl, al
		shl	cl, 4
		or	dl, cl	; OR In what was in A
		and	al, 0f0h	; Knock out lower part
		and	dh, 0fh	; Only the lower nibble
		or	al, dh	; OR In our nibble
		shr	ecx, 16	; Restore this
		and	ah, 29h	; Retain carry & two undefined bits
		mov	dh, ah	; Store our flags away for later
		or	al, al	; Get our flags
		lahf
		and	ah,0c4h	; Only partiy, zero, and sign
		or	ah, dh	; OR In our old flags
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop161:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite161	; Yes - go write it!
		cmp	bx, [edi]	; Are we smaller?
		jb	nextAddr161	; Yes... go to the next addr
		cmp	bx, [edi+4]	; Are we smaller?
		jbe	callRoutine161	; If not, go call it!

nextAddr161:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop161

callRoutine161:
		mov	dx, bx	; Get our address to target
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit161
memoryWrite161:
		mov	[ebp + ebx], dl
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit161:
		xor	dh, dh	; Zero out this for later
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInst68:
		sub	dword [cyclesRemaining], byte 12
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 12
		mov	dl, cl	; Address in DX... (C)
		mov	edi, [_z80IoRead]	; Point to the read array

checkLoop162:
		cmp	[edi], word 0ffffh ; End of the list?
		je		ioRead162
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr162		; Yes, go to the next address
		cmp	dx, [edi+2]	; Are we bigger?
		jbe	callRoutine162

nextAddr162:
		add	edi, 0ch		; Next structure!
		jmp	short checkLoop162

callRoutine162:
		call	ReadIOByte	; Standard read routine
		mov	bl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit162

ioRead162:
		mov	bl, 0ffh	; An unreferenced read
readExit162:
;
; Remember, this variant of the IN instruction modifies the flags
;

		sahf	; Restore our flags
		mov	dh, ah	; Save flags for later
		or	bl, bl;
		lahf
		and	dh, 029h	; Only keep carry and two unused flags
		and	ah, 0d4h
		or	ah, dh
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInst69:
		sub	dword [cyclesRemaining], byte 12
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 12
		mov	dl, cl	; Address in DX... (C)
		mov	[_z80af], ax	; Store AF
		mov	al, bl	; And our data to write
		mov	edi, [_z80IoWrite]	; Point to the I/O write array

checkLoop163:
		cmp	[edi], word 0ffffh ; End of our list?
		je	WriteMacroExit163	; Yes - ignore it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr163	; Yes... go to the next addr
		cmp	dx, [edi+2]	; Are we bigger?
		jbe	callRoutine163	; If not, go call it!

nextAddr163:
		add	edi, 0ch		; Next structure, please
		jmp	short checkLoop163

callRoutine163:
		call	WriteIOByte	; Go write the data!
WriteMacroExit163:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInst6a:
		sub	dword [cyclesRemaining], byte 15
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 15
		mov	dx, bx	; Get our original register
		mov	[_orgval], dx	; Store this for later half carry computation
		mov	[_orgval2], bx	; Store this, too
		sahf		; Restore our flags
		adc	bx, dx	; Do the operation!
		lahf		; Get our new flags
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		and	ah, 0edh	; Knock out negative & half carry flags
		mov	[_z80hl], bx
		xor	bx, [_orgval]
		xor	bx, [_orgval2]
		and	bh, 10h	; Half carry?
		or	ah, bh	; OR It in if so
		mov	bx, [_z80hl]
		xor	dh, dh	; Make sure we don't hose things
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInst6f:
		sub	dword [cyclesRemaining], byte 18
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 18
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop164:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead164
		cmp	bx, [edi]	; Are we smaller?
		jb		nextAddr164		; Yes, go to the next address
		cmp	bx, [edi+4]	; Are we bigger?
		jbe	callRoutine164

nextAddr164:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop164

callRoutine164:
		mov	dx, bx	; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit164

memoryRead164:
		mov	dl, [ebp + ebx]	; Get our data

readExit164:
		mov	dh, dl	; Put a copy in DH
		shr	dh, 4	; Get our upper nibble in position
		shl	dl, 4	; Get our lower nibble into the higher position
		shl	ecx, 16	; Save this for later
		mov	cl, al
		and	cl, 0fh
	; Only the lower nibble
		or	dl, cl	; OR In A->(HL) transfer
		and	al, 0f0h	; Only the upper 4 bits remain
		or	al, dh	; OR It in to our accumulator
		shr	ecx, 16	; Restore this
		and	ah, 29h	; Retain carry & two undefined bits
		mov	dh, ah	; Store our flags away for later
		or	al, al	; Get our flags
		lahf
		and	ah,0c4h	; Only partiy, zero, and sign
		or	ah, dh	; OR In our old flags
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop165:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite165	; Yes - go write it!
		cmp	bx, [edi]	; Are we smaller?
		jb	nextAddr165	; Yes... go to the next addr
		cmp	bx, [edi+4]	; Are we smaller?
		jbe	callRoutine165	; If not, go call it!

nextAddr165:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop165

callRoutine165:
		mov	dx, bx	; Get our address to target
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit165
memoryWrite165:
		mov	[ebp + ebx], dl
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit165:
		xor	dh, dh	; Zero out this for later
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInst72:
		sub	dword [cyclesRemaining], byte 15
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 15
		mov	dx, word [_z80sp]	; Get our original register
		mov	[_orgval], dx	; Store this for later half carry computation
		mov	[_orgval2], bx	; Store this, too
		sahf		; Restore our flags
		sbb	bx, dx	; Do the operation!
		lahf		; Get our new flags
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		and	ah, 0edh	; Knock out negative & half carry flags
		or	ah, 02h	; Negative!
		mov	[_z80hl], bx
		xor	bx, [_orgval]
		xor	bx, [_orgval2]
		and	bh, 10h	; Half carry?
		or	ah, bh	; OR It in if so
		mov	bx, [_z80hl]
		xor	dh, dh	; Make sure we don't hose things
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInst73:
		sub	dword [cyclesRemaining], byte 20
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 20
		mov	dx, [esi]	; Get our address to write to
		add	esi, 2		; Next address, please...
		mov	[_z80af], ax	; Store AF
		mov	al, byte [_z80sp]	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop166:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite166	; Yes - go write it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr166	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine166	; If not, go call it!

nextAddr166:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop166

callRoutine166:
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit166
memoryWrite166:
		mov	edi, edx
		mov	dl, byte [_z80sp]
		mov	[ebp + edi], dl
		mov	edx, edi
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit166:
		inc	dx
		mov	[_z80af], ax	; Store AF
		mov	al, byte [_z80sp + 1]	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop167:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite167	; Yes - go write it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr167	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine167	; If not, go call it!

nextAddr167:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop167

callRoutine167:
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit167
memoryWrite167:
		mov	edi, edx
		mov	dl, byte [_z80sp + 1]
		mov	[ebp + edi], dl
		mov	edx, edi
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit167:
		xor	dh, dh	; Zero our upper word
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInst78:
		sub	dword [cyclesRemaining], byte 12
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 12
		mov	dl, cl	; Address in DX... (C)
		mov	edi, [_z80IoRead]	; Point to the read array

checkLoop168:
		cmp	[edi], word 0ffffh ; End of the list?
		je		ioRead168
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr168		; Yes, go to the next address
		cmp	dx, [edi+2]	; Are we bigger?
		jbe	callRoutine168

nextAddr168:
		add	edi, 0ch		; Next structure!
		jmp	short checkLoop168

callRoutine168:
		call	ReadIOByte	; Standard read routine
		mov	[_z80af], al	; Save our new accumulator
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit168

ioRead168:
		mov	al, 0ffh	; An unreferenced read
readExit168:
;
; Remember, this variant of the IN instruction modifies the flags
;

		sahf	; Restore our flags
		mov	dh, ah	; Save flags for later
		or	al, al;
		lahf
		and	dh, 029h	; Only keep carry and two unused flags
		and	ah, 0d4h
		or	ah, dh
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInst79:
		sub	dword [cyclesRemaining], byte 12
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 12
		mov	dl, cl	; Address in DX... (C)
		mov	[_z80af], ax	; Store AF
		mov	edi, [_z80IoWrite]	; Point to the I/O write array

checkLoop169:
		cmp	[edi], word 0ffffh ; End of our list?
		je	WriteMacroExit169	; Yes - ignore it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr169	; Yes... go to the next addr
		cmp	dx, [edi+2]	; Are we bigger?
		jbe	callRoutine169	; If not, go call it!

nextAddr169:
		add	edi, 0ch		; Next structure, please
		jmp	short checkLoop169

callRoutine169:
		call	WriteIOByte	; Go write the data!
WriteMacroExit169:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInst7a:
		sub	dword [cyclesRemaining], byte 15
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 15
		mov	dx, word [_z80sp]	; Get our original register
		mov	[_orgval], dx	; Store this for later half carry computation
		mov	[_orgval2], bx	; Store this, too
		sahf		; Restore our flags
		adc	bx, dx	; Do the operation!
		lahf		; Get our new flags
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		and	ah, 0edh	; Knock out negative & half carry flags
		mov	[_z80hl], bx
		xor	bx, [_orgval]
		xor	bx, [_orgval2]
		and	bh, 10h	; Half carry?
		or	ah, bh	; OR It in if so
		mov	bx, [_z80hl]
		xor	dh, dh	; Make sure we don't hose things
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInst7b:
		sub	dword [cyclesRemaining], byte 20
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 20
		mov	dx, [esi]	; Get address to load
		add	esi, 2	; Skip over it so we don't execute it
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop170:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead170
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr170		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine170

nextAddr170:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop170

callRoutine170:
		call	ReadMemoryByte	; Standard read routine
		mov	byte [_z80sp], al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit170

memoryRead170:
		mov	di, dx
		mov	dl, [ebp + edx]
		mov	byte [_z80sp], dl
		mov	dx, di
readExit170:
		inc	dx
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop171:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead171
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr171		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine171

nextAddr171:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop171

callRoutine171:
		call	ReadMemoryByte	; Standard read routine
		mov	byte [_z80sp + 1], al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit171

memoryRead171:
		mov	di, dx
		mov	dl, [ebp + edx]
		mov	byte [_z80sp + 1], dl
		mov	dx, di
readExit171:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInsta0:
		sub	dword [cyclesRemaining], byte 16
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 16
		mov	[_orgval], cx	; Store BC for later
		push	esi	; Save our PC for later
		push	ebp	; Save our base pointer for later
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop172:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead172
		cmp	bx, [edi]	; Are we smaller?
		jb		nextAddr172		; Yes, go to the next address
		cmp	bx, [edi+4]	; Are we bigger?
		jbe	callRoutine172

nextAddr172:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop172

callRoutine172:
		mov	dx, bx	; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit172

memoryRead172:
		mov	dl, [ebp + ebx]	; Get our data

readExit172:
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	dx, [_z80de]
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop173:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite173	; Yes - go write it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr173	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine173	; If not, go call it!

nextAddr173:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop173

callRoutine173:
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit173
memoryWrite173:
		mov	[ebp + edx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit173:
		inc	bx	; Increment HL
		inc	word [_z80de]	; Increment DE
		and	ah, 0e9h ; Knock out H & N and P/V
		dec	cx	; Decrement BC
		jz	atZero174 ; We're done!
		or	ah, 04h	; Non-zero - we're still going!
atZero174:
		pop	ebp	; Restore our base pointer
		pop	esi	; Restore PC
		xor	dh, dh	; Make sure we don't hose things
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInsta1:
		sub	dword [cyclesRemaining], byte 16
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 16
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop175:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead175
		cmp	bx, [edi]	; Are we smaller?
		jb		nextAddr175		; Yes, go to the next address
		cmp	bx, [edi+4]	; Are we bigger?
		jbe	callRoutine175

nextAddr175:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop175

callRoutine175:
		mov	dx, bx	; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit175

memoryRead175:
		mov	dl, [ebp + ebx]	; Get our data

readExit175:
		mov	byte [_z80af], ah
		sahf
		cmp	al, dl	; Do our comparison
		lahf
		and	ah, 0fah	; No P/V or carry!
		dec	cx	; Dec BC
		jz	notBcZero176
		or	ah, 04h	; P/V set when BC not zero
notBcZero176:
		or	ah, 02h	; N Gets set when we do compares
		mov	dl, byte [_z80af]
		and	dl, 01h
		or	ah, dl	; Preserve carry!
		inc	bx	; Increment!
		xor	edx, edx
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInsta2:
		sub	dword [cyclesRemaining], byte 16
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 16
		push	cx	; Save BC
		xor	ch, ch ; Not 16 bit for this instruction
		mov	edi, [_z80IoRead]	; Point to the read array

checkLoop177:
		cmp	[edi], word 0ffffh ; End of the list?
		je		ioRead177
		cmp	cx, [edi]	; Are we smaller?
		jb		nextAddr177		; Yes, go to the next address
		cmp	cx, [edi+2]	; Are we bigger?
		jbe	callRoutine177

nextAddr177:
		add	edi, 0ch		; Next structure!
		jmp	short checkLoop177

callRoutine177:
		mov	dx, cx	; Get our address
		call	ReadIOByte	; Standard read routine
		mov	dl, al	; Put it in DL for later consumption
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit177

ioRead177:
		mov	dl, 0ffh	; An unreferenced read
readExit177:
		pop	cx	; Restore BC
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop178:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite178	; Yes - go write it!
		cmp	bx, [edi]	; Are we smaller?
		jb	nextAddr178	; Yes... go to the next addr
		cmp	bx, [edi+4]	; Are we smaller?
		jbe	callRoutine178	; If not, go call it!

nextAddr178:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop178

callRoutine178:
		mov	dx, bx	; Get our address to target
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit178
memoryWrite178:
		mov	[ebp + ebx], dl
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit178:
		inc	bx	; Increment HL
		dec	ch	; Decrement B (of C)
		jnz	clearFlag176
		or	ah, 040h	; Set the Zero flag!
		jmp	short continue176
clearFlag176:
		and	ah, 0bfh	; Clear the zero flag
continue176:
		or	ah, 02h	; Set negative!
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInsta3:
		sub	dword [cyclesRemaining], byte 16
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 16
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop180:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead180
		cmp	bx, [edi]	; Are we smaller?
		jb		nextAddr180		; Yes, go to the next address
		cmp	bx, [edi+4]	; Are we bigger?
		jbe	callRoutine180

nextAddr180:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop180

callRoutine180:
		mov	dx, bx	; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit180

memoryRead180:
		mov	dl, [ebp + ebx]	; Get our data

readExit180:
		push	cx	; Save BC
		xor	ch, ch	; No 16 bit for this instruction!
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	edi, [_z80IoWrite]	; Point to the I/O write array

checkLoop181:
		cmp	[edi], word 0ffffh ; End of our list?
		je	WriteMacroExit181	; Yes - ignore it!
		cmp	cx, [edi]	; Are we smaller?
		jb	nextAddr181	; Yes... go to the next addr
		cmp	cx, [edi+2]	; Are we bigger?
		jbe	callRoutine181	; If not, go call it!

nextAddr181:
		add	edi, 0ch		; Next structure, please
		jmp	short checkLoop181

callRoutine181:
		mov	dx, cx	; Get our address to target
		call	WriteIOByte	; Go write the data!
WriteMacroExit181:
		pop	cx	; Restore BC now that it has been "OUT"ed
		inc	bx	; Increment HL
		dec	ch	; Decrement B (of C)
		jnz	clearFlag179
		or	ah, 040h	; Set the Zero flag!
		jmp	short continue179
clearFlag179:
		and	ah, 0bfh	; Clear the zero flag
continue179:
		or	ah, 02h	; Set negative!
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInsta8:
		sub	dword [cyclesRemaining], byte 16
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 16
		mov	[_orgval], cx	; Store BC for later
		push	esi	; Save our PC for later
		push	ebp	; Save our base pointer for later
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop182:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead182
		cmp	bx, [edi]	; Are we smaller?
		jb		nextAddr182		; Yes, go to the next address
		cmp	bx, [edi+4]	; Are we bigger?
		jbe	callRoutine182

nextAddr182:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop182

callRoutine182:
		mov	dx, bx	; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit182

memoryRead182:
		mov	dl, [ebp + ebx]	; Get our data

readExit182:
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	dx, [_z80de]
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop183:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite183	; Yes - go write it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr183	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine183	; If not, go call it!

nextAddr183:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop183

callRoutine183:
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit183
memoryWrite183:
		mov	[ebp + edx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit183:
		dec	bx	; Decrement HL
		dec	word [_z80de]	; Decrement DE
		and	ah, 0e9h ; Knock out H & N and P/V
		dec	cx	; Decrement BC
		jz	atZero184 ; We're done!
		or	ah, 04h	; Non-zero - we're still going!
atZero184:
		pop	ebp	; Restore our base pointer
		pop	esi	; Restore PC
		xor	dh, dh	; Make sure we don't hose things
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInsta9:
		sub	dword [cyclesRemaining], byte 16
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 16
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop185:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead185
		cmp	bx, [edi]	; Are we smaller?
		jb		nextAddr185		; Yes, go to the next address
		cmp	bx, [edi+4]	; Are we bigger?
		jbe	callRoutine185

nextAddr185:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop185

callRoutine185:
		mov	dx, bx	; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit185

memoryRead185:
		mov	dl, [ebp + ebx]	; Get our data

readExit185:
		mov	byte [_z80af], ah
		sahf
		cmp	al, dl	; Do our comparison
		lahf
		and	ah, 0fah	; No P/V or carry!
		dec	cx	; Dec BC
		jz	notBcZero186
		or	ah, 04h	; P/V set when BC not zero
notBcZero186:
		or	ah, 02h	; N Gets set when we do compares
		mov	dl, byte [_z80af]
		and	dl, 01h
		or	ah, dl	; Preserve carry!
		dec	bx	; Decrement!
		xor	edx, edx
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInstaa:
		sub	dword [cyclesRemaining], byte 16
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 16
		push	cx	; Save BC
		xor	ch, ch ; Not 16 bit for this instruction
		mov	edi, [_z80IoRead]	; Point to the read array

checkLoop187:
		cmp	[edi], word 0ffffh ; End of the list?
		je		ioRead187
		cmp	cx, [edi]	; Are we smaller?
		jb		nextAddr187		; Yes, go to the next address
		cmp	cx, [edi+2]	; Are we bigger?
		jbe	callRoutine187

nextAddr187:
		add	edi, 0ch		; Next structure!
		jmp	short checkLoop187

callRoutine187:
		mov	dx, cx	; Get our address
		call	ReadIOByte	; Standard read routine
		mov	dl, al	; Put it in DL for later consumption
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit187

ioRead187:
		mov	dl, 0ffh	; An unreferenced read
readExit187:
		pop	cx	; Restore BC
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop188:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite188	; Yes - go write it!
		cmp	bx, [edi]	; Are we smaller?
		jb	nextAddr188	; Yes... go to the next addr
		cmp	bx, [edi+4]	; Are we smaller?
		jbe	callRoutine188	; If not, go call it!

nextAddr188:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop188

callRoutine188:
		mov	dx, bx	; Get our address to target
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit188
memoryWrite188:
		mov	[ebp + ebx], dl
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit188:
		dec	bx	; Decrement HL
		dec	ch	; Decrement B (of C)
		jnz	clearFlag186
		or	ah, 040h	; Set the Zero flag!
		jmp	short continue186
clearFlag186:
		and	ah, 0bfh	; Clear the zero flag
continue186:
		or	ah, 02h	; Set negative!
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInstab:
		sub	dword [cyclesRemaining], byte 16
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 16
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop190:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead190
		cmp	bx, [edi]	; Are we smaller?
		jb		nextAddr190		; Yes, go to the next address
		cmp	bx, [edi+4]	; Are we bigger?
		jbe	callRoutine190

nextAddr190:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop190

callRoutine190:
		mov	dx, bx	; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit190

memoryRead190:
		mov	dl, [ebp + ebx]	; Get our data

readExit190:
		push	cx	; Save BC
		xor	ch, ch	; No 16 bit for this instruction!
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	edi, [_z80IoWrite]	; Point to the I/O write array

checkLoop191:
		cmp	[edi], word 0ffffh ; End of our list?
		je	WriteMacroExit191	; Yes - ignore it!
		cmp	cx, [edi]	; Are we smaller?
		jb	nextAddr191	; Yes... go to the next addr
		cmp	cx, [edi+2]	; Are we bigger?
		jbe	callRoutine191	; If not, go call it!

nextAddr191:
		add	edi, 0ch		; Next structure, please
		jmp	short checkLoop191

callRoutine191:
		mov	dx, cx	; Get our address to target
		call	WriteIOByte	; Go write the data!
WriteMacroExit191:
		pop	cx	; Restore BC now that it has been "OUT"ed
		dec	bx	; Decrement HL
		dec	ch	; Decrement B (of C)
		jnz	clearFlag189
		or	ah, 040h	; Set the Zero flag!
		jmp	short continue189
clearFlag189:
		and	ah, 0bfh	; Clear the zero flag
continue189:
		or	ah, 02h	; Set negative!
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInstb0:
		sub	dword [cyclesRemaining], byte 21
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 21
		mov	[_orgval], cx	; Store BC for later
		push	esi	; Save our PC for later
		push	ebp	; Save our base pointer for later
ldRepeat192:
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop192:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead192
		cmp	bx, [edi]	; Are we smaller?
		jb		nextAddr192		; Yes, go to the next address
		cmp	bx, [edi+4]	; Are we bigger?
		jbe	callRoutine192

nextAddr192:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop192

callRoutine192:
		mov	dx, bx	; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit192

memoryRead192:
		mov	dl, [ebp + ebx]	; Get our data

readExit192:
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	dx, [_z80de]
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop193:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite193	; Yes - go write it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr193	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine193	; If not, go call it!

nextAddr193:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop193

callRoutine193:
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit193
memoryWrite193:
		mov	[ebp + edx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit193:
		inc	bx	; Increment HL
		inc	word [_z80de]	; Increment DE
		dec	cx	; Decrement BC
		jz	noMore194
		jmp	ldRepeat192 ; Loop until we're done!
noMore194:
		and	ah, 0e9h	; No N, P/V, or H!
		shl	eax, 16	; Save this for later
		mov	ax, [_orgval] ; Get our original BC count
		mov	dx, 21	; 21 Clock cycles per iteration
		mul	dx		; Multiply it!
		mov	edx, eax	; Put our value in EDX
		and	edx, 0ffffh ; Only the lower part matters..
		add	[dwElapsedTicks], edx
		sub	[cyclesRemaining], edx
		xor	dh, dh
		shr	eax, 16	; Restore this!
		pop	ebp	; Restore our base pointer
		pop	esi	; Restore PC
		xor	dh, dh	; Make sure we don't hose things
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInstb1:
		sub	dword [cyclesRemaining], byte 21
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 21
		mov	dword [_orgval], 0	; Zero our timing info
cpRepeat194:
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop195:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead195
		cmp	bx, [edi]	; Are we smaller?
		jb		nextAddr195		; Yes, go to the next address
		cmp	bx, [edi+4]	; Are we bigger?
		jbe	callRoutine195

nextAddr195:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop195

callRoutine195:
		mov	dx, bx	; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit195

memoryRead195:
		mov	dl, [ebp + ebx]	; Get our data

readExit195:
		mov	byte [_z80af], ah
		sahf
		cmp	al, dl	; Do our comparison
		lahf
		and	ah, 0fah	; No P/V or carry!
		dec	cx	; Dec BC
		jz	notBcZero196
		or	ah, 04h	; P/V set when BC not zero
notBcZero196:
		or	ah, 02h	; N Gets set when we do compares
		mov	dl, byte [_z80af]
		and	dl, 01h
		or	ah, dl	; Preserve carry!
		inc	bx	; Increment!
		sahf
		jz	BCDone194
		jnp	BCDone194
		add	dword [_orgval], 21	; 21 T-States when not done
		jmp	cpRepeat194
BCDone194:
		mov	edx, dword [_orgval]
		add	[dwElapsedTicks], edx
		sub	[cyclesRemaining], edx
		xor	edx, edx
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInstb2:
		sub	dword [cyclesRemaining], byte 21
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 21
loopIt196:
		push	cx	; Save BC
		xor	ch, ch ; Not 16 bit for this instruction
		mov	edi, [_z80IoRead]	; Point to the read array

checkLoop197:
		cmp	[edi], word 0ffffh ; End of the list?
		je		ioRead197
		cmp	cx, [edi]	; Are we smaller?
		jb		nextAddr197		; Yes, go to the next address
		cmp	cx, [edi+2]	; Are we bigger?
		jbe	callRoutine197

nextAddr197:
		add	edi, 0ch		; Next structure!
		jmp	short checkLoop197

callRoutine197:
		mov	dx, cx	; Get our address
		call	ReadIOByte	; Standard read routine
		mov	dl, al	; Put it in DL for later consumption
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit197

ioRead197:
		mov	dl, 0ffh	; An unreferenced read
readExit197:
		pop	cx	; Restore BC
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop198:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite198	; Yes - go write it!
		cmp	bx, [edi]	; Are we smaller?
		jb	nextAddr198	; Yes... go to the next addr
		cmp	bx, [edi+4]	; Are we smaller?
		jbe	callRoutine198	; If not, go call it!

nextAddr198:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop198

callRoutine198:
		mov	dx, bx	; Get our address to target
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit198
memoryWrite198:
		mov	[ebp + ebx], dl
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit198:
		inc	bx	; Increment HL
		dec	ch	; Decrement B (of C)
		jnz	loopIt196
		jnz	clearFlag196
		or	ah, 040h	; Set the Zero flag!
		jmp	short continue196
clearFlag196:
		and	ah, 0bfh	; Clear the zero flag
continue196:
		or	ah, 02h	; Set negative!
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInstb3:
		sub	dword [cyclesRemaining], byte 16
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 16
loopIt199:
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop200:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead200
		cmp	bx, [edi]	; Are we smaller?
		jb		nextAddr200		; Yes, go to the next address
		cmp	bx, [edi+4]	; Are we bigger?
		jbe	callRoutine200

nextAddr200:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop200

callRoutine200:
		mov	dx, bx	; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit200

memoryRead200:
		mov	dl, [ebp + ebx]	; Get our data

readExit200:
		push	cx	; Save BC
		xor	ch, ch	; No 16 bit for this instruction!
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	edi, [_z80IoWrite]	; Point to the I/O write array

checkLoop201:
		cmp	[edi], word 0ffffh ; End of our list?
		je	WriteMacroExit201	; Yes - ignore it!
		cmp	cx, [edi]	; Are we smaller?
		jb	nextAddr201	; Yes... go to the next addr
		cmp	cx, [edi+2]	; Are we bigger?
		jbe	callRoutine201	; If not, go call it!

nextAddr201:
		add	edi, 0ch		; Next structure, please
		jmp	short checkLoop201

callRoutine201:
		mov	dx, cx	; Get our address to target
		call	WriteIOByte	; Go write the data!
WriteMacroExit201:
		pop	cx	; Restore BC now that it has been "OUT"ed
		inc	bx	; Increment HL
		dec	ch	; Decrement B (of C)
		jnz	loopIt199
		jnz	clearFlag199
		or	ah, 040h	; Set the Zero flag!
		jmp	short continue199
clearFlag199:
		and	ah, 0bfh	; Clear the zero flag
continue199:
		or	ah, 02h	; Set negative!
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInstb8:
		sub	dword [cyclesRemaining], byte 21
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 21
		mov	[_orgval], cx	; Store BC for later
		push	esi	; Save our PC for later
		push	ebp	; Save our base pointer for later
ldRepeat202:
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop202:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead202
		cmp	bx, [edi]	; Are we smaller?
		jb		nextAddr202		; Yes, go to the next address
		cmp	bx, [edi+4]	; Are we bigger?
		jbe	callRoutine202

nextAddr202:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop202

callRoutine202:
		mov	dx, bx	; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit202

memoryRead202:
		mov	dl, [ebp + ebx]	; Get our data

readExit202:
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	dx, [_z80de]
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop203:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite203	; Yes - go write it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr203	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine203	; If not, go call it!

nextAddr203:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop203

callRoutine203:
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit203
memoryWrite203:
		mov	[ebp + edx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit203:
		dec	bx	; Decrement HL
		dec	word [_z80de]	; Decrement DE
		dec	cx	; Decrement BC
		jz	noMore204
		jmp	ldRepeat202 ; Loop until we're done!
noMore204:
		and	ah, 0e9h	; No N, P/V, or H!
		shl	eax, 16	; Save this for later
		mov	ax, [_orgval] ; Get our original BC count
		mov	dx, 21	; 21 Clock cycles per iteration
		mul	dx		; Multiply it!
		mov	edx, eax	; Put our value in EDX
		and	edx, 0ffffh ; Only the lower part matters..
		add	[dwElapsedTicks], edx
		sub	[cyclesRemaining], edx
		xor	dh, dh
		shr	eax, 16	; Restore this!
		pop	ebp	; Restore our base pointer
		pop	esi	; Restore PC
		xor	dh, dh	; Make sure we don't hose things
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInstb9:
		sub	dword [cyclesRemaining], byte 21
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 21
		mov	dword [_orgval], 0	; Zero our timing info
cpRepeat204:
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop205:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead205
		cmp	bx, [edi]	; Are we smaller?
		jb		nextAddr205		; Yes, go to the next address
		cmp	bx, [edi+4]	; Are we bigger?
		jbe	callRoutine205

nextAddr205:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop205

callRoutine205:
		mov	dx, bx	; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit205

memoryRead205:
		mov	dl, [ebp + ebx]	; Get our data

readExit205:
		mov	byte [_z80af], ah
		sahf
		cmp	al, dl	; Do our comparison
		lahf
		and	ah, 0fah	; No P/V or carry!
		dec	cx	; Dec BC
		jz	notBcZero206
		or	ah, 04h	; P/V set when BC not zero
notBcZero206:
		or	ah, 02h	; N Gets set when we do compares
		mov	dl, byte [_z80af]
		and	dl, 01h
		or	ah, dl	; Preserve carry!
		dec	bx	; Decrement!
		sahf
		jz	BCDone204
		jnp	BCDone204
		add	dword [_orgval], 21	; 21 T-States when not done
		jmp	cpRepeat204
BCDone204:
		mov	edx, dword [_orgval]
		add	[dwElapsedTicks], edx
		sub	[cyclesRemaining], edx
		xor	edx, edx
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInstba:
		sub	dword [cyclesRemaining], byte 21
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 21
loopIt206:
		push	cx	; Save BC
		xor	ch, ch ; Not 16 bit for this instruction
		mov	edi, [_z80IoRead]	; Point to the read array

checkLoop207:
		cmp	[edi], word 0ffffh ; End of the list?
		je		ioRead207
		cmp	cx, [edi]	; Are we smaller?
		jb		nextAddr207		; Yes, go to the next address
		cmp	cx, [edi+2]	; Are we bigger?
		jbe	callRoutine207

nextAddr207:
		add	edi, 0ch		; Next structure!
		jmp	short checkLoop207

callRoutine207:
		mov	dx, cx	; Get our address
		call	ReadIOByte	; Standard read routine
		mov	dl, al	; Put it in DL for later consumption
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit207

ioRead207:
		mov	dl, 0ffh	; An unreferenced read
readExit207:
		pop	cx	; Restore BC
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop208:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite208	; Yes - go write it!
		cmp	bx, [edi]	; Are we smaller?
		jb	nextAddr208	; Yes... go to the next addr
		cmp	bx, [edi+4]	; Are we smaller?
		jbe	callRoutine208	; If not, go call it!

nextAddr208:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop208

callRoutine208:
		mov	dx, bx	; Get our address to target
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit208
memoryWrite208:
		mov	[ebp + ebx], dl
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit208:
		dec	bx	; Decrement HL
		dec	ch	; Decrement B (of C)
		jnz	loopIt206
		jnz	clearFlag206
		or	ah, 040h	; Set the Zero flag!
		jmp	short continue206
clearFlag206:
		and	ah, 0bfh	; Clear the zero flag
continue206:
		or	ah, 02h	; Set negative!
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInstbb:
		sub	dword [cyclesRemaining], byte 16
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 16
loopIt209:
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop210:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead210
		cmp	bx, [edi]	; Are we smaller?
		jb		nextAddr210		; Yes, go to the next address
		cmp	bx, [edi+4]	; Are we bigger?
		jbe	callRoutine210

nextAddr210:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop210

callRoutine210:
		mov	dx, bx	; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit210

memoryRead210:
		mov	dl, [ebp + ebx]	; Get our data

readExit210:
		push	cx	; Save BC
		xor	ch, ch	; No 16 bit for this instruction!
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	edi, [_z80IoWrite]	; Point to the I/O write array

checkLoop211:
		cmp	[edi], word 0ffffh ; End of our list?
		je	WriteMacroExit211	; Yes - ignore it!
		cmp	cx, [edi]	; Are we smaller?
		jb	nextAddr211	; Yes... go to the next addr
		cmp	cx, [edi+2]	; Are we bigger?
		jbe	callRoutine211	; If not, go call it!

nextAddr211:
		add	edi, 0ch		; Next structure, please
		jmp	short checkLoop211

callRoutine211:
		mov	dx, cx	; Get our address to target
		call	WriteIOByte	; Go write the data!
WriteMacroExit211:
		pop	cx	; Restore BC now that it has been "OUT"ed
		dec	bx	; Decrement HL
		dec	ch	; Decrement B (of C)
		jnz	loopIt209
		jnz	clearFlag209
		or	ah, 040h	; Set the Zero flag!
		jmp	short continue209
clearFlag209:
		and	ah, 0bfh	; Clear the zero flag
continue209:
		or	ah, 02h	; Set negative!
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst09:
		sub	dword [cyclesRemaining], byte 15
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 15
		mov	dh, ah	; Get our flags
		and	dh, 0ech	; Preserve the top three and bits 2 & 3
		mov	di, [_z80ix]	; Get our value
		mov	[_orgval], di	; Store our original value
		add	di, cx
		lahf
		mov	[_z80ix], di	; Store our register back
		mov	di, [_orgval]	; Get original
		xor	di, word [_z80ix] ; XOR It with our computed value
		xor	di, cx
		and	di, 1000h	; Just our half carry
		or		dx, di	; Or in our flags
		and	ah, 01h	; Just carry
		or	ah, dh
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst19:
		sub	dword [cyclesRemaining], byte 15
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 15
		mov	dh, ah	; Get our flags
		and	dh, 0ech	; Preserve the top three and bits 2 & 3
		mov	di, [_z80ix]	; Get our value
		mov	[_orgval], di	; Store our original value
		add	di, word [_z80de]
		lahf
		mov	[_z80ix], di	; Store our register back
		mov	di, [_orgval]	; Get original
		xor	di, word [_z80ix] ; XOR It with our computed value
		xor	di, word [_z80de]
		and	di, 1000h	; Just our half carry
		or		dx, di	; Or in our flags
		and	ah, 01h	; Just carry
		or	ah, dh
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst21:
		sub	dword [cyclesRemaining], byte 14
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 14
		mov	di, [esi]	; Get our word to load
		add	esi, 2	; Advance past the word
		mov	[_z80ix], di ; Store our new value
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst22:
		sub	dword [cyclesRemaining], byte 20
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 20
		mov	dx, [esi]	 ; Get our address to store
		add	esi, 2
		mov	[_orgval], dx
		mov	dl, [_z80ix]
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	dx, [_orgval]
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop212:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite212	; Yes - go write it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr212	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine212	; If not, go call it!

nextAddr212:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop212

callRoutine212:
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit212
memoryWrite212:
		mov	[ebp + edx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit212:
		inc	word [_orgval]
		mov	dl, [_z80ix + 1]
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	dx, [_orgval]
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop213:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite213	; Yes - go write it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr213	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine213	; If not, go call it!

nextAddr213:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop213

callRoutine213:
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit213
memoryWrite213:
		mov	[ebp + edx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit213:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst23:
		sub	dword [cyclesRemaining], byte 10
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 10
		inc	word [_z80ix]	; Increment our mz80Index register
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst24:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		sahf
		inc	byte [_z80ix + 1]
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		xor	dh, dh
		and	ah, 0fdh	; Knock out N!
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst25:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		sahf
		dec	byte [_z80ix + 1]
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		xor	dh, dh
		or	ah, 02h	; Set negative!
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst26:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dl, [esi]	; Get immediate byte to load
		inc	esi	; Next byte
		mov	byte [_z80ix + 1], dl
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst29:
		sub	dword [cyclesRemaining], byte 15
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 15
		mov	dh, ah	; Get our flags
		and	dh, 0ech	; Preserve the top three and bits 2 & 3
		mov	di, [_z80ix]	; Get our value
		mov	[_orgval], di	; Store our original value
		add	di, di
		lahf
		mov	[_z80ix], di	; Store our register back
		mov	di, [_orgval]	; Get original
		xor	di, word [_z80ix] ; XOR It with our computed value
		xor	di, di
		and	di, 1000h	; Just our half carry
		or		dx, di	; Or in our flags
		and	ah, 01h	; Just carry
		or	ah, dh
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst2a:
		sub	dword [cyclesRemaining], byte 20
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 20
		mov	dx, [esi]	 ; Get our address to store
		add	esi, 2
		mov	[_orgval], dx
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop214:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead214
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr214		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine214

nextAddr214:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop214

callRoutine214:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit214

memoryRead214:
		mov	dl, [ebp + edx]	; Get our data

readExit214:
		mov	[_z80ix], dl
		inc	word [_orgval]
		mov	dx, [_orgval]
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop215:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead215
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr215		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine215

nextAddr215:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop215

callRoutine215:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit215

memoryRead215:
		mov	dl, [ebp + edx]	; Get our data

readExit215:
		mov	[_z80ix + 1], dl
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst2b:
		sub	dword [cyclesRemaining], byte 10
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 10
		dec	word [_z80ix]	; Increment our mz80Index register
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst2c:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		sahf
		inc	byte [_z80ix]
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		xor	dh, dh
		and	ah, 0fdh	; Knock out N!
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst2d:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		sahf
		dec	byte [_z80ix]
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		xor	dh, dh
		or	ah, 02h	; Set negative!
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst2e:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dl, [esi]	; Get immediate byte to load
		inc	esi	; Next byte
		mov	byte [_z80ix], dl
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst34:
		sub	dword [cyclesRemaining], byte 23
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 23
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned216	; Nope!
		dec	dh			; Make it FFable
notSigned216:
		add	dx, [_z80ix]	; Our offset!
		mov	[_orgval], dx
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop217:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead217
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr217		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine217

nextAddr217:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop217

callRoutine217:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit217

memoryRead217:
		mov	dl, [ebp + edx]	; Get our data

readExit217:
		sahf
		inc	dl
		lahf
		o16	pushf
		shl	edx, 16
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		shr	edx, 16
		and	ah, 0fdh	; Knock out N!
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	dx, [_orgval]
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop218:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite218	; Yes - go write it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr218	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine218	; If not, go call it!

nextAddr218:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop218

callRoutine218:
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit218
memoryWrite218:
		mov	[ebp + edx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit218:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst35:
		sub	dword [cyclesRemaining], byte 23
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 23
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned219	; Nope!
		dec	dh			; Make it FFable
notSigned219:
		add	dx, [_z80ix]	; Our offset!
		mov	[_orgval], dx
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop220:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead220
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr220		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine220

nextAddr220:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop220

callRoutine220:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit220

memoryRead220:
		mov	dl, [ebp + edx]	; Get our data

readExit220:
		sahf
		dec	dl
		lahf
		o16	pushf
		shl	edx, 16
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		shr	edx, 16
		or		ah, 02h	; Make it N!
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	dx, [_orgval]
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop221:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite221	; Yes - go write it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr221	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine221	; If not, go call it!

nextAddr221:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop221

callRoutine221:
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit221
memoryWrite221:
		mov	[ebp + edx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit221:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst36:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dx, [esi]	; Get our address
		add	esi, 2	; Skip over our storage bytes
		mov	di, dx	; Store it here for later
		xor	dh, dh
		or	dl, dl
		jns	noNegate222
		dec	dh
noNegate222:
		add	dx, [_z80ix]	; Add in our index
		mov	[_orgval], dx	; Store our address to write to
		mov	dx, di
		xchg	dh, dl
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	dx, [_orgval]
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop222:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite222	; Yes - go write it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr222	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine222	; If not, go call it!

nextAddr222:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop222

callRoutine222:
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit222
memoryWrite222:
		mov	[ebp + edx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit222:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst39:
		sub	dword [cyclesRemaining], byte 15
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 15
		mov	dh, ah	; Get our flags
		and	dh, 0ech	; Preserve the top three and bits 2 & 3
		mov	di, [_z80ix]	; Get our value
		mov	[_orgval], di	; Store our original value
		add	di, word [_z80sp]
		lahf
		mov	[_z80ix], di	; Store our register back
		mov	di, [_orgval]	; Get original
		xor	di, word [_z80ix] ; XOR It with our computed value
		xor	di, word [_z80sp]
		and	di, 1000h	; Just our half carry
		or		dx, di	; Or in our flags
		and	ah, 01h	; Just carry
		or	ah, dh
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst44:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	ch, byte [_z80ix + 1]
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst45:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	ch, byte [_z80ix + 0]
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst46:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned224	; Nope!
		dec	dh			; Make it FFable
notSigned224:
		add	dx, [_z80ix]	; Our offset!
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop225:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead225
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr225		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine225

nextAddr225:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop225

callRoutine225:
		call	ReadMemoryByte	; Standard read routine
		mov	ch, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit225

memoryRead225:
		mov	ch, [ebp + edx]	; Get our data

readExit225:
		xor	dh, dh	; Make sure we don't hose things
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst4c:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	cl, byte [_z80ix + 1]
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst4d:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	cl, byte [_z80ix + 0]
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst4e:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned227	; Nope!
		dec	dh			; Make it FFable
notSigned227:
		add	dx, [_z80ix]	; Our offset!
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop228:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead228
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr228		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine228

nextAddr228:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop228

callRoutine228:
		call	ReadMemoryByte	; Standard read routine
		mov	cl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit228

memoryRead228:
		mov	cl, [ebp + edx]	; Get our data

readExit228:
		xor	dh, dh	; Make sure we don't hose things
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst54:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dx, [_z80de]	; Get a usable copy of DE here
		mov	dh, byte [_z80ix + 1]
		mov	[_z80de], dx	; Put it back!
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst55:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dx, [_z80de]	; Get a usable copy of DE here
		mov	dh, byte [_z80ix + 0]
		mov	[_z80de], dx	; Put it back!
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst56:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned230	; Nope!
		dec	dh			; Make it FFable
notSigned230:
		add	dx, [_z80ix]	; Our offset!
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop231:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead231
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr231		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine231

nextAddr231:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop231

callRoutine231:
		call	ReadMemoryByte	; Standard read routine
		mov	byte [_z80de + 1], al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit231

memoryRead231:
		mov	di, dx
		mov	dl, [ebp + edx]
		mov	byte [_z80de + 1], dl
		mov	dx, di
readExit231:
		xor	dh, dh	; Make sure we don't hose things
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst5c:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dx, [_z80de]	; Get a usable copy of DE here
		mov	dl, byte [_z80ix + 1]
		mov	[_z80de], dx	; Put it back!
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst5d:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dx, [_z80de]	; Get a usable copy of DE here
		mov	dl, byte [_z80ix + 0]
		mov	[_z80de], dx	; Put it back!
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst5e:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned233	; Nope!
		dec	dh			; Make it FFable
notSigned233:
		add	dx, [_z80ix]	; Our offset!
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop234:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead234
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr234		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine234

nextAddr234:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop234

callRoutine234:
		call	ReadMemoryByte	; Standard read routine
		mov	byte [_z80de], al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit234

memoryRead234:
		mov	di, dx
		mov	dl, [ebp + edx]
		mov	byte [_z80de], dl
		mov	dx, di
readExit234:
		xor	dh, dh	; Make sure we don't hose things
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst60:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov   byte [_z80ix + 1], ch
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst61:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov   byte [_z80ix + 1], cl
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst62:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
	mov	dx, [_z80de]	; Get DE
		mov   byte [_z80ix + 1], dh
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst63:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
	mov	dx, [_z80de]	; Get DE
		mov   byte [_z80ix + 1], dl
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst64:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
	mov	dh, byte [_z80ix + 1]
		mov   byte [_z80ix + 1], bh
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst65:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
	mov	dl, byte [_z80ix]
		mov   byte [_z80ix + 1], bl
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst66:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned236	; Nope!
		dec	dh			; Make it FFable
notSigned236:
		add	dx, [_z80ix]	; Our offset!
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop237:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead237
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr237		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine237

nextAddr237:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop237

callRoutine237:
		call	ReadMemoryByte	; Standard read routine
		mov	bh, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit237

memoryRead237:
		mov	bh, [ebp + edx]	; Get our data

readExit237:
		xor	dh, dh	; Make sure we don't hose things
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst67:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov   byte [_z80ix + 1], al
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst68:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov   byte [_z80ix + 0], ch
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst69:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov   byte [_z80ix + 0], cl
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst6a:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
	mov	dx, [_z80de]	; Get DE
		mov   byte [_z80ix + 0], dh
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst6b:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
	mov	dx, [_z80de]	; Get DE
		mov   byte [_z80ix + 0], dl
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst6c:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
	mov	dh, byte [_z80ix + 1]
		mov   byte [_z80ix + 0], bh
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst6d:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
	mov	dl, byte [_z80ix]
		mov   byte [_z80ix + 0], bl
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst6e:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned239	; Nope!
		dec	dh			; Make it FFable
notSigned239:
		add	dx, [_z80ix]	; Our offset!
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop240:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead240
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr240		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine240

nextAddr240:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop240

callRoutine240:
		call	ReadMemoryByte	; Standard read routine
		mov	bl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit240

memoryRead240:
		mov	bl, [ebp + edx]	; Get our data

readExit240:
		xor	dh, dh	; Make sure we don't hose things
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst6f:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov   byte [_z80ix + 0], al
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst70:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned242	; Nope!
		dec	dh			; Make it FFable
notSigned242:
		add	dx, [_z80ix]	; Our offset!
		mov	[_z80af], ax	; Store AF
		mov	al, ch	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop243:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite243	; Yes - go write it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr243	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine243	; If not, go call it!

nextAddr243:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop243

callRoutine243:
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit243
memoryWrite243:
		mov	[ebp + edx], ch
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit243:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst71:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned244	; Nope!
		dec	dh			; Make it FFable
notSigned244:
		add	dx, [_z80ix]	; Our offset!
		mov	[_z80af], ax	; Store AF
		mov	al, cl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop245:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite245	; Yes - go write it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr245	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine245	; If not, go call it!

nextAddr245:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop245

callRoutine245:
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit245
memoryWrite245:
		mov	[ebp + edx], cl
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit245:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst72:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned246	; Nope!
		dec	dh			; Make it FFable
notSigned246:
		add	dx, [_z80ix]	; Our offset!
		mov	[_z80af], ax	; Store AF
		mov	al, byte [_z80de + 1]	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop247:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite247	; Yes - go write it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr247	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine247	; If not, go call it!

nextAddr247:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop247

callRoutine247:
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit247
memoryWrite247:
		mov	edi, edx
		mov	dl, byte [_z80de + 1]
		mov	[ebp + edi], dl
		mov	edx, edi
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit247:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst73:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned248	; Nope!
		dec	dh			; Make it FFable
notSigned248:
		add	dx, [_z80ix]	; Our offset!
		mov	[_z80af], ax	; Store AF
		mov	al, byte [_z80de]	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop249:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite249	; Yes - go write it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr249	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine249	; If not, go call it!

nextAddr249:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop249

callRoutine249:
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit249
memoryWrite249:
		mov	edi, edx
		mov	dl, byte [_z80de]
		mov	[ebp + edi], dl
		mov	edx, edi
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit249:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst74:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned250	; Nope!
		dec	dh			; Make it FFable
notSigned250:
		add	dx, [_z80ix]	; Our offset!
		mov	[_z80af], ax	; Store AF
		mov	al, bh	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop251:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite251	; Yes - go write it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr251	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine251	; If not, go call it!

nextAddr251:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop251

callRoutine251:
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit251
memoryWrite251:
		mov	[ebp + edx], bh
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit251:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst75:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned252	; Nope!
		dec	dh			; Make it FFable
notSigned252:
		add	dx, [_z80ix]	; Our offset!
		mov	[_z80af], ax	; Store AF
		mov	al, bl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop253:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite253	; Yes - go write it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr253	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine253	; If not, go call it!

nextAddr253:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop253

callRoutine253:
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit253
memoryWrite253:
		mov	[ebp + edx], bl
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit253:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst77:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned254	; Nope!
		dec	dh			; Make it FFable
notSigned254:
		add	dx, [_z80ix]	; Our offset!
		mov	[_z80af], ax	; Store AF
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop255:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite255	; Yes - go write it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr255	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine255	; If not, go call it!

nextAddr255:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop255

callRoutine255:
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit255
memoryWrite255:
		mov	[ebp + edx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit255:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst7c:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	al, byte [_z80ix + 1]
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst7d:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	al, byte [_z80ix + 0]
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst7e:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned256	; Nope!
		dec	dh			; Make it FFable
notSigned256:
		add	dx, [_z80ix]	; Our offset!
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop257:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead257
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr257		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine257

nextAddr257:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop257

callRoutine257:
		call	ReadMemoryByte	; Standard read routine
		mov	[_z80af], al	; Save our new accumulator
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit257

memoryRead257:
		mov	al, [ebp + edx]	; Get our data

readExit257:
		xor	dh, dh	; Make sure we don't hose things
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst84:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dl, byte [_z80ix + 1]
		sahf		; Store our flags in x86 flag reg
		add	al, dl
		lahf		; Get flags back into AH
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		xor	dh, dh
		and	ah, 0fdh ; No N!
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst85:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dl, byte [_z80ix]
		sahf		; Store our flags in x86 flag reg
		add	al, dl
		lahf		; Get flags back into AH
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		xor	dh, dh
		and	ah, 0fdh ; No N!
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst86:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned259	; Nope!
		dec	dh			; Make it FFable
notSigned259:
		add	dx, [_z80ix]	; Our offset!
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop260:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead260
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr260		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine260

nextAddr260:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop260

callRoutine260:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit260

memoryRead260:
		mov	dl, [ebp + edx]	; Get our data

readExit260:
		sahf
		add	al, dl
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		and	ah, 0fdh	; Knock out negative
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst8c:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dl, byte [_z80ix + 1]
		sahf		; Store our flags in x86 flag reg
		adc	al, dl
		lahf		; Get flags back into AH
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		xor	dh, dh
		and	ah, 0fdh ; No N!
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst8d:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dl, byte [_z80ix]
		sahf		; Store our flags in x86 flag reg
		adc	al, dl
		lahf		; Get flags back into AH
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		xor	dh, dh
		and	ah, 0fdh ; No N!
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst8e:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned261	; Nope!
		dec	dh			; Make it FFable
notSigned261:
		add	dx, [_z80ix]	; Our offset!
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop262:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead262
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr262		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine262

nextAddr262:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop262

callRoutine262:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit262

memoryRead262:
		mov	dl, [ebp + edx]	; Get our data

readExit262:
		sahf
		adc	al, dl
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		and	ah, 0fdh	; Knock out negative
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst94:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dl, byte [_z80ix + 1]
		sahf		; Store our flags in x86 flag reg
		sub	al, dl
		lahf		; Get flags back into AH
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		xor	dh, dh
		or	ah, 02h	; N Gets set!
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst95:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dl, byte [_z80ix]
		sahf		; Store our flags in x86 flag reg
		sub	al, dl
		lahf		; Get flags back into AH
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		xor	dh, dh
		or	ah, 02h	; N Gets set!
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst96:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned263	; Nope!
		dec	dh			; Make it FFable
notSigned263:
		add	dx, [_z80ix]	; Our offset!
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop264:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead264
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr264		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine264

nextAddr264:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop264

callRoutine264:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit264

memoryRead264:
		mov	dl, [ebp + edx]	; Get our data

readExit264:
		sahf
		sub	al, dl
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		or	ah, 02h	; Set negative
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst9c:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dl, byte [_z80ix + 1]
		sahf		; Store our flags in x86 flag reg
		sbb	al, dl
		lahf		; Get flags back into AH
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		xor	dh, dh
		or	ah, 02h	; N Gets set!
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst9d:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dl, byte [_z80ix]
		sahf		; Store our flags in x86 flag reg
		sbb	al, dl
		lahf		; Get flags back into AH
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		xor	dh, dh
		or	ah, 02h	; N Gets set!
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst9e:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned265	; Nope!
		dec	dh			; Make it FFable
notSigned265:
		add	dx, [_z80ix]	; Our offset!
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop266:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead266
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr266		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine266

nextAddr266:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop266

callRoutine266:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit266

memoryRead266:
		mov	dl, [ebp + edx]	; Get our data

readExit266:
		sahf
		sbb	al, dl
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		or	ah, 02h	; Set negative
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInsta4:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dl, byte [_z80ix + 1]
		sahf		; Store our flags in x86 flag reg
		and	al, dl
		lahf		; Get flags back into AH
		and	ah, 0ech	; Only these flags matter!
		or	ah, 010h	; Half carry gets set
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInsta5:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dl, byte [_z80ix]
		sahf		; Store our flags in x86 flag reg
		and	al, dl
		lahf		; Get flags back into AH
		and	ah, 0ech	; Only these flags matter!
		or	ah, 010h	; Half carry gets set
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInsta6:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned267	; Nope!
		dec	dh			; Make it FFable
notSigned267:
		add	dx, [_z80ix]	; Our offset!
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop268:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead268
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr268		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine268

nextAddr268:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop268

callRoutine268:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit268

memoryRead268:
		mov	dl, [ebp + edx]	; Get our data

readExit268:
		sahf
		and	al, dl
		lahf
		and	ah,0fch	; Knock out N & C
		or	ah, 10h	; Set half carry
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInstac:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dl, byte [_z80ix + 1]
		sahf		; Store our flags in x86 flag reg
		xor	al, dl
		lahf		; Get flags back into AH
		and	ah, 0ech	; Only these flags matter!
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInstad:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dl, byte [_z80ix]
		sahf		; Store our flags in x86 flag reg
		xor	al, dl
		lahf		; Get flags back into AH
		and	ah, 0ech	; Only these flags matter!
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInstae:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned269	; Nope!
		dec	dh			; Make it FFable
notSigned269:
		add	dx, [_z80ix]	; Our offset!
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop270:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead270
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr270		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine270

nextAddr270:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop270

callRoutine270:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit270

memoryRead270:
		mov	dl, [ebp + edx]	; Get our data

readExit270:
		sahf
		xor	al, dl
		lahf
		and	ah, 0ech	; Knock out H, N, and C
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInstb4:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dl, byte [_z80ix + 1]
		sahf		; Store our flags in x86 flag reg
		or	al, dl
		lahf		; Get flags back into AH
		and	ah, 0ech ; No H, N, or C
		and	ah, 0ech ; No H, N, or C
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInstb5:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dl, byte [_z80ix]
		sahf		; Store our flags in x86 flag reg
		or	al, dl
		lahf		; Get flags back into AH
		and	ah, 0ech ; No H, N, or C
		and	ah, 0ech ; No H, N, or C
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInstb6:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned271	; Nope!
		dec	dh			; Make it FFable
notSigned271:
		add	dx, [_z80ix]	; Our offset!
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop272:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead272
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr272		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine272

nextAddr272:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop272

callRoutine272:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit272

memoryRead272:
		mov	dl, [ebp + edx]	; Get our data

readExit272:
		sahf
		or	al, dl
		lahf
		and	ah, 0ech	; Knock out H, N, and C
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInstbc:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dl, byte [_z80ix + 1]
		sahf		; Store our flags in x86 flag reg
		cmp	al, dl
		lahf		; Get flags back into AH
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		xor	dh, dh
		or	ah, 02h	; Negative gets set on a compare
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInstbd:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dl, byte [_z80ix]
		sahf		; Store our flags in x86 flag reg
		cmp	al, dl
		lahf		; Get flags back into AH
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		xor	dh, dh
		or	ah, 02h	; Negative gets set on a compare
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInstbe:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned273	; Nope!
		dec	dh			; Make it FFable
notSigned273:
		add	dx, [_z80ix]	; Our offset!
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop274:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead274
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr274		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine274

nextAddr274:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop274

callRoutine274:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit274

memoryRead274:
		mov	dl, [ebp + edx]	; Get our data

readExit274:
		sahf
		cmp	al, dl
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		or	ah, 02h	; Set negative
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]

DDInstcb:
		mov	[_baseFixup], dword 3
		mov	dx, [esi]	; Get our instruction (and offset)
		add	esi, 2	; Increment our PC
		mov	byte [_orgval], dl ; Store our value
		or	dl, dl
		js	notNeg275
		mov	byte [_orgval + 1], 00h;
 		jmp	short jumpHandler275
notNeg275:
		mov	byte [_orgval + 1], 0ffh;	It's negative
jumpHandler275:
		shl	ebx, 16	; Save BX away
		mov	bx, [_z80ix]
		add	[_orgval], bx
		shr	ebx, 16	; Restore BX
		mov	dl, dh	; Get our instruction
		xor	dh, dh	; Zero this
		jmp	dword [z80ddfdcbInstructions+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInste1:
		sub	dword [cyclesRemaining], byte 14
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 14
		mov	dx, [_z80sp]
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop276:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead276
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr276		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine276

nextAddr276:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop276

callRoutine276:
		call	ReadMemoryByte	; Standard read routine
		mov	byte [_z80ix], al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit276

memoryRead276:
		mov	di, dx
		mov	dl, [ebp + edx]
		mov	byte [_z80ix], dl
		mov	dx, di
readExit276:
		inc	dx
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop277:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead277
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr277		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine277

nextAddr277:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop277

callRoutine277:
		call	ReadMemoryByte	; Standard read routine
		mov	byte [_z80ix + 1], al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit277

memoryRead277:
		mov	di, dx
		mov	dl, [ebp + edx]
		mov	byte [_z80ix + 1], dl
		mov	dx, di
readExit277:
		add	word [_z80sp], 2
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInste3:
		sub	dword [cyclesRemaining], byte 23
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 23
		mov	dx, word [_z80sp]
		xor	edi, edi
		mov	di, [_z80ix]
		xchg	di, [ebp+edx]
		mov	[_z80ix], di
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInste5:
		sub	dword [cyclesRemaining], byte 15
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 15
		sub	word [_z80sp], 2
		mov	dx, [_z80sp]
		mov	[_z80af], ax	; Store AF
		mov	al, byte [_z80ix]	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop278:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite278	; Yes - go write it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr278	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine278	; If not, go call it!

nextAddr278:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop278

callRoutine278:
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit278
memoryWrite278:
		mov	edi, edx
		mov	dl, byte [_z80ix]
		mov	[ebp + edi], dl
		mov	edx, edi
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit278:
		inc	dx
		mov	[_z80af], ax	; Store AF
		mov	al, byte [_z80ix + 1]	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop279:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite279	; Yes - go write it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr279	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine279	; If not, go call it!

nextAddr279:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop279

callRoutine279:
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit279
memoryWrite279:
		mov	edi, edx
		mov	dl, byte [_z80ix + 1]
		mov	[ebp + edi], dl
		mov	edx, edi
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit279:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInste9:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80ix]	; Get our value
		mov	esi, edx		; New PC!
		add	esi, ebp		; Add in our base
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInstf9:
		sub	dword [cyclesRemaining], byte 10
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 10
		mov	di, [_z80ix] ; Get our source register
		mov	word [_z80sp], di	; Store our new SP
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDFDCBInst06:
		sub	dword [cyclesRemaining], byte 23
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 23
		mov	dx, [_orgval]	; Get our target address
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop280:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead280
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr280		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine280

nextAddr280:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop280

callRoutine280:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit280

memoryRead280:
		mov	dl, [ebp + edx]	; Get our data

readExit280:
		sahf		; Restore our flags
		rol	dl, 1
		lahf		; Get our flags back
		and	ah, 0edh	; Knock out H & N
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	dx, [_orgval]
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop281:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite281	; Yes - go write it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr281	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine281	; If not, go call it!

nextAddr281:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop281

callRoutine281:
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit281
memoryWrite281:
		mov	[ebp + edx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit281:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDFDCBInst0e:
		sub	dword [cyclesRemaining], byte 23
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 23
		mov	dx, [_orgval]	; Get our target address
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop282:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead282
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr282		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine282

nextAddr282:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop282

callRoutine282:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit282

memoryRead282:
		mov	dl, [ebp + edx]	; Get our data

readExit282:
		sahf		; Restore our flags
		ror	dl, 1
		lahf		; Get our flags back
		and	ah, 0edh	; Knock out H & N
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	dx, [_orgval]
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop283:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite283	; Yes - go write it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr283	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine283	; If not, go call it!

nextAddr283:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop283

callRoutine283:
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit283
memoryWrite283:
		mov	[ebp + edx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit283:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDFDCBInst16:
		sub	dword [cyclesRemaining], byte 23
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 23
		mov	dx, [_orgval]	; Get our target address
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop284:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead284
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr284		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine284

nextAddr284:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop284

callRoutine284:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit284

memoryRead284:
		mov	dl, [ebp + edx]	; Get our data

readExit284:
		sahf		; Restore our flags
		rcl	dl, 1
		lahf		; Get our flags back
		and	ah, 0edh	; Knock out H & N
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	dx, [_orgval]
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop285:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite285	; Yes - go write it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr285	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine285	; If not, go call it!

nextAddr285:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop285

callRoutine285:
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit285
memoryWrite285:
		mov	[ebp + edx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit285:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDFDCBInst1e:
		sub	dword [cyclesRemaining], byte 23
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 23
		mov	dx, [_orgval]	; Get our target address
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop286:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead286
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr286		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine286

nextAddr286:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop286

callRoutine286:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit286

memoryRead286:
		mov	dl, [ebp + edx]	; Get our data

readExit286:
		sahf		; Restore our flags
		rcr	dl, 1
		lahf		; Get our flags back
		and	ah, 0edh	; Knock out H & N
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	dx, [_orgval]
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop287:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite287	; Yes - go write it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr287	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine287	; If not, go call it!

nextAddr287:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop287

callRoutine287:
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit287
memoryWrite287:
		mov	[ebp + edx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit287:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDFDCBInst26:
		sub	dword [cyclesRemaining], byte 23
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 23
		mov	dx, [_orgval]	; Get our target address
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop288:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead288
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr288		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine288

nextAddr288:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop288

callRoutine288:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit288

memoryRead288:
		mov	dl, [ebp + edx]	; Get our data

readExit288:
		sahf		; Restore our flags
		shl	dl, 1
		lahf		; Get our flags back
		and	ah, 0ech	; No Half carry or negative!
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	dx, [_orgval]
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop289:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite289	; Yes - go write it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr289	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine289	; If not, go call it!

nextAddr289:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop289

callRoutine289:
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit289
memoryWrite289:
		mov	[ebp + edx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit289:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDFDCBInst2e:
		sub	dword [cyclesRemaining], byte 23
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 23
		mov	dx, [_orgval]	; Get our target address
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop290:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead290
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr290		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine290

nextAddr290:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop290

callRoutine290:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit290

memoryRead290:
		mov	dl, [ebp + edx]	; Get our data

readExit290:
		sahf		; Restore our flags
		sar	dl, 1
		lahf		; Get our flags back
		and	ah, 0ech	; No Half carry or negative!
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	dx, [_orgval]
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop291:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite291	; Yes - go write it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr291	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine291	; If not, go call it!

nextAddr291:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop291

callRoutine291:
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit291
memoryWrite291:
		mov	[ebp + edx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit291:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDFDCBInst3e:
		sub	dword [cyclesRemaining], byte 23
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 23
		mov	dx, [_orgval]	; Get our target address
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop292:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead292
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr292		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine292

nextAddr292:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop292

callRoutine292:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit292

memoryRead292:
		mov	dl, [ebp + edx]	; Get our data

readExit292:
		sahf		; Restore our flags
		shr	dl, 1
		lahf		; Get our flags back
		and	ah, 0edh	; Knock out H & N
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	dx, [_orgval]
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop293:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite293	; Yes - go write it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr293	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine293	; If not, go call it!

nextAddr293:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop293

callRoutine293:
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit293
memoryWrite293:
		mov	[ebp + edx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit293:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDFDCBInst46:
		sub	dword [cyclesRemaining], byte 20
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 20
		mov	dx, [_orgval]	; Get our target address
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop294:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead294
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr294		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine294

nextAddr294:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop294

callRoutine294:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit294

memoryRead294:
		mov	dl, [ebp + edx]	; Get our data

readExit294:
		mov	dh, ah	; Store our original flags
		and	dh, 29h	; Keep our old flags
		sahf		; Restore our flags
		test	dl, 001h	; Is it set?
		lahf		; Get our flags back
		and	ah, 0ech	; No Half carry or negative!
		or	ah, 10h	; OR In our half carry
		and	ah, 0d0h ; New flags
		or	ah, dh	; OR In our old flags
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDFDCBInst4e:
		sub	dword [cyclesRemaining], byte 20
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 20
		mov	dx, [_orgval]	; Get our target address
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop295:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead295
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr295		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine295

nextAddr295:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop295

callRoutine295:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit295

memoryRead295:
		mov	dl, [ebp + edx]	; Get our data

readExit295:
		mov	dh, ah	; Store our original flags
		and	dh, 29h	; Keep our old flags
		sahf		; Restore our flags
		test	dl, 002h	; Is it set?
		lahf		; Get our flags back
		and	ah, 0ech	; No Half carry or negative!
		or	ah, 10h	; OR In our half carry
		and	ah, 0d0h ; New flags
		or	ah, dh	; OR In our old flags
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDFDCBInst56:
		sub	dword [cyclesRemaining], byte 20
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 20
		mov	dx, [_orgval]	; Get our target address
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop296:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead296
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr296		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine296

nextAddr296:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop296

callRoutine296:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit296

memoryRead296:
		mov	dl, [ebp + edx]	; Get our data

readExit296:
		mov	dh, ah	; Store our original flags
		and	dh, 29h	; Keep our old flags
		sahf		; Restore our flags
		test	dl, 004h	; Is it set?
		lahf		; Get our flags back
		and	ah, 0ech	; No Half carry or negative!
		or	ah, 10h	; OR In our half carry
		and	ah, 0d0h ; New flags
		or	ah, dh	; OR In our old flags
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDFDCBInst5e:
		sub	dword [cyclesRemaining], byte 20
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 20
		mov	dx, [_orgval]	; Get our target address
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop297:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead297
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr297		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine297

nextAddr297:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop297

callRoutine297:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit297

memoryRead297:
		mov	dl, [ebp + edx]	; Get our data

readExit297:
		mov	dh, ah	; Store our original flags
		and	dh, 29h	; Keep our old flags
		sahf		; Restore our flags
		test	dl, 008h	; Is it set?
		lahf		; Get our flags back
		and	ah, 0ech	; No Half carry or negative!
		or	ah, 10h	; OR In our half carry
		and	ah, 0d0h ; New flags
		or	ah, dh	; OR In our old flags
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDFDCBInst66:
		sub	dword [cyclesRemaining], byte 20
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 20
		mov	dx, [_orgval]	; Get our target address
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop298:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead298
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr298		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine298

nextAddr298:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop298

callRoutine298:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit298

memoryRead298:
		mov	dl, [ebp + edx]	; Get our data

readExit298:
		mov	dh, ah	; Store our original flags
		and	dh, 29h	; Keep our old flags
		sahf		; Restore our flags
		test	dl, 010h	; Is it set?
		lahf		; Get our flags back
		and	ah, 0ech	; No Half carry or negative!
		or	ah, 10h	; OR In our half carry
		and	ah, 0d0h ; New flags
		or	ah, dh	; OR In our old flags
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDFDCBInst6e:
		sub	dword [cyclesRemaining], byte 20
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 20
		mov	dx, [_orgval]	; Get our target address
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop299:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead299
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr299		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine299

nextAddr299:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop299

callRoutine299:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit299

memoryRead299:
		mov	dl, [ebp + edx]	; Get our data

readExit299:
		mov	dh, ah	; Store our original flags
		and	dh, 29h	; Keep our old flags
		sahf		; Restore our flags
		test	dl, 020h	; Is it set?
		lahf		; Get our flags back
		and	ah, 0ech	; No Half carry or negative!
		or	ah, 10h	; OR In our half carry
		and	ah, 0d0h ; New flags
		or	ah, dh	; OR In our old flags
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDFDCBInst76:
		sub	dword [cyclesRemaining], byte 20
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 20
		mov	dx, [_orgval]	; Get our target address
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop300:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead300
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr300		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine300

nextAddr300:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop300

callRoutine300:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit300

memoryRead300:
		mov	dl, [ebp + edx]	; Get our data

readExit300:
		mov	dh, ah	; Store our original flags
		and	dh, 29h	; Keep our old flags
		sahf		; Restore our flags
		test	dl, 040h	; Is it set?
		lahf		; Get our flags back
		and	ah, 0ech	; No Half carry or negative!
		or	ah, 10h	; OR In our half carry
		and	ah, 0d0h ; New flags
		or	ah, dh	; OR In our old flags
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDFDCBInst7e:
		sub	dword [cyclesRemaining], byte 20
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 20
		mov	dx, [_orgval]	; Get our target address
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop301:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead301
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr301		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine301

nextAddr301:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop301

callRoutine301:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit301

memoryRead301:
		mov	dl, [ebp + edx]	; Get our data

readExit301:
		mov	dh, ah	; Store our original flags
		and	dh, 29h	; Keep our old flags
		sahf		; Restore our flags
		test	dl, 080h	; Is it set?
		lahf		; Get our flags back
		and	ah, 0ech	; No Half carry or negative!
		or	ah, 10h	; OR In our half carry
		and	ah, 0d0h ; New flags
		or	ah, dh	; OR In our old flags
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDFDCBInst86:
		sub	dword [cyclesRemaining], byte 23
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 23
		mov	dx, [_orgval]	; Get our target address
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop302:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead302
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr302		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine302

nextAddr302:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop302

callRoutine302:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit302

memoryRead302:
		mov	dl, [ebp + edx]	; Get our data

readExit302:
		and	dl, 0feh	; Reset the bit
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	dx, [_orgval]
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop303:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite303	; Yes - go write it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr303	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine303	; If not, go call it!

nextAddr303:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop303

callRoutine303:
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit303
memoryWrite303:
		mov	[ebp + edx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit303:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDFDCBInst8e:
		sub	dword [cyclesRemaining], byte 23
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 23
		mov	dx, [_orgval]	; Get our target address
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop304:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead304
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr304		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine304

nextAddr304:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop304

callRoutine304:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit304

memoryRead304:
		mov	dl, [ebp + edx]	; Get our data

readExit304:
		and	dl, 0fdh	; Reset the bit
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	dx, [_orgval]
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop305:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite305	; Yes - go write it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr305	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine305	; If not, go call it!

nextAddr305:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop305

callRoutine305:
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit305
memoryWrite305:
		mov	[ebp + edx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit305:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDFDCBInst96:
		sub	dword [cyclesRemaining], byte 23
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 23
		mov	dx, [_orgval]	; Get our target address
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop306:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead306
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr306		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine306

nextAddr306:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop306

callRoutine306:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit306

memoryRead306:
		mov	dl, [ebp + edx]	; Get our data

readExit306:
		and	dl, 0fbh	; Reset the bit
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	dx, [_orgval]
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop307:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite307	; Yes - go write it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr307	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine307	; If not, go call it!

nextAddr307:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop307

callRoutine307:
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit307
memoryWrite307:
		mov	[ebp + edx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit307:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDFDCBInst9e:
		sub	dword [cyclesRemaining], byte 23
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 23
		mov	dx, [_orgval]	; Get our target address
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop308:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead308
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr308		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine308

nextAddr308:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop308

callRoutine308:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit308

memoryRead308:
		mov	dl, [ebp + edx]	; Get our data

readExit308:
		and	dl, 0f7h	; Reset the bit
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	dx, [_orgval]
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop309:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite309	; Yes - go write it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr309	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine309	; If not, go call it!

nextAddr309:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop309

callRoutine309:
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit309
memoryWrite309:
		mov	[ebp + edx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit309:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDFDCBInsta6:
		sub	dword [cyclesRemaining], byte 23
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 23
		mov	dx, [_orgval]	; Get our target address
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop310:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead310
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr310		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine310

nextAddr310:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop310

callRoutine310:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit310

memoryRead310:
		mov	dl, [ebp + edx]	; Get our data

readExit310:
		and	dl, 0efh	; Reset the bit
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	dx, [_orgval]
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop311:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite311	; Yes - go write it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr311	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine311	; If not, go call it!

nextAddr311:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop311

callRoutine311:
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit311
memoryWrite311:
		mov	[ebp + edx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit311:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDFDCBInstae:
		sub	dword [cyclesRemaining], byte 23
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 23
		mov	dx, [_orgval]	; Get our target address
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop312:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead312
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr312		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine312

nextAddr312:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop312

callRoutine312:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit312

memoryRead312:
		mov	dl, [ebp + edx]	; Get our data

readExit312:
		and	dl, 0dfh	; Reset the bit
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	dx, [_orgval]
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop313:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite313	; Yes - go write it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr313	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine313	; If not, go call it!

nextAddr313:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop313

callRoutine313:
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit313
memoryWrite313:
		mov	[ebp + edx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit313:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDFDCBInstb6:
		sub	dword [cyclesRemaining], byte 23
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 23
		mov	dx, [_orgval]	; Get our target address
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop314:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead314
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr314		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine314

nextAddr314:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop314

callRoutine314:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit314

memoryRead314:
		mov	dl, [ebp + edx]	; Get our data

readExit314:
		and	dl, 0bfh	; Reset the bit
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	dx, [_orgval]
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop315:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite315	; Yes - go write it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr315	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine315	; If not, go call it!

nextAddr315:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop315

callRoutine315:
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit315
memoryWrite315:
		mov	[ebp + edx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit315:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDFDCBInstbe:
		sub	dword [cyclesRemaining], byte 23
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 23
		mov	dx, [_orgval]	; Get our target address
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop316:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead316
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr316		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine316

nextAddr316:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop316

callRoutine316:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit316

memoryRead316:
		mov	dl, [ebp + edx]	; Get our data

readExit316:
		and	dl, 07fh	; Reset the bit
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	dx, [_orgval]
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop317:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite317	; Yes - go write it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr317	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine317	; If not, go call it!

nextAddr317:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop317

callRoutine317:
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit317
memoryWrite317:
		mov	[ebp + edx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit317:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDFDCBInstc6:
		sub	dword [cyclesRemaining], byte 23
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 23
		mov	dx, [_orgval]	; Get our target address
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop318:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead318
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr318		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine318

nextAddr318:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop318

callRoutine318:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit318

memoryRead318:
		mov	dl, [ebp + edx]	; Get our data

readExit318:
		or	dl, 001h	; Set the bit
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	dx, [_orgval]
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop319:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite319	; Yes - go write it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr319	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine319	; If not, go call it!

nextAddr319:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop319

callRoutine319:
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit319
memoryWrite319:
		mov	[ebp + edx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit319:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDFDCBInstce:
		sub	dword [cyclesRemaining], byte 23
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 23
		mov	dx, [_orgval]	; Get our target address
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop320:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead320
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr320		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine320

nextAddr320:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop320

callRoutine320:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit320

memoryRead320:
		mov	dl, [ebp + edx]	; Get our data

readExit320:
		or	dl, 002h	; Set the bit
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	dx, [_orgval]
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop321:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite321	; Yes - go write it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr321	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine321	; If not, go call it!

nextAddr321:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop321

callRoutine321:
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit321
memoryWrite321:
		mov	[ebp + edx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit321:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDFDCBInstd6:
		sub	dword [cyclesRemaining], byte 23
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 23
		mov	dx, [_orgval]	; Get our target address
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop322:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead322
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr322		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine322

nextAddr322:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop322

callRoutine322:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit322

memoryRead322:
		mov	dl, [ebp + edx]	; Get our data

readExit322:
		or	dl, 004h	; Set the bit
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	dx, [_orgval]
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop323:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite323	; Yes - go write it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr323	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine323	; If not, go call it!

nextAddr323:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop323

callRoutine323:
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit323
memoryWrite323:
		mov	[ebp + edx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit323:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDFDCBInstde:
		sub	dword [cyclesRemaining], byte 23
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 23
		mov	dx, [_orgval]	; Get our target address
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop324:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead324
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr324		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine324

nextAddr324:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop324

callRoutine324:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit324

memoryRead324:
		mov	dl, [ebp + edx]	; Get our data

readExit324:
		or	dl, 008h	; Set the bit
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	dx, [_orgval]
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop325:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite325	; Yes - go write it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr325	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine325	; If not, go call it!

nextAddr325:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop325

callRoutine325:
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit325
memoryWrite325:
		mov	[ebp + edx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit325:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDFDCBInste6:
		sub	dword [cyclesRemaining], byte 23
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 23
		mov	dx, [_orgval]	; Get our target address
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop326:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead326
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr326		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine326

nextAddr326:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop326

callRoutine326:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit326

memoryRead326:
		mov	dl, [ebp + edx]	; Get our data

readExit326:
		or	dl, 010h	; Set the bit
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	dx, [_orgval]
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop327:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite327	; Yes - go write it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr327	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine327	; If not, go call it!

nextAddr327:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop327

callRoutine327:
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit327
memoryWrite327:
		mov	[ebp + edx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit327:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDFDCBInstee:
		sub	dword [cyclesRemaining], byte 23
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 23
		mov	dx, [_orgval]	; Get our target address
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop328:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead328
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr328		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine328

nextAddr328:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop328

callRoutine328:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit328

memoryRead328:
		mov	dl, [ebp + edx]	; Get our data

readExit328:
		or	dl, 020h	; Set the bit
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	dx, [_orgval]
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop329:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite329	; Yes - go write it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr329	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine329	; If not, go call it!

nextAddr329:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop329

callRoutine329:
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit329
memoryWrite329:
		mov	[ebp + edx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit329:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDFDCBInstf6:
		sub	dword [cyclesRemaining], byte 23
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 23
		mov	dx, [_orgval]	; Get our target address
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop330:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead330
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr330		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine330

nextAddr330:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop330

callRoutine330:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit330

memoryRead330:
		mov	dl, [ebp + edx]	; Get our data

readExit330:
		or	dl, 040h	; Set the bit
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	dx, [_orgval]
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop331:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite331	; Yes - go write it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr331	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine331	; If not, go call it!

nextAddr331:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop331

callRoutine331:
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit331
memoryWrite331:
		mov	[ebp + edx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit331:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDFDCBInstfe:
		sub	dword [cyclesRemaining], byte 23
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 23
		mov	dx, [_orgval]	; Get our target address
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop332:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead332
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr332		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine332

nextAddr332:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop332

callRoutine332:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit332

memoryRead332:
		mov	dl, [ebp + edx]	; Get our data

readExit332:
		or	dl, 080h	; Set the bit
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	dx, [_orgval]
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop333:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite333	; Yes - go write it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr333	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine333	; If not, go call it!

nextAddr333:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop333

callRoutine333:
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit333
memoryWrite333:
		mov	[ebp + edx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit333:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst09:
		sub	dword [cyclesRemaining], byte 15
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 15
		mov	dh, ah	; Get our flags
		and	dh, 0ech	; Preserve the top three and bits 2 & 3
		mov	di, [_z80iy]	; Get our value
		mov	[_orgval], di	; Store our original value
		add	di, cx
		lahf
		mov	[_z80iy], di	; Store our register back
		mov	di, [_orgval]	; Get original
		xor	di, word [_z80iy] ; XOR It with our computed value
		xor	di, cx
		and	di, 1000h	; Just our half carry
		or		dx, di	; Or in our flags
		and	ah, 01h	; Just carry
		or	ah, dh
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst19:
		sub	dword [cyclesRemaining], byte 15
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 15
		mov	dh, ah	; Get our flags
		and	dh, 0ech	; Preserve the top three and bits 2 & 3
		mov	di, [_z80iy]	; Get our value
		mov	[_orgval], di	; Store our original value
		add	di, word [_z80de]
		lahf
		mov	[_z80iy], di	; Store our register back
		mov	di, [_orgval]	; Get original
		xor	di, word [_z80iy] ; XOR It with our computed value
		xor	di, word [_z80de]
		and	di, 1000h	; Just our half carry
		or		dx, di	; Or in our flags
		and	ah, 01h	; Just carry
		or	ah, dh
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst21:
		sub	dword [cyclesRemaining], byte 14
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 14
		mov	di, [esi]	; Get our word to load
		add	esi, 2	; Advance past the word
		mov	[_z80iy], di ; Store our new value
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst22:
		sub	dword [cyclesRemaining], byte 20
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 20
		mov	dx, [esi]	 ; Get our address to store
		add	esi, 2
		mov	[_orgval], dx
		mov	dl, [_z80iy]
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	dx, [_orgval]
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop334:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite334	; Yes - go write it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr334	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine334	; If not, go call it!

nextAddr334:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop334

callRoutine334:
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit334
memoryWrite334:
		mov	[ebp + edx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit334:
		inc	word [_orgval]
		mov	dl, [_z80iy + 1]
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	dx, [_orgval]
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop335:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite335	; Yes - go write it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr335	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine335	; If not, go call it!

nextAddr335:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop335

callRoutine335:
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit335
memoryWrite335:
		mov	[ebp + edx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit335:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst23:
		sub	dword [cyclesRemaining], byte 10
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 10
		inc	word [_z80iy]	; Increment our mz80Index register
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst24:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		sahf
		inc	byte [_z80iy + 1]
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		xor	dh, dh
		and	ah, 0fdh	; Knock out N!
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst25:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		sahf
		dec	byte [_z80iy + 1]
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		xor	dh, dh
		or	ah, 02h	; Set negative!
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst26:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dl, [esi]	; Get immediate byte to load
		inc	esi	; Next byte
		mov	byte [_z80iy + 1], dl
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst29:
		sub	dword [cyclesRemaining], byte 15
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 15
		mov	dh, ah	; Get our flags
		and	dh, 0ech	; Preserve the top three and bits 2 & 3
		mov	di, [_z80iy]	; Get our value
		mov	[_orgval], di	; Store our original value
		add	di, di
		lahf
		mov	[_z80iy], di	; Store our register back
		mov	di, [_orgval]	; Get original
		xor	di, word [_z80iy] ; XOR It with our computed value
		xor	di, di
		and	di, 1000h	; Just our half carry
		or		dx, di	; Or in our flags
		and	ah, 01h	; Just carry
		or	ah, dh
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst2a:
		sub	dword [cyclesRemaining], byte 20
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 20
		mov	dx, [esi]	 ; Get our address to store
		add	esi, 2
		mov	[_orgval], dx
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop336:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead336
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr336		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine336

nextAddr336:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop336

callRoutine336:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit336

memoryRead336:
		mov	dl, [ebp + edx]	; Get our data

readExit336:
		mov	[_z80iy], dl
		inc	word [_orgval]
		mov	dx, [_orgval]
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop337:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead337
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr337		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine337

nextAddr337:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop337

callRoutine337:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit337

memoryRead337:
		mov	dl, [ebp + edx]	; Get our data

readExit337:
		mov	[_z80iy + 1], dl
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst2b:
		sub	dword [cyclesRemaining], byte 10
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 10
		dec	word [_z80iy]	; Increment our mz80Index register
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst2c:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		sahf
		inc	byte [_z80iy]
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		xor	dh, dh
		and	ah, 0fdh	; Knock out N!
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst2d:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		sahf
		dec	byte [_z80iy]
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		xor	dh, dh
		or	ah, 02h	; Set negative!
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst2e:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dl, [esi]	; Get immediate byte to load
		inc	esi	; Next byte
		mov	byte [_z80iy], dl
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst34:
		sub	dword [cyclesRemaining], byte 23
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 23
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned338	; Nope!
		dec	dh			; Make it FFable
notSigned338:
		add	dx, [_z80iy]	; Our offset!
		mov	[_orgval], dx
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop339:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead339
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr339		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine339

nextAddr339:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop339

callRoutine339:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit339

memoryRead339:
		mov	dl, [ebp + edx]	; Get our data

readExit339:
		sahf
		inc	dl
		lahf
		o16	pushf
		shl	edx, 16
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		shr	edx, 16
		and	ah, 0fdh	; Knock out N!
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	dx, [_orgval]
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop340:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite340	; Yes - go write it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr340	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine340	; If not, go call it!

nextAddr340:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop340

callRoutine340:
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit340
memoryWrite340:
		mov	[ebp + edx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit340:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst35:
		sub	dword [cyclesRemaining], byte 23
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 23
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned341	; Nope!
		dec	dh			; Make it FFable
notSigned341:
		add	dx, [_z80iy]	; Our offset!
		mov	[_orgval], dx
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop342:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead342
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr342		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine342

nextAddr342:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop342

callRoutine342:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit342

memoryRead342:
		mov	dl, [ebp + edx]	; Get our data

readExit342:
		sahf
		dec	dl
		lahf
		o16	pushf
		shl	edx, 16
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		shr	edx, 16
		or		ah, 02h	; Make it N!
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	dx, [_orgval]
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop343:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite343	; Yes - go write it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr343	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine343	; If not, go call it!

nextAddr343:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop343

callRoutine343:
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit343
memoryWrite343:
		mov	[ebp + edx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit343:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst36:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dx, [esi]	; Get our address
		add	esi, 2	; Skip over our storage bytes
		mov	di, dx	; Store it here for later
		xor	dh, dh
		or	dl, dl
		jns	noNegate344
		dec	dh
noNegate344:
		add	dx, [_z80iy]	; Add in our index
		mov	[_orgval], dx	; Store our address to write to
		mov	dx, di
		xchg	dh, dl
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	dx, [_orgval]
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop344:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite344	; Yes - go write it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr344	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine344	; If not, go call it!

nextAddr344:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop344

callRoutine344:
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit344
memoryWrite344:
		mov	[ebp + edx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit344:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst39:
		sub	dword [cyclesRemaining], byte 15
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 15
		mov	dh, ah	; Get our flags
		and	dh, 0ech	; Preserve the top three and bits 2 & 3
		mov	di, [_z80iy]	; Get our value
		mov	[_orgval], di	; Store our original value
		add	di, word [_z80sp]
		lahf
		mov	[_z80iy], di	; Store our register back
		mov	di, [_orgval]	; Get original
		xor	di, word [_z80iy] ; XOR It with our computed value
		xor	di, word [_z80sp]
		and	di, 1000h	; Just our half carry
		or		dx, di	; Or in our flags
		and	ah, 01h	; Just carry
		or	ah, dh
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst44:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	ch, byte [_z80iy + 1]
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst45:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	ch, byte [_z80iy + 0]
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst46:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned346	; Nope!
		dec	dh			; Make it FFable
notSigned346:
		add	dx, [_z80iy]	; Our offset!
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop347:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead347
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr347		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine347

nextAddr347:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop347

callRoutine347:
		call	ReadMemoryByte	; Standard read routine
		mov	ch, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit347

memoryRead347:
		mov	ch, [ebp + edx]	; Get our data

readExit347:
		xor	dh, dh	; Make sure we don't hose things
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst4c:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	cl, byte [_z80iy + 1]
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst4d:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	cl, byte [_z80iy + 0]
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst4e:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned349	; Nope!
		dec	dh			; Make it FFable
notSigned349:
		add	dx, [_z80iy]	; Our offset!
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop350:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead350
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr350		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine350

nextAddr350:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop350

callRoutine350:
		call	ReadMemoryByte	; Standard read routine
		mov	cl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit350

memoryRead350:
		mov	cl, [ebp + edx]	; Get our data

readExit350:
		xor	dh, dh	; Make sure we don't hose things
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst54:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dx, [_z80de]	; Get a usable copy of DE here
		mov	dh, byte [_z80iy + 1]
		mov	[_z80de], dx	; Put it back!
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst55:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dx, [_z80de]	; Get a usable copy of DE here
		mov	dh, byte [_z80iy + 0]
		mov	[_z80de], dx	; Put it back!
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst56:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned352	; Nope!
		dec	dh			; Make it FFable
notSigned352:
		add	dx, [_z80iy]	; Our offset!
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop353:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead353
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr353		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine353

nextAddr353:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop353

callRoutine353:
		call	ReadMemoryByte	; Standard read routine
		mov	byte [_z80de + 1], al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit353

memoryRead353:
		mov	di, dx
		mov	dl, [ebp + edx]
		mov	byte [_z80de + 1], dl
		mov	dx, di
readExit353:
		xor	dh, dh	; Make sure we don't hose things
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst5c:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dx, [_z80de]	; Get a usable copy of DE here
		mov	dl, byte [_z80iy + 1]
		mov	[_z80de], dx	; Put it back!
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst5d:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dx, [_z80de]	; Get a usable copy of DE here
		mov	dl, byte [_z80iy + 0]
		mov	[_z80de], dx	; Put it back!
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst5e:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned355	; Nope!
		dec	dh			; Make it FFable
notSigned355:
		add	dx, [_z80iy]	; Our offset!
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop356:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead356
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr356		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine356

nextAddr356:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop356

callRoutine356:
		call	ReadMemoryByte	; Standard read routine
		mov	byte [_z80de], al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit356

memoryRead356:
		mov	di, dx
		mov	dl, [ebp + edx]
		mov	byte [_z80de], dl
		mov	dx, di
readExit356:
		xor	dh, dh	; Make sure we don't hose things
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst60:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov   byte [_z80iy + 1], ch
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst61:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov   byte [_z80iy + 1], cl
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst62:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
	mov	dx, [_z80de]	; Get DE
		mov   byte [_z80iy + 1], dh
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst63:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
	mov	dx, [_z80de]	; Get DE
		mov   byte [_z80iy + 1], dl
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst64:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
	mov	dh, byte [_z80iy + 1]
		mov   byte [_z80iy + 1], bh
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst65:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
	mov	dl, byte [_z80iy]
		mov   byte [_z80iy + 1], bl
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst66:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned358	; Nope!
		dec	dh			; Make it FFable
notSigned358:
		add	dx, [_z80iy]	; Our offset!
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop359:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead359
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr359		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine359

nextAddr359:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop359

callRoutine359:
		call	ReadMemoryByte	; Standard read routine
		mov	bh, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit359

memoryRead359:
		mov	bh, [ebp + edx]	; Get our data

readExit359:
		xor	dh, dh	; Make sure we don't hose things
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst67:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov   byte [_z80iy + 1], al
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst68:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov   byte [_z80iy + 0], ch
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst69:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov   byte [_z80iy + 0], cl
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst6a:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
	mov	dx, [_z80de]	; Get DE
		mov   byte [_z80iy + 0], dh
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst6b:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
	mov	dx, [_z80de]	; Get DE
		mov   byte [_z80iy + 0], dl
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst6c:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
	mov	dh, byte [_z80iy + 1]
		mov   byte [_z80iy + 0], bh
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst6d:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
	mov	dl, byte [_z80iy]
		mov   byte [_z80iy + 0], bl
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst6e:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned361	; Nope!
		dec	dh			; Make it FFable
notSigned361:
		add	dx, [_z80iy]	; Our offset!
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop362:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead362
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr362		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine362

nextAddr362:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop362

callRoutine362:
		call	ReadMemoryByte	; Standard read routine
		mov	bl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit362

memoryRead362:
		mov	bl, [ebp + edx]	; Get our data

readExit362:
		xor	dh, dh	; Make sure we don't hose things
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst6f:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov   byte [_z80iy + 0], al
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst70:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned364	; Nope!
		dec	dh			; Make it FFable
notSigned364:
		add	dx, [_z80iy]	; Our offset!
		mov	[_z80af], ax	; Store AF
		mov	al, ch	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop365:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite365	; Yes - go write it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr365	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine365	; If not, go call it!

nextAddr365:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop365

callRoutine365:
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit365
memoryWrite365:
		mov	[ebp + edx], ch
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit365:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst71:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned366	; Nope!
		dec	dh			; Make it FFable
notSigned366:
		add	dx, [_z80iy]	; Our offset!
		mov	[_z80af], ax	; Store AF
		mov	al, cl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop367:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite367	; Yes - go write it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr367	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine367	; If not, go call it!

nextAddr367:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop367

callRoutine367:
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit367
memoryWrite367:
		mov	[ebp + edx], cl
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit367:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst72:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned368	; Nope!
		dec	dh			; Make it FFable
notSigned368:
		add	dx, [_z80iy]	; Our offset!
		mov	[_z80af], ax	; Store AF
		mov	al, byte [_z80de + 1]	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop369:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite369	; Yes - go write it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr369	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine369	; If not, go call it!

nextAddr369:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop369

callRoutine369:
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit369
memoryWrite369:
		mov	edi, edx
		mov	dl, byte [_z80de + 1]
		mov	[ebp + edi], dl
		mov	edx, edi
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit369:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst73:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned370	; Nope!
		dec	dh			; Make it FFable
notSigned370:
		add	dx, [_z80iy]	; Our offset!
		mov	[_z80af], ax	; Store AF
		mov	al, byte [_z80de]	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop371:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite371	; Yes - go write it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr371	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine371	; If not, go call it!

nextAddr371:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop371

callRoutine371:
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit371
memoryWrite371:
		mov	edi, edx
		mov	dl, byte [_z80de]
		mov	[ebp + edi], dl
		mov	edx, edi
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit371:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst74:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned372	; Nope!
		dec	dh			; Make it FFable
notSigned372:
		add	dx, [_z80iy]	; Our offset!
		mov	[_z80af], ax	; Store AF
		mov	al, bh	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop373:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite373	; Yes - go write it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr373	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine373	; If not, go call it!

nextAddr373:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop373

callRoutine373:
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit373
memoryWrite373:
		mov	[ebp + edx], bh
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit373:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst75:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned374	; Nope!
		dec	dh			; Make it FFable
notSigned374:
		add	dx, [_z80iy]	; Our offset!
		mov	[_z80af], ax	; Store AF
		mov	al, bl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop375:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite375	; Yes - go write it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr375	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine375	; If not, go call it!

nextAddr375:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop375

callRoutine375:
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit375
memoryWrite375:
		mov	[ebp + edx], bl
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit375:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst77:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned376	; Nope!
		dec	dh			; Make it FFable
notSigned376:
		add	dx, [_z80iy]	; Our offset!
		mov	[_z80af], ax	; Store AF
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop377:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite377	; Yes - go write it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr377	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine377	; If not, go call it!

nextAddr377:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop377

callRoutine377:
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit377
memoryWrite377:
		mov	[ebp + edx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit377:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst7c:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	al, byte [_z80iy + 1]
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst7d:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	al, byte [_z80iy + 0]
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst7e:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned378	; Nope!
		dec	dh			; Make it FFable
notSigned378:
		add	dx, [_z80iy]	; Our offset!
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop379:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead379
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr379		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine379

nextAddr379:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop379

callRoutine379:
		call	ReadMemoryByte	; Standard read routine
		mov	[_z80af], al	; Save our new accumulator
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit379

memoryRead379:
		mov	al, [ebp + edx]	; Get our data

readExit379:
		xor	dh, dh	; Make sure we don't hose things
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst84:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dl, byte [_z80iy + 1]
		sahf		; Store our flags in x86 flag reg
		add	al, dl
		lahf		; Get flags back into AH
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		xor	dh, dh
		and	ah, 0fdh ; No N!
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst85:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dl, byte [_z80iy]
		sahf		; Store our flags in x86 flag reg
		add	al, dl
		lahf		; Get flags back into AH
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		xor	dh, dh
		and	ah, 0fdh ; No N!
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst86:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned381	; Nope!
		dec	dh			; Make it FFable
notSigned381:
		add	dx, [_z80iy]	; Our offset!
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop382:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead382
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr382		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine382

nextAddr382:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop382

callRoutine382:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit382

memoryRead382:
		mov	dl, [ebp + edx]	; Get our data

readExit382:
		sahf
		add	al, dl
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		and	ah, 0fdh	; Knock out negative
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst8c:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dl, byte [_z80iy + 1]
		sahf		; Store our flags in x86 flag reg
		adc	al, dl
		lahf		; Get flags back into AH
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		xor	dh, dh
		and	ah, 0fdh ; No N!
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst8d:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dl, byte [_z80iy]
		sahf		; Store our flags in x86 flag reg
		adc	al, dl
		lahf		; Get flags back into AH
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		xor	dh, dh
		and	ah, 0fdh ; No N!
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst8e:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned383	; Nope!
		dec	dh			; Make it FFable
notSigned383:
		add	dx, [_z80iy]	; Our offset!
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop384:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead384
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr384		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine384

nextAddr384:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop384

callRoutine384:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit384

memoryRead384:
		mov	dl, [ebp + edx]	; Get our data

readExit384:
		sahf
		adc	al, dl
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		and	ah, 0fdh	; Knock out negative
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst94:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dl, byte [_z80iy + 1]
		sahf		; Store our flags in x86 flag reg
		sub	al, dl
		lahf		; Get flags back into AH
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		xor	dh, dh
		or	ah, 02h	; N Gets set!
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst95:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dl, byte [_z80iy]
		sahf		; Store our flags in x86 flag reg
		sub	al, dl
		lahf		; Get flags back into AH
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		xor	dh, dh
		or	ah, 02h	; N Gets set!
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst96:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned385	; Nope!
		dec	dh			; Make it FFable
notSigned385:
		add	dx, [_z80iy]	; Our offset!
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop386:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead386
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr386		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine386

nextAddr386:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop386

callRoutine386:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit386

memoryRead386:
		mov	dl, [ebp + edx]	; Get our data

readExit386:
		sahf
		sub	al, dl
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		or	ah, 02h	; Set negative
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst9c:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dl, byte [_z80iy + 1]
		sahf		; Store our flags in x86 flag reg
		sbb	al, dl
		lahf		; Get flags back into AH
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		xor	dh, dh
		or	ah, 02h	; N Gets set!
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst9d:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dl, byte [_z80iy]
		sahf		; Store our flags in x86 flag reg
		sbb	al, dl
		lahf		; Get flags back into AH
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		xor	dh, dh
		or	ah, 02h	; N Gets set!
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst9e:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned387	; Nope!
		dec	dh			; Make it FFable
notSigned387:
		add	dx, [_z80iy]	; Our offset!
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop388:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead388
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr388		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine388

nextAddr388:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop388

callRoutine388:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit388

memoryRead388:
		mov	dl, [ebp + edx]	; Get our data

readExit388:
		sahf
		sbb	al, dl
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		or	ah, 02h	; Set negative
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInsta4:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dl, byte [_z80iy + 1]
		sahf		; Store our flags in x86 flag reg
		and	al, dl
		lahf		; Get flags back into AH
		and	ah, 0ech	; Only these flags matter!
		or	ah, 010h	; Half carry gets set
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInsta5:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dl, byte [_z80iy]
		sahf		; Store our flags in x86 flag reg
		and	al, dl
		lahf		; Get flags back into AH
		and	ah, 0ech	; Only these flags matter!
		or	ah, 010h	; Half carry gets set
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInsta6:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned389	; Nope!
		dec	dh			; Make it FFable
notSigned389:
		add	dx, [_z80iy]	; Our offset!
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop390:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead390
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr390		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine390

nextAddr390:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop390

callRoutine390:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit390

memoryRead390:
		mov	dl, [ebp + edx]	; Get our data

readExit390:
		sahf
		and	al, dl
		lahf
		and	ah,0fch	; Knock out N & C
		or	ah, 10h	; Set half carry
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInstac:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dl, byte [_z80iy + 1]
		sahf		; Store our flags in x86 flag reg
		xor	al, dl
		lahf		; Get flags back into AH
		and	ah, 0ech	; Only these flags matter!
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInstad:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dl, byte [_z80iy]
		sahf		; Store our flags in x86 flag reg
		xor	al, dl
		lahf		; Get flags back into AH
		and	ah, 0ech	; Only these flags matter!
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInstae:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned391	; Nope!
		dec	dh			; Make it FFable
notSigned391:
		add	dx, [_z80iy]	; Our offset!
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop392:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead392
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr392		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine392

nextAddr392:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop392

callRoutine392:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit392

memoryRead392:
		mov	dl, [ebp + edx]	; Get our data

readExit392:
		sahf
		xor	al, dl
		lahf
		and	ah, 0ech	; Knock out H, N, and C
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInstb4:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dl, byte [_z80iy + 1]
		sahf		; Store our flags in x86 flag reg
		or	al, dl
		lahf		; Get flags back into AH
		and	ah, 0ech ; No H, N, or C
		and	ah, 0ech ; No H, N, or C
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInstb5:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dl, byte [_z80iy]
		sahf		; Store our flags in x86 flag reg
		or	al, dl
		lahf		; Get flags back into AH
		and	ah, 0ech ; No H, N, or C
		and	ah, 0ech ; No H, N, or C
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInstb6:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned393	; Nope!
		dec	dh			; Make it FFable
notSigned393:
		add	dx, [_z80iy]	; Our offset!
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop394:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead394
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr394		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine394

nextAddr394:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop394

callRoutine394:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit394

memoryRead394:
		mov	dl, [ebp + edx]	; Get our data

readExit394:
		sahf
		or	al, dl
		lahf
		and	ah, 0ech	; Knock out H, N, and C
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInstbc:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dl, byte [_z80iy + 1]
		sahf		; Store our flags in x86 flag reg
		cmp	al, dl
		lahf		; Get flags back into AH
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		xor	dh, dh
		or	ah, 02h	; Negative gets set on a compare
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInstbd:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dl, byte [_z80iy]
		sahf		; Store our flags in x86 flag reg
		cmp	al, dl
		lahf		; Get flags back into AH
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		xor	dh, dh
		or	ah, 02h	; Negative gets set on a compare
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInstbe:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned395	; Nope!
		dec	dh			; Make it FFable
notSigned395:
		add	dx, [_z80iy]	; Our offset!
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop396:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead396
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr396		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine396

nextAddr396:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop396

callRoutine396:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit396

memoryRead396:
		mov	dl, [ebp + edx]	; Get our data

readExit396:
		sahf
		cmp	al, dl
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	dh, dh
		or	ah, 02h	; Set negative
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]

FDInstcb:
		mov	[_baseFixup], dword 3
		mov	dx, [esi]	; Get our instruction (and offset)
		add	esi, 2	; Increment our PC
		mov	byte [_orgval], dl ; Store our value
		or	dl, dl
		js	notNeg397
		mov	byte [_orgval + 1], 00h;
 		jmp	short jumpHandler397
notNeg397:
		mov	byte [_orgval + 1], 0ffh;	It's negative
jumpHandler397:
		shl	ebx, 16	; Save BX away
		mov	bx, [_z80iy]
		add	[_orgval], bx
		shr	ebx, 16	; Restore BX
		mov	dl, dh	; Get our instruction
		xor	dh, dh	; Zero this
		jmp	dword [z80ddfdcbInstructions+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInste1:
		sub	dword [cyclesRemaining], byte 14
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 14
		mov	dx, [_z80sp]
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop398:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead398
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr398		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine398

nextAddr398:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop398

callRoutine398:
		call	ReadMemoryByte	; Standard read routine
		mov	byte [_z80iy], al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit398

memoryRead398:
		mov	di, dx
		mov	dl, [ebp + edx]
		mov	byte [_z80iy], dl
		mov	dx, di
readExit398:
		inc	dx
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop399:
		cmp	[edi], word 0ffffh ; End of the list?
		je		memoryRead399
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr399		; Yes, go to the next address
		cmp	dx, [edi+4]	; Are we bigger?
		jbe	callRoutine399

nextAddr399:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop399

callRoutine399:
		call	ReadMemoryByte	; Standard read routine
		mov	byte [_z80iy + 1], al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit399

memoryRead399:
		mov	di, dx
		mov	dl, [ebp + edx]
		mov	byte [_z80iy + 1], dl
		mov	dx, di
readExit399:
		add	word [_z80sp], 2
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInste3:
		sub	dword [cyclesRemaining], byte 23
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 23
		mov	dx, word [_z80sp]
		xor	edi, edi
		mov	di, [_z80iy]
		xchg	di, [ebp+edx]
		mov	[_z80iy], di
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInste5:
		sub	dword [cyclesRemaining], byte 15
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 15
		sub	word [_z80sp], 2
		mov	dx, [_z80sp]
		mov	[_z80af], ax	; Store AF
		mov	al, byte [_z80iy]	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop400:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite400	; Yes - go write it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr400	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine400	; If not, go call it!

nextAddr400:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop400

callRoutine400:
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit400
memoryWrite400:
		mov	edi, edx
		mov	dl, byte [_z80iy]
		mov	[ebp + edi], dl
		mov	edx, edi
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit400:
		inc	dx
		mov	[_z80af], ax	; Store AF
		mov	al, byte [_z80iy + 1]	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop401:
		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite401	; Yes - go write it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr401	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine401	; If not, go call it!

nextAddr401:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop401

callRoutine401:
		call	WriteMemoryByte	; Go write the data!
		jmp	short WriteMacroExit401
memoryWrite401:
		mov	edi, edx
		mov	dl, byte [_z80iy + 1]
		mov	[ebp + edi], dl
		mov	edx, edi
		mov	ax, [_z80af] ; Get our accumulator and flags
WriteMacroExit401:
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInste9:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80iy]	; Get our value
		mov	esi, edx		; New PC!
		add	esi, ebp		; Add in our base
		xor	dh, dh
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInstf9:
		sub	dword [cyclesRemaining], byte 10
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 10
		mov	di, [_z80iy] ; Get our source register
		mov	word [_z80sp], di	; Store our new SP
		mov	dl, [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

; This is a generic read memory byte handler when a foreign
; handler is to be called

; EDI=Handler address, EDX=Address
; On return, EDX & EDI are undisturbed and AL=Byte read

ReadMemoryByte:
		mov	[_z80af], ax	; Save AF
		mov	[_z80hl], bx	; Save HL
		mov	[_z80bc], cx	; Save BC
		sub	esi, ebp	; Our program counter
		mov	[_z80pc], si	; Save our program counter
		push	edi	; Save our structure address
		push	edx	; And our desired address
		call	dword [edi + 8]	; Go call our handler
		pop	edx	; Restore our address
		pop	edi	; Restore our handler's address
		xor	ebx, ebx	; Zero our future HL
		xor	ecx, ecx	; Zero our future BC
		xor	esi, esi	; Zero it!
		mov	si, [_z80pc]	; Get our program counter back
		mov	ebp, [_z80Base] ; Base pointer comes back
		add	esi, ebp	; Rebase it properly
		mov	bx, [_z80hl]	; Get HL back
		mov	cx, [_z80bc]	; Get BC back
		ret


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

; This is a generic read memory byte handler when a foreign
; handler is to be called.
; EDI=Handler address, AL=Byte to write, EDX=Address
; EDI and EDX Are undisturbed on exit

WriteMemoryByte:
		mov	[_z80hl], bx	; Save HL
		mov	[_z80bc], cx	; Save BX
		sub	esi, ebp	; Our program counter
		mov	[_z80pc], si	; Save our program counter
		push	edi	; Save our structure address
		push	eax	; Data to write
		push	edx	; And our desired address
		call	dword [edi + 8]	; Go call our handler
		pop	edx	; Restore our address
		pop	eax	; Restore our data written
		pop	edi	; Save our structure address
		xor	ebx, ebx	; Zero our future HL
		xor	ecx, ecx	; Zero our future BC
		mov	bx, [_z80hl]	; Get HL back
		mov	cx, [_z80bc]	; Get BC back
		mov	ax, [_z80af]	; Get AF back
		xor	esi, esi	; Zero it!
		mov	si, [_z80pc]	; Get our program counter back
		mov	ebp, [_z80Base] ; Base pointer comes back
		add	esi, ebp	; Rebase it properly
		ret


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

; This is a generic I/O read byte handler for when a foreign
; handler is to be called
; EDI=Handler address, EDX=I/O Address
; On return, EDX & EDI are undisturbed and AL=Byte read

ReadIOByte:
		mov	[_z80af], ax	; Save AF
		mov	[_z80hl], bx	; Save HL
		mov	[_z80bc], cx	; Save BC
		sub	esi, ebp	; Our program counter
		mov	[_z80pc], si	; Save our program counter
		push	edi	; Save our structure address
		push	edx	; And our desired I/O port
		call	dword [edi + 4]	; Go call our handler
		pop	edx	; Restore our address
		pop	edi	; Restore our handler's address
		xor	ebx, ebx	; Zero our future HL
		xor	ecx, ecx	; Zero our future BC
		xor	esi, esi	; Zero it!
		mov	si, [_z80pc]	; Get our program counter back
		mov	ebp, [_z80Base] ; Base pointer comes back
		add	esi, ebp	; Rebase it properly
		mov	bx, [_z80hl]	; Get HL back
		mov	cx, [_z80bc]	; Get BC back
		ret


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

; This is a generic write I/O byte handler when a foreign handler is to
; be called
; EDI=Handler address, AL=Byte to write, EDX=I/O Address
; EDI and EDX Are undisturbed on exit

WriteIOByte:
		mov	[_z80hl], bx	; Save HL
		mov	[_z80bc], cx	; Save BX
		sub	esi, ebp	; Our program counter
		mov	[_z80pc], si	; Save our program counter
		push	edi	; Save our structure address
		push	eax	; Data to write
		push	edx	; And our desired I/O address
		call	dword [edi + 4]	; Go call our handler
		pop	edx	; Restore our address
		pop	eax	; Restore our data written
		pop	edi	; Save our structure address
		xor	ebx, ebx	; Zero our future HL
		xor	ecx, ecx	; Zero our future BC
		mov	bx, [_z80hl]	; Get HL back
		mov	cx, [_z80bc]	; Get BC back
		mov	ax, [_z80af]	; Get AF back
		xor	esi, esi	; Zero it!
		mov	si, [_z80pc]	; Get our program counter back
		mov	ebp, [_z80Base] ; Base pointer comes back
		add	esi, ebp	; Rebase it properly
		ret

		global	_mz80GetContext
		global	mz80GetContext_

times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

mz80GetContext_:
_mz80GetContext:
		mov	eax, [esp+4]	; Get our context address
		push	esi		; Save registers we use
		push	edi
		push	ecx
		mov     ecx, _mz80contextEnd - _mz80contextBegin
		mov	esi, _mz80contextBegin
		mov	edi, eax	; Source address in ESI
		rep	movsb		; Move it as fast as we can!
		pop	ecx
		pop	edi
		pop	esi
		ret			; No return code
		global	_mz80SetContext
		global	mz80SetContext_

times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

mz80SetContext_:
_mz80SetContext:
		mov	eax, [esp+4]	; Get our context address
		push	esi		; Save registers we use
		push	edi
		push	ecx
		mov     ecx, _mz80contextEnd - _mz80contextBegin
		mov	edi, _mz80contextBegin
		mov	esi, eax	; Source address in ESI
		rep	movsb		; Move it as fast as we can!
		pop	ecx
		pop	edi
		pop	esi
		ret			; No return code
		global	_mz80GetContextSize
		global	mz80GetContextSize_

times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

mz80GetContextSize_:
_mz80GetContextSize:
		mov     eax, _mz80contextEnd - _mz80contextBegin
		ret

		global	_mz80GetElapsedTicks
		global	mz80GetElapsedTicks_

times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

mz80GetElapsedTicks_:
_mz80GetElapsedTicks:
		mov	eax, [esp+4]	; Get our context address
		or	eax, eax	; Should we clear it?
		jz	getTicks
		xor	eax, eax
		xchg	eax, [dwElapsedTicks]
		ret
getTicks:
		mov	eax, [dwElapsedTicks]
		ret
		global	_mz80ReleaseTimeslice
		global	mz80ReleaseTimeslice_

times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

mz80ReleaseTimeslice_:
_mz80ReleaseTimeslice:
		mov	[cyclesRemaining], dword 1
		ret

		global	_mz80reset
		global	mz80reset_

times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

mz80reset_:
_mz80reset:
		xor	eax, eax 	; Zero AX

		mov	dword [_z80halted], eax	; We're not halted anymore!
		mov	word [_z80af], ax	; Zero A & flags
		mov	word [_z80bc], ax	; Zero BC
		mov	word [_z80de],	ax	; Zero DE
		mov	word [_z80hl], ax	; Zero HL
		mov	word [_z80afprime], ax	; Zero AF Prime
		mov	word [_z80bcprime], ax	; Zero BC prime
		mov	word [_z80deprime], ax ; Zero DE prime
		mov	word [_z80hlprime], ax ; Zero HL prime
		mov	byte [_z80i], al	; Zero Interrupt register
		mov	byte [_z80r], al	; Zero refresh register
		mov	word [_z80ix], 0ffffh	; Default mz80Index register
		mov	word [_z80iy], 0ffffh	; Default mz80Index register
		mov	word [_z80pc], ax	; Zero program counter
		mov	word [_z80sp], ax	; And the stack pointer
		mov	dword [_z80inInterrupt], eax ; Not in interrupt
		mov	dword [_z80interruptMode], eax ; Clear our interrupt mode (0)
		mov	dword [_z80interruptState], eax ; Set the state to off
		mov	word [_z80intAddr], 38h ; Set default interrupt address
		mov	word [_z80nmiAddr], 66h ; Set default nmi addr

		ret

		global	_mz80int
		global	mz80int_

times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

mz80int_:
_mz80int:
		mov	eax, [esp+4]	; Get our (potential) lower interrupt address
		cmp	dword [_z80interruptState], 0
		je	alreadyInInt	; Interrupts are disabled

		inc	dword [_z80inInterrupt]	; Set our in-interrupt semaphore
		mov	dword [_z80halted], 0	; We're not halted!

		push	ebp
		push	edi
		push	edx
		mov	ebp, [_z80Base]

		mov	dx, [_z80pc]
		xor	edi, edi
		mov	di, word [_z80sp]
		sub	di, 2
		mov	word [_z80sp], di
		mov	[ebp+edi], dx
		cmp	dword [_z80interruptMode], 2 ; Are we lower than mode 2?
		jb		justModeTwo
		mov	ah, [_z80i]	; Get our high address here
		and	eax, 0ffffh ; Only the lower part
		mov	ax, [eax+ebp] ; Get our vector
		jmp	short setNewVector ; Go set it!
justModeTwo:
		mov	ax, word [_z80intAddr]
setNewVector:
		mov	[_z80pc], ax

		pop	edx
		pop	edi
		pop	ebp

		xor	eax, eax	; Indicate we took the interrupt
		jmp	short z80intExit

alreadyInInt:
		mov	eax, 1		; Indicate we didn't take it

z80intExit:
		ret
		global	_mz80nmi
		global	mz80nmi_

times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

mz80nmi_:
_mz80nmi:
		mov	dword [_z80halted], 0	; We're not halted anymore!
		mov	dword [_z80inInterrupt], 0	; We're not halted anymore!

		push	ebp
		push	edi
		mov	ebp, [_z80Base]

		xor	eax, eax
		mov	ax, [_z80pc]
		xor	edi, edi
		mov	di, word [_z80sp]
		sub	di, 2
		mov	word [_z80sp], di
		mov	[ebp+edi], ax
		mov	ax, [_z80nmiAddr]
		mov	[_z80pc], ax

		pop	edi
		pop	ebp

		xor	eax, eax	; Indicate we took the interrupt
		ret
		global	_mz80exec
		global	mz80exec_

times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

mz80exec_:
_mz80exec:
		mov	eax, [esp+4]	; Get our execution cycle count
		push	ebx			; Save all registers we use
		push	ecx
		push	edx
		push	ebp
		push	esi
		push	edi

		mov	dword [cyclesRemaining], eax	; Store # of instructions to
						; execute
		cmp	dword [_z80halted], 0
		je	goCpu
		mov	eax, dword [cyclesRemaining]
		add	dword [dwElapsedTicks], eax
		mov	dword [cyclesRemaining], 0	; Nothing left!
		mov	eax, 80000000h	; Successful exection
		jmp	popReg
goCpu:
		cld				; Go forward!

		xor	eax, eax		; Zero EAX 'cause we use it!
		xor	ebx, ebx		; Zero EBX, too
		xor	ecx, ecx		; Zero ECX
		xor	edx, edx		; And EDX
		xor	edi, edi		; Zero EDI as well
		xor	esi, esi		; Zero our source address

		mov	ax, [_z80af]		; Accumulator & flags
		xchg	ah, al		; Swap these for later
		mov	bx, [_z80hl]		; Get our HL value
		mov	cx, [_z80bc]		; And our BC value
		mov	ebp, [_z80Base]		; Get the base address
		mov	si, [_z80pc]		; Get our program counter
		add	esi, ebp		; Add in our base address
		mov	dl, [esi]
		inc	esi
		jmp	dword [z80regular+edx*4]

; We get to invalidInsWord if it's a double byte invalid opcode

invalidInsWord:
		dec	esi

; We get to invalidInsByte if it's a single byte invalid opcode

invalidInsByte:
		xchg	ah, al		; Swap them back so they look good
		mov	[_z80af], ax		; Store A & flags
		dec	esi			; Back up one instruction...
		mov	edx, esi		; Get our address in EAX
		sub	edx, ebp		; And subtract our base for
						; an invalid instruction
		jmp	short emulateEnd

noMoreExec2:
		sub	esi, [_baseFixup]
noMoreExec:
		dec	esi
		xchg	ah, al		; Swap these for later
		mov	[_z80af], ax		; Store A & flags
		mov	edx, 80000000h		; Indicate successful exec
		jmp	short emulateEnd	; All finished!

; Now let's tuck away the virtual registers for next time

storeFlags:
		xchg	ah, al		; Swap these for later
		mov	[_z80af], ax		; Store A & flags
emulateEnd:
		mov	[_z80hl], bx		; Store HL
		mov	[_z80bc], cx		; Store BC
		sub	esi, [_z80Base]		; Knock off physical address
		mov	[_z80pc], si		; And store virtual address
		mov	eax, edx		; Result code return

popReg:
		pop	edi			; Restore registers
		pop	esi
		pop	ebp
		pop	edx
		pop	ecx
		pop	ebx

		ret

		end
